/* A Bison parser, made by GNU Bison 3.0.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         parser_parse
#define yylex           parser_lex
#define yyerror         parser_error
#define yydebug         parser_debug
#define yynerrs         parser_nerrs

#define yylval          parser_lval
#define yychar          parser_char

/* Copy the first part of user declarations.  */
#line 1 "tools/widl/parser.y" /* yacc.c:339  */

/*
 * IDL Compiler
 *
 * Copyright 2002 Ove Kaaven
 * Copyright 2006-2008 Robert Shearman
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA
 */

#include "config.h"

#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <assert.h>
#include <ctype.h>
#include <string.h>

#include "widl.h"
#include "utils.h"
#include "parser.h"
#include "header.h"
#include "typelib.h"
#include "typegen.h"
#include "expr.h"
#include "typetree.h"

struct _import_t
{
  char *name;
  int import_performed;
};

static str_list_t *append_str(str_list_t *list, char *str);
static attr_list_t *append_attr_list(attr_list_t *new_list, attr_list_t *old_list);
static decl_spec_t *make_decl_spec(type_t *type, decl_spec_t *left, decl_spec_t *right,
        enum storage_class stgclass, enum type_qualifier qual, enum function_specifier func_specifier);
static attr_t *make_attr(enum attr_type type);
static attr_t *make_attrv(enum attr_type type, unsigned int val);
static attr_t *make_custom_attr(UUID *id, expr_t *pval);
static expr_list_t *append_expr(expr_list_t *list, expr_t *expr);
static var_t *declare_var(attr_list_t *attrs, decl_spec_t *decl_spec, declarator_t *decl, int top);
static var_list_t *set_var_types(attr_list_t *attrs, decl_spec_t *decl_spec, declarator_list_t *decls);
static var_list_t *append_var_list(var_list_t *list, var_list_t *vars);
static declarator_list_t *append_declarator(declarator_list_t *list, declarator_t *p);
static declarator_t *make_declarator(var_t *var);
static type_t *make_safearray(type_t *type);
static typelib_t *make_library(const char *name, const attr_list_t *attrs);
static void append_array(declarator_t *decl, expr_t *expr);
static void append_chain_type(declarator_t *decl, type_t *type, enum type_qualifier qual);
static void append_chain_callconv(type_t *chain, char *callconv);
static warning_list_t *append_warning(warning_list_t *, int);

static type_t *reg_typedefs(decl_spec_t *decl_spec, var_list_t *names, attr_list_t *attrs);
static type_t *find_type_or_error(struct namespace *parent, const char *name);
static struct namespace *find_namespace_or_error(struct namespace *namespace, const char *name);

static var_t *reg_const(var_t *var);

static void push_namespace(const char *name);
static void pop_namespace(const char *name);
static void push_parameters_namespace(const char *name);
static void pop_parameters_namespace(const char *name);

static statement_list_t *append_parameterized_type_stmts(statement_list_t *stmts);
static void check_arg_attrs(const var_t *arg);
static void check_statements(const statement_list_t *stmts, int is_inside_library);
static void check_all_user_types(const statement_list_t *stmts);
static attr_list_t *check_function_attrs(const char *name, attr_list_t *attrs);
static attr_list_t *check_typedef_attrs(attr_list_t *attrs);
static attr_list_t *check_enum_attrs(attr_list_t *attrs);
static attr_list_t *check_enum_member_attrs(attr_list_t *attrs);
static attr_list_t *check_struct_attrs(attr_list_t *attrs);
static attr_list_t *check_union_attrs(attr_list_t *attrs);
static attr_list_t *check_field_attrs(const char *name, attr_list_t *attrs);
static attr_list_t *check_library_attrs(const char *name, attr_list_t *attrs);
const char *get_attr_display_name(enum attr_type type);
static void add_explicit_handle_if_necessary(const type_t *iface, var_t *func);

static void check_async_uuid(type_t *iface);

static statement_t *make_statement(enum statement_type type);
static statement_t *make_statement_type_decl(type_t *type);
static statement_t *make_statement_reference(type_t *type);
static statement_t *make_statement_declaration(var_t *var);
static statement_t *make_statement_library(typelib_t *typelib);
static statement_t *make_statement_pragma(const char *str);
static statement_t *make_statement_cppquote(const char *str);
static statement_t *make_statement_importlib(const char *str);
static statement_t *make_statement_module(type_t *type);
static statement_t *make_statement_typedef(var_list_t *names, int declonly);
static statement_t *make_statement_import(const char *str);
static statement_t *make_statement_parameterized_type(type_t *type, typeref_list_t *params);
static statement_t *make_statement_delegate(type_t *ret, var_list_t *args);
static statement_list_t *append_statement(statement_list_t *list, statement_t *stmt);
static statement_list_t *append_statements(statement_list_t *, statement_list_t *);
static attr_list_t *append_attribs(attr_list_t *, attr_list_t *);

static struct namespace global_namespace = {
    NULL, NULL, LIST_INIT(global_namespace.entry), LIST_INIT(global_namespace.children)
};

static struct namespace *current_namespace = &global_namespace;
static struct namespace *parameters_namespace = NULL;
static statement_list_t *parameterized_type_stmts = NULL;

static typelib_t *current_typelib;


#line 197 "tools/widl/parser.tab.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 1
#endif


/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int parser_debug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    aIDENTIFIER = 258,
    aPRAGMA = 259,
    aKNOWNTYPE = 260,
    aNUM = 261,
    aHEXNUM = 262,
    aDOUBLE = 263,
    aSTRING = 264,
    aWSTRING = 265,
    aSQSTRING = 266,
    aUUID = 267,
    aEOF = 268,
    aACF = 269,
    SHL = 270,
    SHR = 271,
    MEMBERPTR = 272,
    EQUALITY = 273,
    INEQUALITY = 274,
    GREATEREQUAL = 275,
    LESSEQUAL = 276,
    LOGICALOR = 277,
    LOGICALAND = 278,
    ELLIPSIS = 279,
    tACTIVATABLE = 280,
    tAGGREGATABLE = 281,
    tAGILE = 282,
    tALLNODES = 283,
    tALLOCATE = 284,
    tANNOTATION = 285,
    tAPICONTRACT = 286,
    tAPPOBJECT = 287,
    tASYNC = 288,
    tASYNCUUID = 289,
    tAUTOHANDLE = 290,
    tBINDABLE = 291,
    tBOOLEAN = 292,
    tBROADCAST = 293,
    tBYTE = 294,
    tBYTECOUNT = 295,
    tCALLAS = 296,
    tCALLBACK = 297,
    tCASE = 298,
    tCDECL = 299,
    tCHAR = 300,
    tCOCLASS = 301,
    tCODE = 302,
    tCOMMSTATUS = 303,
    tCONST = 304,
    tCONTEXTHANDLE = 305,
    tCONTEXTHANDLENOSERIALIZE = 306,
    tCONTEXTHANDLESERIALIZE = 307,
    tCONTRACT = 308,
    tCONTRACTVERSION = 309,
    tCONTROL = 310,
    tCPPQUOTE = 311,
    tCUSTOM = 312,
    tDECLARE = 313,
    tDECODE = 314,
    tDEFAULT = 315,
    tDEFAULTBIND = 316,
    tDELEGATE = 317,
    tDEFAULTCOLLELEM = 318,
    tDEFAULTVALUE = 319,
    tDEFAULTVTABLE = 320,
    tDISABLECONSISTENCYCHECK = 321,
    tDISPLAYBIND = 322,
    tDISPINTERFACE = 323,
    tDLLNAME = 324,
    tDONTFREE = 325,
    tDOUBLE = 326,
    tDUAL = 327,
    tENABLEALLOCATE = 328,
    tENCODE = 329,
    tENDPOINT = 330,
    tENTRY = 331,
    tENUM = 332,
    tERRORSTATUST = 333,
    tEVENTADD = 334,
    tEVENTREMOVE = 335,
    tEXCLUSIVETO = 336,
    tEXPLICITHANDLE = 337,
    tEXTERN = 338,
    tFALSE = 339,
    tFASTCALL = 340,
    tFAULTSTATUS = 341,
    tFLAGS = 342,
    tFLOAT = 343,
    tFORCEALLOCATE = 344,
    tHANDLE = 345,
    tHANDLET = 346,
    tHELPCONTEXT = 347,
    tHELPFILE = 348,
    tHELPSTRING = 349,
    tHELPSTRINGCONTEXT = 350,
    tHELPSTRINGDLL = 351,
    tHIDDEN = 352,
    tHYPER = 353,
    tID = 354,
    tIDEMPOTENT = 355,
    tIGNORE = 356,
    tIIDIS = 357,
    tIMMEDIATEBIND = 358,
    tIMPLICITHANDLE = 359,
    tIMPORT = 360,
    tIMPORTLIB = 361,
    tIN = 362,
    tIN_LINE = 363,
    tINLINE = 364,
    tINPUTSYNC = 365,
    tINT = 366,
    tINT32 = 367,
    tINT3264 = 368,
    tINT64 = 369,
    tINTERFACE = 370,
    tLCID = 371,
    tLENGTHIS = 372,
    tLIBRARY = 373,
    tLICENSED = 374,
    tLOCAL = 375,
    tLONG = 376,
    tMARSHALINGBEHAVIOR = 377,
    tMAYBE = 378,
    tMESSAGE = 379,
    tMETHODS = 380,
    tMODULE = 381,
    tMTA = 382,
    tNAMESPACE = 383,
    tNOCODE = 384,
    tNONBROWSABLE = 385,
    tNONCREATABLE = 386,
    tNONE = 387,
    tNONEXTENSIBLE = 388,
    tNOTIFY = 389,
    tNOTIFYFLAG = 390,
    tNULL = 391,
    tOBJECT = 392,
    tODL = 393,
    tOLEAUTOMATION = 394,
    tOPTIMIZE = 395,
    tOPTIONAL = 396,
    tOUT = 397,
    tPARTIALIGNORE = 398,
    tPASCAL = 399,
    tPOINTERDEFAULT = 400,
    tPRAGMA_WARNING = 401,
    tPROGID = 402,
    tPROPERTIES = 403,
    tPROPGET = 404,
    tPROPPUT = 405,
    tPROPPUTREF = 406,
    tPROXY = 407,
    tPTR = 408,
    tPUBLIC = 409,
    tRANGE = 410,
    tREADONLY = 411,
    tREF = 412,
    tREGISTER = 413,
    tREPRESENTAS = 414,
    tREQUESTEDIT = 415,
    tREQUIRES = 416,
    tRESTRICTED = 417,
    tRETVAL = 418,
    tRUNTIMECLASS = 419,
    tSAFEARRAY = 420,
    tSHORT = 421,
    tSIGNED = 422,
    tSINGLENODE = 423,
    tSIZEIS = 424,
    tSIZEOF = 425,
    tSMALL = 426,
    tSOURCE = 427,
    tSTANDARD = 428,
    tSTATIC = 429,
    tSTDCALL = 430,
    tSTRICTCONTEXTHANDLE = 431,
    tSTRING = 432,
    tSTRUCT = 433,
    tSWITCH = 434,
    tSWITCHIS = 435,
    tSWITCHTYPE = 436,
    tTHREADING = 437,
    tTRANSMITAS = 438,
    tTRUE = 439,
    tTYPEDEF = 440,
    tUIDEFAULT = 441,
    tUNION = 442,
    tUNIQUE = 443,
    tUNSIGNED = 444,
    tUSESGETLASTERROR = 445,
    tUSERMARSHAL = 446,
    tUUID = 447,
    tV1ENUM = 448,
    tVARARG = 449,
    tVERSION = 450,
    tVIPROGID = 451,
    tVOID = 452,
    tWCHAR = 453,
    tWIREMARSHAL = 454,
    tAPARTMENT = 455,
    tNEUTRAL = 456,
    tSINGLE = 457,
    tFREE = 458,
    tBOTH = 459,
    CAST = 460,
    PPTR = 461,
    POS = 462,
    NEG = 463,
    ADDRESSOF = 464
  };
#endif

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED

union YYSTYPE
{
#line 123 "tools/widl/parser.y" /* yacc.c:355  */

	attr_t *attr;
	attr_list_t *attr_list;
	str_list_t *str_list;
	expr_t *expr;
	expr_list_t *expr_list;
	type_t *type;
	var_t *var;
	var_list_t *var_list;
	declarator_t *declarator;
	declarator_list_t *declarator_list;
	statement_t *statement;
	statement_list_t *stmt_list;
	warning_t *warning;
	warning_list_t *warning_list;
	typeref_t *typeref;
	typeref_list_t *typeref_list;
	char *str;
	UUID *uuid;
	unsigned int num;
	double dbl;
	typelib_t *typelib;
	struct _import_t *import;
	struct _decl_spec_t *declspec;
	enum storage_class stgclass;
	enum type_qualifier type_qualifier;
	enum function_specifier function_specifier;
	struct namespace *namespace;

#line 474 "tools/widl/parser.tab.c" /* yacc.c:355  */
};

typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE parser_lval;

int parser_parse (void);



/* Copy the second part of user declarations.  */

#line 491 "tools/widl/parser.tab.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  3
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   3552

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  234
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  144
/* YYNRULES -- Number of rules.  */
#define YYNRULES  489
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  893

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   464

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   218,     2,     2,     2,   217,   210,     2,
     231,   232,   215,   214,   205,   213,   225,   216,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   207,   228,
     211,   233,   212,   206,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   226,     2,   227,   209,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   229,   208,   230,   219,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     220,   221,   222,   223,   224
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   349,   349,   364,   364,   366,   367,   373,   375,   376,
     380,   382,   383,   383,   385,   386,   387,   388,   389,   392,
     395,   396,   398,   399,   401,   402,   403,   404,   407,   408,
     409,   410,   410,   412,   413,   414,   415,   418,   419,   421,
     422,   424,   425,   426,   427,   428,   431,   432,   435,   436,
     440,   441,   442,   443,   444,   445,   446,   449,   457,   465,
     466,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     481,   483,   491,   497,   501,   503,   507,   511,   512,   515,
     516,   519,   520,   524,   529,   536,   540,   541,   544,   545,
     549,   552,   553,   554,   557,   558,   562,   563,   564,   568,
     569,   572,   578,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     622,   623,   624,   625,   626,   627,   628,   629,   630,   631,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     642,   643,   644,   645,   646,   648,   649,   650,   651,   652,
     653,   654,   655,   656,   657,   658,   659,   660,   661,   662,
     663,   664,   665,   666,   667,   668,   669,   670,   674,   675,
     676,   677,   678,   679,   680,   681,   682,   683,   684,   685,
     686,   687,   688,   689,   690,   691,   692,   693,   694,   695,
     696,   697,   698,   702,   703,   708,   709,   710,   711,   714,
     715,   718,   722,   728,   729,   730,   733,   737,   749,   754,
     758,   763,   766,   767,   770,   771,   774,   775,   776,   777,
     778,   779,   780,   781,   782,   783,   784,   785,   786,   787,
     788,   789,   790,   791,   792,   793,   794,   795,   796,   797,
     798,   799,   800,   801,   802,   803,   804,   805,   806,   807,
     808,   809,   810,   811,   813,   815,   816,   819,   820,   823,
     829,   835,   836,   839,   844,   851,   852,   855,   856,   860,
     861,   864,   868,   874,   882,   886,   891,   892,   895,   896,
     899,   900,   903,   906,   907,   908,   909,   910,   911,   912,
     913,   914,   915,   916,   919,   920,   923,   924,   925,   926,
     927,   928,   929,   930,   931,   935,   936,   940,   941,   944,
     949,   950,   951,   952,   953,   957,   958,   962,   965,   969,
     972,   976,   979,   983,   986,   987,   991,   992,   995,   998,
    1001,  1002,  1005,  1006,  1010,  1012,  1016,  1017,  1018,  1021,
    1025,  1026,  1030,  1031,  1031,  1031,  1035,  1040,  1041,  1039,
    1048,  1049,  1050,  1051,  1053,  1054,  1057,  1057,  1070,  1074,
    1075,  1079,  1082,  1085,  1090,  1091,  1092,  1096,  1100,  1103,
    1104,  1107,  1108,  1112,  1114,  1118,  1119,  1123,  1124,  1125,
    1129,  1131,  1132,  1136,  1137,  1138,  1139,  1144,  1146,  1147,
    1152,  1154,  1158,  1159,  1164,  1165,  1166,  1167,  1171,  1179,
    1181,  1182,  1187,  1189,  1193,  1194,  1201,  1202,  1203,  1204,
    1205,  1209,  1216,  1217,  1220,  1221,  1224,  1231,  1232,  1237,
    1238,  1242,  1243,  1244,  1245,  1246,  1247,  1251,  1252,  1253,
    1256,  1260,  1261,  1262,  1263,  1264,  1265,  1266,  1267,  1268,
    1269,  1273,  1274,  1275,  1278,  1285,  1287,  1293,  1294,  1295,
    1298,  1300,  1303,  1305,  1309,  1316,  1325,  1326,  1330,  1331,
    1335,  1337,  1338,  1339,  1343,  1344,  1349,  1350,  1351,  1352
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 1
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "aIDENTIFIER", "aPRAGMA", "aKNOWNTYPE",
  "aNUM", "aHEXNUM", "aDOUBLE", "aSTRING", "aWSTRING", "aSQSTRING",
  "aUUID", "aEOF", "aACF", "SHL", "SHR", "MEMBERPTR", "EQUALITY",
  "INEQUALITY", "GREATEREQUAL", "LESSEQUAL", "LOGICALOR", "LOGICALAND",
  "ELLIPSIS", "tACTIVATABLE", "tAGGREGATABLE", "tAGILE", "tALLNODES",
  "tALLOCATE", "tANNOTATION", "tAPICONTRACT", "tAPPOBJECT", "tASYNC",
  "tASYNCUUID", "tAUTOHANDLE", "tBINDABLE", "tBOOLEAN", "tBROADCAST",
  "tBYTE", "tBYTECOUNT", "tCALLAS", "tCALLBACK", "tCASE", "tCDECL",
  "tCHAR", "tCOCLASS", "tCODE", "tCOMMSTATUS", "tCONST", "tCONTEXTHANDLE",
  "tCONTEXTHANDLENOSERIALIZE", "tCONTEXTHANDLESERIALIZE", "tCONTRACT",
  "tCONTRACTVERSION", "tCONTROL", "tCPPQUOTE", "tCUSTOM", "tDECLARE",
  "tDECODE", "tDEFAULT", "tDEFAULTBIND", "tDELEGATE", "tDEFAULTCOLLELEM",
  "tDEFAULTVALUE", "tDEFAULTVTABLE", "tDISABLECONSISTENCYCHECK",
  "tDISPLAYBIND", "tDISPINTERFACE", "tDLLNAME", "tDONTFREE", "tDOUBLE",
  "tDUAL", "tENABLEALLOCATE", "tENCODE", "tENDPOINT", "tENTRY", "tENUM",
  "tERRORSTATUST", "tEVENTADD", "tEVENTREMOVE", "tEXCLUSIVETO",
  "tEXPLICITHANDLE", "tEXTERN", "tFALSE", "tFASTCALL", "tFAULTSTATUS",
  "tFLAGS", "tFLOAT", "tFORCEALLOCATE", "tHANDLE", "tHANDLET",
  "tHELPCONTEXT", "tHELPFILE", "tHELPSTRING", "tHELPSTRINGCONTEXT",
  "tHELPSTRINGDLL", "tHIDDEN", "tHYPER", "tID", "tIDEMPOTENT", "tIGNORE",
  "tIIDIS", "tIMMEDIATEBIND", "tIMPLICITHANDLE", "tIMPORT", "tIMPORTLIB",
  "tIN", "tIN_LINE", "tINLINE", "tINPUTSYNC", "tINT", "tINT32", "tINT3264",
  "tINT64", "tINTERFACE", "tLCID", "tLENGTHIS", "tLIBRARY", "tLICENSED",
  "tLOCAL", "tLONG", "tMARSHALINGBEHAVIOR", "tMAYBE", "tMESSAGE",
  "tMETHODS", "tMODULE", "tMTA", "tNAMESPACE", "tNOCODE", "tNONBROWSABLE",
  "tNONCREATABLE", "tNONE", "tNONEXTENSIBLE", "tNOTIFY", "tNOTIFYFLAG",
  "tNULL", "tOBJECT", "tODL", "tOLEAUTOMATION", "tOPTIMIZE", "tOPTIONAL",
  "tOUT", "tPARTIALIGNORE", "tPASCAL", "tPOINTERDEFAULT",
  "tPRAGMA_WARNING", "tPROGID", "tPROPERTIES", "tPROPGET", "tPROPPUT",
  "tPROPPUTREF", "tPROXY", "tPTR", "tPUBLIC", "tRANGE", "tREADONLY",
  "tREF", "tREGISTER", "tREPRESENTAS", "tREQUESTEDIT", "tREQUIRES",
  "tRESTRICTED", "tRETVAL", "tRUNTIMECLASS", "tSAFEARRAY", "tSHORT",
  "tSIGNED", "tSINGLENODE", "tSIZEIS", "tSIZEOF", "tSMALL", "tSOURCE",
  "tSTANDARD", "tSTATIC", "tSTDCALL", "tSTRICTCONTEXTHANDLE", "tSTRING",
  "tSTRUCT", "tSWITCH", "tSWITCHIS", "tSWITCHTYPE", "tTHREADING",
  "tTRANSMITAS", "tTRUE", "tTYPEDEF", "tUIDEFAULT", "tUNION", "tUNIQUE",
  "tUNSIGNED", "tUSESGETLASTERROR", "tUSERMARSHAL", "tUUID", "tV1ENUM",
  "tVARARG", "tVERSION", "tVIPROGID", "tVOID", "tWCHAR", "tWIREMARSHAL",
  "tAPARTMENT", "tNEUTRAL", "tSINGLE", "tFREE", "tBOTH", "','", "'?'",
  "':'", "'|'", "'^'", "'&'", "'<'", "'>'", "'-'", "'+'", "'*'", "'/'",
  "'%'", "'!'", "'~'", "CAST", "PPTR", "POS", "NEG", "ADDRESSOF", "'.'",
  "'['", "']'", "';'", "'{'", "'}'", "'('", "')'", "'='", "$accept",
  "input", "m_acf", "decl_statements", "decl_block", "imp_decl_statements",
  "imp_decl_block", "gbl_statements", "$@1", "imp_statements", "$@2",
  "int_statements", "semicolon_opt", "statement", "pragma_warning",
  "warnings", "typedecl", "cppquote", "import_start", "import",
  "importlib", "libraryhdr", "library_start", "librarydef", "m_args",
  "arg_list", "args", "arg", "array", "m_attributes", "attributes",
  "attrib_list", "str_list", "marshaling_behavior", "contract_ver",
  "contract_req", "static_attr", "attribute", "uuid_string", "callconv",
  "cases", "case", "enums", "enum_list", "enum_member", "enum", "enumdef",
  "m_exprs", "m_expr", "expr", "expr_list_int_const", "expr_int_const",
  "expr_const", "fields", "field", "ne_union_field", "ne_union_fields",
  "union_field", "s_field", "funcdef", "declaration", "m_ident",
  "m_typename", "typename", "ident", "base_type", "m_int", "int_std",
  "namespace_pfx", "qualified_type", "parameterized_type",
  "parameterized_type_arg", "parameterized_type_args", "coclass",
  "coclassdef", "runtimeclass", "runtimeclass_def", "apicontract",
  "apicontract_def", "namespacedef", "class_interfaces", "class_interface",
  "dispinterface", "dispattributes", "dispint_props", "dispint_meths",
  "dispinterfacedef", "inherit", "type_parameter", "type_parameters",
  "interface", "$@3", "$@4", "delegatedef", "$@5", "$@6", "required_types",
  "requires", "interfacedef", "$@7", "interfaceref", "dispinterfaceref",
  "module", "moduledef", "storage_cls_spec", "function_specifier",
  "type_qualifier", "m_type_qual_list", "decl_spec",
  "unqualified_decl_spec", "m_decl_spec_no_type", "decl_spec_no_type",
  "declarator", "direct_declarator", "abstract_declarator",
  "abstract_declarator_no_direct", "m_abstract_declarator",
  "abstract_direct_declarator", "any_declarator",
  "any_declarator_no_direct", "m_any_declarator", "any_direct_declarator",
  "declarator_list", "m_bitfield", "struct_declarator",
  "struct_declarator_list", "init_declarator", "threading_type",
  "pointer_type", "structdef", "unqualified_type", "type", "typedef",
  "uniondef", "version", "acf_statements", "acf_int_statements",
  "acf_int_statement", "acf_interface", "acf_attributes",
  "acf_attribute_list", "acf_attribute", "allocate_option_list",
  "allocate_option", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,    44,    63,    58,   124,    94,
      38,    60,    62,    45,    43,    42,    47,    37,    33,   126,
     460,   461,   462,   463,   464,    46,    91,    93,    59,   123,
     125,    40,    41,    61
};
# endif

#define YYPACT_NINF -642

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-642)))

#define YYTABLE_NINF -477

#define yytable_value_is_error(Yytable_value) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
    -642,   122,  1799,  -642,  -100,  -642,    48,   -34,   283,  -642,
    -642,  -642,   283,  -642,  -117,   -92,   283,  -642,   297,  -642,
    -642,  -642,  -642,    97,   223,  -642,  -642,  -642,  -642,  -642,
     283,    97,   251,    34,  -642,   283,    46,    97,   618,  -642,
    -642,   357,   373,   618,  -642,  -642,  3353,  -642,  -642,  -642,
    -642,    50,  -642,  -642,  -642,  -642,  -642,    15,  2839,    81,
      82,  -642,  -642,  -642,   374,    53,  -642,    96,  -642,   103,
    -642,   136,  -642,    40,   162,   286,   169,   177,  -642,  -642,
    -642,    24,    24,    24,   263,  2979,   185,  -642,    24,   189,
     192,  -642,    77,  -642,   -34,   224,  -642,  -642,  -642,  -642,
     401,  -642,  -642,   -62,   205,  -642,  -642,  -642,   203,   229,
    -642,  -642,    85,  -642,  2979,  -642,  -642,    13,   212,   -89,
    -111,  -642,   213,  -642,   214,  -642,  -642,   218,  -642,  -642,
    -642,   219,   221,  -642,  -642,  -642,  -642,  -642,   227,   228,
    -642,   230,  -642,  -642,  -642,  -642,   231,  -642,  -642,  -642,
     232,  -642,  -642,  -642,   234,   235,  -642,  -642,   236,  -642,
    -642,  -642,  -642,  -642,   237,   239,   240,   241,   242,  -642,
     243,  -642,  -642,   244,  -642,   246,  -642,  -642,   248,   249,
    -642,  -642,   252,  -642,  -642,  -642,  -642,  -642,  -642,  -642,
    -642,  -642,  -642,  -642,   253,  -642,  -642,  -642,   254,   257,
    -642,  -642,  -642,  -642,  -642,  -642,   258,  -642,  -642,   260,
    -642,  -642,  -642,   261,  -642,   264,  -642,  -642,   265,   268,
     269,   270,  -642,  -642,  -642,   272,   274,  -642,  -642,   275,
     276,   277,   -97,  -642,  -642,  -642,  1945,  1159,  2979,   283,
     217,   225,   382,   283,   397,   413,   280,   290,   282,   285,
     293,  -642,   263,   301,   302,  -642,   300,   323,  3027,  -642,
    -642,  -642,  -642,  -642,   307,  -642,  -642,  -642,  -642,  -642,
    -642,  -642,  -642,  -642,  -642,  -642,  -642,   263,   263,  -642,
    -642,   209,    -5,  -642,  -642,  -642,    24,  -642,  -642,  -642,
     306,  -642,  -642,  -642,   -59,  -642,  -642,   455,   308,   -26,
     -74,  -642,  -642,   331,   334,   311,  -642,   315,  -642,  2887,
     541,   104,   283,  1010,  2887,   547,   104,  1010,   550,   551,
    1010,  2887,  1010,   552,   553,  1010,   556,  1010,  1010,  2385,
    1010,  1010,    32,   569,   -53,   571,  1010,  2979,  1010,  2887,
    1010,  2979,   134,  2979,  2979,   104,   216,   572,  2979,  3353,
     356,  -642,   354,   358,  -642,  -642,  -642,  -642,   360,  -642,
     369,  -642,   370,  -642,   355,   371,   372,  -642,  -642,  -642,
     169,   283,  -642,  2887,  -642,  -642,   376,  -642,   376,   -80,
    -642,  -642,  -642,   379,   394,  -642,  -642,  -642,   374,   -21,
     391,  -642,   -24,  -642,    -4,    80,   380,  -642,  1010,   703,
    2385,  -642,  -642,    27,    77,  -642,   381,  -642,   418,  -642,
     283,   383,   410,   352,  -642,   283,   610,   610,  -642,    73,
     217,   131,   386,   414,   399,  -642,  -642,   400,   402,  -642,
    -642,  -642,  -642,  -642,  -642,  -642,  -642,  -642,   392,  -642,
    1010,  1010,  1010,  1010,  1010,  1010,   894,  2623,   -85,  -642,
     403,   404,   405,   434,  2623,   408,   409,  -642,   -79,   411,
     412,   416,   419,   420,   421,   422,   424,  2299,   426,  2887,
     118,   427,   -78,  -642,  2623,  -642,  -642,  -642,   428,   429,
     430,   433,   437,   435,   -77,   439,   445,  2384,   440,  -642,
    -642,  -642,  -642,  -642,  -642,   442,   443,   444,   446,   441,
    -642,   448,   450,   460,  -642,  3353,  -642,   660,  -642,  -642,
    -642,  -642,  -642,  -642,  -642,   -61,   263,  1446,   166,   173,
     169,   418,   516,  -642,  -642,  -642,  3027,  -642,  1375,   480,
     -13,   468,  -642,  -642,  -642,  -642,   917,  -642,  1156,   465,
     493,  -642,  -642,  -642,  -642,  -642,  -642,   -45,  -642,  -642,
     514,   490,  -642,  -642,   182,  1010,  -642,  -642,   498,  -642,
      60,    64,  -642,  2887,  -642,  2887,   473,  -642,   489,  -642,
     491,  -642,   547,  -642,  -642,  -642,  3124,    65,    65,    65,
      65,    65,    65,  -642,  2469,   271,  3195,    24,  1010,  1010,
     705,  1010,  1010,  1010,  1010,  1010,  1010,  1010,  1010,  1010,
    1010,  1010,  1010,  1010,  1010,  1010,  1010,  1010,   715,  1010,
    1010,  -642,  -642,   714,  -642,  1010,  -642,  -642,   712,  -642,
    -642,  -642,  -642,  -642,  -642,  -642,  -642,  -642,  -642,  -642,
     118,  -642,  2037,  -642,   118,  -642,  -642,  -642,    86,  -642,
    1010,  -642,  -642,  -642,  -642,  -642,  1010,  -642,  -642,  -642,
    2887,  -642,  -642,  -642,  -642,  -642,  -642,   716,  -642,  -642,
    -642,  -642,   -23,   492,  -642,  -642,  2385,  -642,   518,   169,
    -642,   542,  2887,   169,    23,  -642,   169,  -642,    53,  -642,
     418,   497,  -642,  -642,  -642,   521,   505,  1653,   504,  -642,
    -642,  -642,  2254,    27,  -642,   509,   506,   514,  3027,  -642,
    -642,   283,   525,  -642,  -642,  -642,   118,   510,   263,    -3,
     283,  -642,  -642,  -642,   271,  -642,  -642,  2183,  -642,   271,
    -642,   508,   124,    24,  -642,   211,   211,  -642,   605,   605,
     378,   378,  2550,  2642,  2602,   158,  1494,  2649,   378,   378,
     126,   126,    65,    65,    65,  -642,  2517,  -642,  -642,   511,
    -642,  -642,   114,  -642,   512,   118,   513,  -642,  2385,  -642,
    -642,   515,  -642,  -642,   418,  -642,   169,  1230,   283,   522,
     263,  -642,  -642,   283,   418,   520,   527,  -642,    53,  -642,
     536,  -642,  -642,  -642,  -642,  2887,   529,  -642,  -642,  -642,
    -642,  -642,   737,  -642,  -642,   -19,  -642,  -642,   543,  -642,
     -96,  -642,  -642,   524,  -642,   526,   337,  -642,   528,   118,
     531,  -642,  1010,  2385,  -642,  -642,  1010,  -642,  -642,  -642,
     114,  -642,  -642,  -642,   534,  -642,   548,  -642,  -642,    92,
     169,  -642,  -642,  -642,   374,  -642,  -642,   418,  1582,  -642,
     533,   544,  1010,  -642,   118,  -642,  -642,  -642,  -642,   114,
    -642,  -642,  -642,    65,   537,  2623,  -642,  -642,  3027,   539,
    -642,  -642,    53,  -642,   169,  -642,  -642,  -642,  -642,    33,
    -642,  -642,    93,  2385,  -642,  1010,   564,  -642,  -642,   545,
     554,   568,   204,  -642,  -642,   204,  -642,  -642,   549,   169,
    -642,  -642,  -642
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
      11,     0,    88,     1,   300,    55,   460,   470,     0,   311,
     303,   322,     0,   388,     0,     0,     0,   310,   298,   312,
     384,   309,   313,   314,     0,   387,   316,   323,   324,   321,
       0,   314,     0,     0,   386,     0,     0,   314,     0,   318,
     385,   298,   298,   308,   451,   304,   103,     2,    27,    26,
      56,     0,    50,    28,    53,    28,    25,     0,    89,   453,
       0,   327,   452,   305,     0,     0,   463,     0,    19,     0,
      23,     0,    21,     0,     0,     0,    48,     0,    17,    16,
      24,   395,   395,   395,     0,     0,   455,   461,   395,     0,
     457,   325,     0,     4,   470,     0,   300,   301,   341,   337,
       0,     5,   348,   454,     0,   299,   315,   320,     0,   362,
     319,   343,     0,   339,     0,   317,   306,   456,     0,   458,
       0,   307,     0,   105,     0,   107,   108,     0,   109,   110,
     111,     0,     0,   114,   115,   116,   117,   118,     0,     0,
     121,     0,   123,   124,   125,   126,     0,   128,   129,   130,
       0,   132,   133,   134,     0,     0,   137,   138,     0,   140,
     141,   142,   143,   144,     0,     0,     0,     0,     0,   150,
       0,   152,   153,     0,   155,     0,   157,   158,   161,     0,
     162,   163,     0,   165,   166,   167,   168,   169,   170,   171,
     172,   173,   174,   175,     0,   177,   178,   179,     0,     0,
     182,   183,   184,   185,   449,   186,     0,   188,   447,     0,
     190,   191,   192,     0,   194,     0,   196,   197,     0,     0,
       0,     0,   202,   448,   203,     0,     0,   207,   208,     0,
       0,     0,     0,    91,   212,    51,    88,    88,     0,     0,
      88,     0,   298,     0,   298,   298,     0,   453,     0,     0,
       0,   376,     0,   455,   457,    52,   300,   462,     0,    18,
      22,    20,    12,    15,     0,    49,   378,    14,   399,   396,
     398,   397,   215,   216,   217,   218,   389,     0,     0,   302,
     403,   439,   402,   295,   453,   455,   395,   457,   391,    54,
       0,   482,   481,   483,     0,   478,   471,     0,     0,     0,
      88,    71,   363,     0,     0,     0,   281,     0,   287,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   234,     0,     0,     0,     0,     0,     0,   234,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   103,
      90,    72,     0,     0,    45,    42,    43,    44,     0,    36,
       0,    40,     0,    38,     0,     0,     0,    34,    33,    41,
      48,     0,   382,     0,    89,    46,   454,    74,   456,   458,
      75,   344,   344,     0,   356,   294,   326,   330,     0,   331,
     333,   335,     0,    11,     0,     0,     0,   401,     0,     0,
      77,   405,   392,     0,     0,   477,     0,    70,     0,     7,
       0,     0,   225,   230,   226,     0,     0,     0,   459,    88,
      88,    88,     0,     0,     0,   214,   213,     0,     0,   245,
     236,   237,   238,   242,   243,   244,   239,   240,     0,   241,
       0,     0,     0,     0,     0,     0,     0,   279,     0,   277,
       0,    99,     0,     0,   280,     0,     0,    94,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     424,     0,     0,   232,   235,    96,    97,    98,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   446,
     441,   442,   443,   444,   445,     0,     0,     0,     0,   467,
     469,     0,     0,     0,    92,   103,     8,     0,    35,    39,
      37,    31,    30,    29,    76,     0,     0,    88,    88,    88,
      48,     0,   374,   328,   332,   334,     0,   329,    88,     0,
      88,     0,   390,   400,   404,   440,     0,    87,     0,     0,
      81,    78,    79,   488,   486,   489,   487,     0,   484,   479,
     472,     0,   228,   231,    88,     0,   359,   360,   364,    59,
       0,     0,   450,     0,   282,     0,     0,   465,    89,   288,
       0,   104,     0,   106,   206,   112,     0,   269,   268,   267,
     270,   265,   266,   460,     0,   412,     0,   395,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   113,   119,     0,   120,     0,   127,   131,     0,   135,
     136,   139,   145,   146,   147,   148,   149,   151,   154,   156,
     424,   389,    77,   429,   424,   426,   425,    84,   421,   160,
     234,   159,   164,   176,   180,   181,     0,   189,   193,   195,
       0,   198,   199,   201,   200,   204,   205,     0,   209,   210,
     211,    93,     0,     0,    28,   367,    77,   432,   464,    48,
      47,     0,    89,    48,     0,   345,    48,   342,   357,   358,
       0,     0,   336,    13,   350,     0,     0,     0,     0,    86,
      85,   406,     0,     0,   480,   476,     0,   472,     0,   227,
     229,     0,     0,    60,    57,    58,     0,   457,     0,   455,
     296,   286,   285,   101,   412,   276,   389,    77,   416,   412,
     413,     0,   409,   395,   393,   258,   259,   271,   252,   253,
     256,   257,   247,   248,     0,   249,   250,   251,   255,   254,
     261,   260,   263,   264,   262,   272,     0,   278,   100,     0,
      95,    83,   424,   389,     0,   424,     0,   420,    77,   428,
     233,     0,   102,   468,     0,    10,    48,    88,     0,     0,
       0,   383,   338,     0,     0,     0,     0,   340,   370,   371,
     375,    46,   352,   351,   354,     0,     0,   293,   355,    82,
      80,   485,     0,   475,   473,     0,   361,   365,   434,   437,
       0,   284,   291,     0,   297,     0,   412,   389,     0,   424,
       0,   408,     0,    77,   415,   394,     0,   275,   122,   419,
     424,   430,   423,   427,     0,   187,     0,    73,    32,     0,
      48,   433,   381,   379,     0,   346,   347,     0,    88,   353,
       0,     0,     0,   436,     0,   283,   219,   274,   407,   424,
     417,   411,   414,   273,     0,   246,   422,   431,     0,     0,
     366,   380,   372,   373,    48,   474,     6,   435,   438,     0,
     410,   418,     0,    77,   377,     0,     0,   466,   220,     0,
       0,     0,    88,     9,   368,    88,   290,   222,     0,    48,
     221,   289,   369
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -642,  -642,  -642,  -642,  -642,  -642,  -642,   387,  -642,   -50,
    -642,     1,  -310,    -1,  -642,   359,  -642,  -642,  -642,  -642,
    -642,  -642,  -642,    30,  -586,  -642,  -642,  -278,  -232,  -236,
      -2,  -642,  -642,  -642,   207,  -262,  -642,  -293,  -211,   -81,
    -642,  -642,  -642,  -642,  -642,   247,    16,   447,   148,   353,
    -642,  -288,  -295,  -642,  -642,  -642,  -642,   -95,  -319,  -642,
     113,  -642,    12,    -6,   -63,  -250,   111,   202,  -251,  -247,
    -241,   278,  -641,    21,    36,    28,    38,    29,    39,    41,
     423,  -642,    20,  -642,  -642,  -642,  -642,  -642,    90,    42,
      17,  -642,  -642,    43,  -642,  -642,  -642,  -642,    45,  -642,
    -642,  -642,  -642,    47,  -642,  -642,  -351,  -547,     7,   226,
     -68,   -55,  -215,  -642,  -642,  -642,  -604,  -642,  -635,  -642,
    -536,  -642,  -642,  -642,   -38,  -642,   555,  -642,   474,    11,
    -385,   -18,  -642,    14,  -642,   718,   112,  -642,  -642,   120,
    -642,   425,  -642,   130
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     1,    47,   299,    48,   662,   354,     2,   393,   236,
     664,   517,   266,   355,    50,   560,    51,    52,    53,    54,
     356,   246,    55,   357,   539,   540,   541,   542,   633,    57,
     374,   232,   458,   478,   452,   422,   485,   233,   427,   634,
     869,   878,   411,   412,   413,   414,   284,   472,   473,   447,
     448,   449,   455,   419,   564,   569,   421,   887,   888,   786,
      60,   803,   104,    61,   635,    62,   107,    63,    64,    65,
      66,   391,   392,   358,   359,   360,   361,   362,   363,   364,
     518,   675,   365,    75,   530,   687,    76,   522,   557,   558,
     366,   415,   702,   367,   768,   889,   780,   681,   368,   384,
     775,   776,   241,   369,    81,    82,    83,   395,   470,   585,
     268,    85,   281,   282,   720,   810,   721,   722,   636,   756,
     637,   638,   668,   843,   799,   800,   283,   495,   234,   285,
      87,    88,    89,   287,   501,    93,   696,   697,    94,    95,
     294,   295,   547,   548
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      58,    49,    98,   278,   373,   237,    99,   388,   387,    84,
     102,   389,   105,    86,   270,   271,    90,   390,    59,    77,
     288,   280,    74,    67,   109,   459,   269,   269,   269,   113,
      69,    71,    56,   269,   461,   105,   105,   464,    68,   466,
      70,    72,   471,    73,   532,    78,   754,    79,   482,    80,
     401,   468,   450,   118,   120,   543,   504,   795,   257,   475,
     514,   587,   396,   397,   410,   252,   703,   286,   307,   253,
     703,   798,   254,    13,   247,   251,   875,   238,   279,   248,
     769,  -476,   590,    96,   752,    97,   249,   250,   303,   408,
    -300,   773,   764,   876,   751,   264,   305,   544,   757,  -300,
     204,   566,   570,   535,   208,   453,   290,    20,   349,   844,
     805,    30,   685,   425,   100,   811,   426,    96,   308,    97,
     610,    96,     3,    97,   272,    91,   618,   640,   640,    13,
     350,   808,   845,    25,   498,   223,   291,   101,   774,   -66,
    -300,   239,   110,   590,   529,   304,   404,   611,   115,  -300,
     665,   292,    46,   619,   641,   648,  -223,   388,   272,   293,
     693,   551,   272,    13,   476,   273,   -62,  -300,   405,   806,
     666,   278,   824,   588,   589,   590,   591,   592,   593,   594,
     533,   526,    34,   563,   565,   565,   526,   694,   527,   280,
     258,   587,    92,   841,   524,   545,   278,   278,    40,   273,
     240,   723,   848,   273,   409,   477,   820,   765,   106,   798,
     677,   686,   661,    46,   280,   280,   819,   872,   402,   822,
     371,   399,   499,   500,   274,  -292,   400,   854,   590,  -292,
     546,   269,   108,   372,    58,    58,   105,   377,   105,   105,
     116,   -64,  -300,    84,    84,   121,   279,    86,    86,   428,
      90,    90,    59,    59,   111,   275,   118,   120,   274,  -301,
     849,   489,   274,   877,   258,   112,    96,   700,    97,   262,
     388,   279,   279,   851,   678,   388,   387,   114,   235,   389,
     679,   671,   674,   674,   856,   390,    96,   880,    97,   275,
     608,   609,   704,   275,   565,   276,   705,   701,   526,    46,
     103,   667,    97,   562,   859,   879,   279,   272,   515,   -61,
     255,   277,   399,   870,   278,   272,   423,   758,   410,   483,
     749,   423,   747,   488,   259,   496,   497,   469,   460,   631,
     503,   260,   280,   631,   490,   491,   492,   493,   494,   297,
     399,   605,   606,   607,   399,   632,   486,   552,   273,   632,
     399,   608,   609,   718,    16,   813,   273,    46,   761,   771,
     117,   567,    97,   772,   261,   279,   777,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   119,   256,    97,    97,
     516,   272,   523,   608,   609,   376,    13,    97,   762,   279,
     263,   586,    46,   588,   589,   590,   673,   265,   469,    46,
     378,   532,    97,   676,   279,   267,   759,   274,    46,   556,
     298,   531,  -224,   -63,   790,   274,   379,   289,    97,   568,
     -65,     4,   273,    97,   603,   604,   605,   606,   607,   388,
      46,   301,   886,   778,   300,   278,   608,   609,   275,   779,
     302,   306,   398,    46,   309,   310,   275,   388,   387,   311,
     312,   389,   313,   280,   375,   532,   827,   390,   314,   315,
     406,   316,   317,   318,   279,   319,   320,   321,   322,   532,
     323,   324,   325,   326,   327,   328,   630,   329,   276,   330,
     331,   274,   718,   332,   333,   334,   716,   718,   335,   336,
     814,   337,   338,   802,   277,   339,   340,   399,   532,   341,
     342,   343,   717,   344,   719,   345,   346,   347,   348,   380,
     279,   381,   275,   388,   382,   672,   670,   826,   -67,   724,
     860,   586,   383,   834,    84,   386,    58,    49,    86,   -68,
     -69,    90,   269,    59,  -328,    84,   394,   403,   416,    86,
     407,   417,    90,   418,    59,    77,   420,   867,    74,    67,
     424,   755,   716,   451,   874,   831,    69,    71,    56,   456,
     457,   462,   463,   399,    68,   465,    70,    72,   717,    73,
     706,    78,   708,    79,   718,    80,   709,   707,   479,   892,
     481,   502,   505,   506,   511,   555,   388,   881,   508,   507,
     862,   603,   604,   605,   606,   607,   863,   509,   510,   512,
     513,   521,   671,   608,   609,  -300,   525,   388,   387,   520,
     550,   389,   534,   553,   767,   554,   559,   390,   571,   572,
     588,   589,   590,   576,   279,   593,   594,   278,   279,   613,
     469,   573,   574,   719,   575,   612,   809,   614,   719,   615,
     616,   617,   646,   620,   621,   280,   565,   804,   622,   565,
     650,   623,   624,   625,   626,   815,   627,   423,   629,   639,
     642,   643,   644,    11,   469,   645,   657,   647,   269,   663,
     454,   649,   652,   454,   653,   654,   655,   680,   656,   252,
     658,   467,   659,   253,   474,   785,   254,   684,   247,   278,
     469,   474,   660,   487,    84,   556,   688,   691,   692,   695,
     279,   698,   279,   701,   279,   710,   429,   280,   727,   430,
     431,   432,   433,   434,   435,   469,    23,   711,   745,   712,
     748,   750,   763,   770,   766,   719,   781,   240,   782,    26,
      27,    28,    29,   783,   788,    92,   793,   797,   801,    31,
     812,   837,   840,   818,   821,   823,   279,   825,   835,   279,
     842,   454,   538,   846,   830,   836,   469,   839,   847,   858,
     850,   865,   556,   852,   279,    58,   857,   832,   833,   871,
     873,   882,   866,   883,    84,   885,   561,   891,    86,   713,
     528,    90,   838,    59,    37,   484,   884,   436,   760,    39,
     890,   796,   252,   577,   578,   579,   580,   581,   582,   584,
     787,   699,   714,   279,   682,   519,   868,   385,   480,   794,
     829,   469,   296,     0,   279,   792,   601,   602,   603,   604,
     605,   606,   607,   791,     0,     0,     0,     0,   861,   549,
     608,   609,     0,     0,     0,     0,   672,   670,   279,   437,
       0,     0,     0,   279,     0,    84,     0,     0,     0,    86,
       0,     0,    90,     0,    59,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   469,     0,   438,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   439,     0,   580,
       0,     0,     0,     0,     0,     0,     0,   429,     0,   583,
     430,   431,   432,   433,   434,   435,     0,     0,     0,     0,
       0,     0,     0,   440,     0,     0,   441,   442,   536,     0,
     429,   444,   445,   430,   431,   432,   433,   434,   435,     0,
     537,     9,     0,    10,   446,     0,     0,     0,     0,    11,
       0,   725,   726,    13,   728,   729,   730,   731,   732,   733,
     734,   735,   736,   737,   738,   739,   740,   741,   742,   743,
     744,     0,   746,     0,     0,    17,     0,     0,   454,     0,
       0,   242,    19,     0,     0,     0,     0,    20,   436,     0,
       0,     0,    21,     0,     0,    22,     0,     0,     0,     0,
       0,     0,    23,   474,     0,     0,     0,     0,     0,     0,
       0,   436,     0,    25,     0,    26,    27,    28,    29,     0,
       0,     0,     0,   429,     0,    31,   430,   431,   432,   433,
     434,   435,     0,     0,     0,     0,     0,     0,     0,     0,
     437,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    34,   437,     0,     0,     0,     0,     0,    36,
      37,    38,     0,     0,   438,    39,     0,     0,    40,     0,
       0,     0,   244,     0,     0,     0,     0,     0,   439,     0,
       0,   245,     0,    43,     0,     0,     0,   438,     0,     0,
       0,    44,    45,     0,   436,     0,     0,     0,     0,     0,
       0,   439,     0,     0,   440,     0,     0,   441,   442,   443,
       0,     0,   444,   445,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   446,     0,   440,     0,     0,
     441,   442,   443,     0,     0,   444,   445,     0,     0,     0,
       0,     0,     0,     0,   689,     0,   437,     0,   446,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     4,     5,     6,   853,     0,     0,     0,   855,
       0,   588,   589,   590,   591,   592,   593,   594,   595,   596,
     438,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       8,     0,     0,     0,   439,   454,     9,     0,    10,     0,
       0,     0,     0,     0,    11,    12,     0,     0,    13,     0,
       0,     0,     0,     0,     0,    14,     0,   352,     0,     0,
     440,     0,     0,   441,   442,   443,     0,    16,   444,   445,
      17,     0,     0,     4,     5,     6,    18,    19,     0,     0,
       0,   446,    20,     0,     0,     0,     0,    21,     0,     0,
      22,     0,     0,     0,     0,     0,     0,    23,     0,     0,
       0,     8,     0,     0,    24,   353,     0,     9,    25,    10,
      26,    27,    28,    29,    30,    11,    12,     0,     0,    13,
      31,     0,     0,     0,     0,     0,    14,    32,   352,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    16,     0,
       0,    17,     0,     0,     0,    33,     0,    18,    19,     0,
       0,     0,     0,    20,     0,     0,     0,    34,    21,     0,
       0,    22,     0,    35,    36,    37,    38,     0,    23,     0,
      39,     0,     0,    40,     0,    24,   353,    41,     0,    25,
       0,    26,    27,    28,    29,    30,    42,     0,    43,     0,
       0,    31,     0,     0,     0,     0,    44,    45,    32,     0,
       0,     0,   597,     0,   598,   599,   600,   601,   602,   603,
     604,   605,   606,   607,     0,     0,    33,     0,     4,     5,
       6,   608,   609,   690,     0,    46,     0,     0,    34,   370,
       0,     0,     0,     0,    35,    36,    37,    38,     0,     0,
       0,    39,     0,     0,    40,     0,     8,     0,    41,     0,
       0,     0,     9,     0,    10,     0,     0,    42,     0,    43,
      11,    12,     0,     0,    13,     0,     0,    44,    45,     0,
       0,    14,     0,    15,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    16,     0,     0,    17,     0,     0,     4,
       5,     6,    18,    19,     0,     0,    46,     0,    20,     0,
     828,     0,     0,    21,     0,     0,    22,     0,     0,     0,
       0,     0,     0,    23,     0,     0,     0,     0,     0,     0,
      24,     0,     0,     9,    25,    10,    26,    27,    28,    29,
      30,    11,     0,     0,     0,    13,    31,     0,     0,     0,
       0,     0,    14,    32,     0,     0,     0,     0,     0,   588,
     589,   590,   591,   592,   593,   594,     0,    17,     0,     0,
       0,    33,     0,    18,    19,     0,     0,     0,     0,    20,
       0,     0,     0,    34,    21,     0,     0,    22,     0,    35,
      36,    37,    38,     0,    23,     0,    39,     0,     0,    40,
       0,    24,     0,    41,     0,    25,     0,    26,    27,    28,
      29,     0,    42,     0,    43,     0,     0,    31,     0,     0,
       0,     0,    44,    45,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     4,     5,     6,     0,     0,
       0,     0,    33,     0,     0,     0,     0,     0,     0,     0,
       0,    46,     0,     0,    34,   683,     0,     0,     0,     0,
       0,    36,    37,    38,     0,     0,     0,    39,     0,     9,
      40,    10,     0,     0,    41,     0,     0,    11,     0,     0,
       0,    13,     0,    42,     0,    43,     0,     0,    14,     0,
       0,     0,     0,    44,    45,     0,     0,     0,     0,     0,
       0,     0,     0,    17,     0,     0,     4,     0,     6,    18,
      19,     0,     0,     0,     0,    20,     0,     0,     0,     0,
      21,     0,    46,    22,     0,     0,   669,     0,     0,     0,
      23,     0,     0,     0,     0,     0,     0,    24,     0,     0,
       9,    25,    10,    26,    27,    28,    29,     0,    11,     0,
       0,     0,    13,    31,   600,   601,   602,   603,   604,   605,
     606,   607,     0,     0,     0,     0,     0,     0,     0,   608,
     609,     0,     0,     0,    17,     0,     0,     0,    33,     0,
     242,    19,     0,     0,     0,     0,    20,     0,     0,     0,
      34,    21,     0,     0,    22,     0,     0,    36,    37,    38,
       0,    23,     0,    39,     0,     0,    40,     0,     0,     0,
      41,     0,    25,     0,    26,    27,    28,    29,     0,    42,
       0,    43,     0,     0,    31,     0,     0,     0,     0,    44,
      45,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    -3,
       0,     0,     4,     5,     6,     0,     0,     0,    46,     0,
       0,    34,   864,     7,     0,     0,     0,     0,    36,    37,
      38,     0,     0,     0,    39,     0,     0,    40,     0,     0,
       8,   244,     0,     0,     0,     0,     9,     0,    10,     0,
     245,     0,    43,     0,    11,    12,     0,     0,    13,     0,
      44,    45,     0,     0,     0,    14,     0,    15,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    16,     0,     0,
      17,     0,     0,     0,     0,     0,    18,    19,     0,    46,
       0,     0,    20,   784,     0,     0,     0,    21,     0,     0,
      22,     0,     0,     0,     0,     0,     0,    23,     0,     0,
       0,     0,     0,     0,    24,     0,     0,     0,    25,     0,
      26,    27,    28,    29,    30,     0,     0,     0,     0,     0,
      31,     0,     0,     0,     0,     0,     0,    32,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    33,     0,     0,     4,     5,
       6,     0,     0,     0,     0,     0,     0,    34,   351,     0,
       0,     0,     0,    35,    36,    37,    38,     0,     0,     0,
      39,     0,     0,    40,     0,     0,     8,    41,     0,     0,
       0,     0,     9,     0,    10,     0,    42,     0,    43,     0,
      11,    12,     0,     0,    13,     0,    44,    45,     0,     0,
       0,    14,     0,   352,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    16,     0,     0,    17,     0,     0,     0,
       0,     0,    18,    19,     0,    46,     0,     0,    20,     0,
       0,     0,     0,    21,     0,     0,    22,     0,     0,     0,
       4,     0,     6,    23,     0,     0,     0,     0,     0,     0,
      24,   353,     0,     0,    25,     0,    26,    27,    28,    29,
      30,     0,     0,     0,     0,     0,    31,     0,     0,     0,
       0,     0,     0,    32,     9,     0,    10,     0,     0,     0,
       0,   272,    11,     0,     0,     0,    13,     0,     0,     0,
       0,    33,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    34,     0,     0,     0,     0,    17,    35,
      36,    37,    38,     0,   242,    19,    39,     0,     0,    40,
      20,     0,   273,    41,     0,    21,     0,     0,    22,     0,
       0,     0,    42,     0,    43,    23,     0,     0,     0,     0,
       0,     0,    44,    45,     0,     0,    25,     0,    26,    27,
      28,    29,     0,     0,     0,     0,     0,     0,    31,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    46,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   274,     0,     0,     0,     0,     4,     0,     6,     0,
       0,     0,     0,     0,     0,    34,     0,     0,     0,     0,
       0,     0,    36,    37,    38,     0,     0,     0,    39,     0,
       0,    40,   275,     0,     0,   244,     0,     0,     0,     0,
       9,     0,    10,     0,   245,     0,    43,   272,    11,     0,
       0,     0,    13,     0,    44,    45,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   753,     0,    17,     0,     0,     4,     0,     6,
     242,    19,     0,    46,     0,     0,    20,     0,   273,     0,
       0,    21,     0,     0,    22,     0,     0,     0,   789,     0,
       0,    23,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     9,    25,    10,    26,    27,    28,    29,     0,    11,
       0,     0,     0,    13,    31,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   588,   589,   590,   591,   592,   593,
     594,   595,   596,     0,     0,    17,     0,   274,     0,     0,
       0,   242,    19,     0,     0,     0,     0,    20,     0,     0,
       0,    34,    21,     0,     0,    22,     0,     0,    36,    37,
      38,     0,    23,     0,    39,     0,     0,    40,   275,     0,
       0,   244,     0,    25,     0,    26,    27,    28,    29,     0,
     245,     0,    43,     0,     0,    31,     0,     0,     0,     0,
      44,    45,     0,     0,     0,     0,     0,     0,     4,     0,
       6,     0,     0,     0,     0,     0,     0,     0,   807,   588,
     589,   590,   591,   592,   593,   594,   595,   596,     0,    46,
       0,     0,    34,     0,     0,     0,     0,     0,     0,    36,
      37,    38,     9,     0,    10,    39,     0,     0,    40,     0,
      11,     0,   244,     0,    13,     0,     0,     0,     0,     0,
       0,   245,     0,    43,     0,     0,     0,     0,     0,     0,
       0,    44,    45,     0,     0,     0,    17,     0,     0,     0,
       0,     0,   242,    19,     0,     0,     0,     0,    20,     0,
       0,     0,     0,    21,     0,     0,    22,     0,     0,     0,
      46,     0,     0,    23,   588,   589,   590,   591,   592,   593,
     594,   595,   596,     0,    25,     0,    26,    27,    28,    29,
       0,     0,     0,     0,     0,   597,    31,   598,   599,   600,
     601,   602,   603,   604,   605,   606,   607,     0,     0,     0,
       0,     0,     0,     0,   608,   609,     0,     0,     0,     0,
       0,   628,   588,   589,   590,   591,   592,   593,   594,   595,
     596,     0,     0,    34,     0,     0,     0,     0,     0,     0,
      36,    37,    38,     0,     0,     0,    39,     0,     0,    40,
       0,     0,     0,   244,     0,   588,   589,   590,   591,   592,
     593,   594,   245,   596,    43,     0,     0,     0,     0,     0,
       0,     0,    44,    45,     0,     0,     0,     0,     0,     0,
     597,     0,   598,   599,   600,   601,   602,   603,   604,   605,
     606,   607,     0,     0,     0,     0,     0,     0,     0,   608,
     609,    46,     0,     0,     0,     0,   651,   588,   589,   590,
     591,   592,   593,   594,   595,   596,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   588,   589,
     590,   591,   592,   593,   594,   595,   596,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   588,   589,   590,
     591,   592,   593,   594,   588,   589,   590,   591,   592,   593,
     594,     0,     0,     0,     0,   597,     0,   598,   599,   600,
     601,   602,   603,   604,   605,   606,   607,     0,     0,     0,
       0,     0,     0,     0,   608,   609,     0,     0,     0,     0,
       0,   715,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   597,     0,   598,   599,   600,   601,   602,
     603,   604,   605,   606,   607,     0,     0,     0,     0,     0,
       0,     0,   608,   609,   817,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,     0,     0,
       0,     0,     0,     0,     0,   608,   609,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   597,   816,
     598,   599,   600,   601,   602,   603,   604,   605,   606,   607,
       0,     0,     0,     0,     0,     0,     0,   608,   609,   597,
       0,   598,   599,   600,   601,   602,   603,   604,   605,   606,
     607,     0,     4,     0,     6,     0,     0,     0,   608,   609,
     598,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     601,   602,   603,   604,   605,   606,   607,   608,   609,     0,
       8,     0,     0,     0,   608,   609,     9,     0,    10,     0,
       0,     0,     0,     0,    11,    12,     0,     0,    13,     0,
       4,     0,     6,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  -349,     0,     0,
      17,     0,     0,     0,     0,     0,   242,    19,     0,     0,
       0,     0,    20,     0,     9,     0,    10,    21,     0,     0,
      22,     0,    11,     0,     0,     0,    13,    23,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    25,     0,
      26,    27,    28,    29,    30,     0,     0,   243,    17,     0,
      31,     0,     0,     0,   242,    19,     0,     0,     0,     0,
      20,     0,     0,     0,     0,    21,     0,     0,    22,     0,
       0,     0,     4,     0,     6,    23,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    25,    34,    26,    27,
      28,    29,     0,    35,    36,    37,    38,     0,    31,     0,
      39,     0,     0,    40,     0,     0,     9,   244,    10,     0,
       0,     0,     0,     0,    11,     0,   245,     0,    43,     0,
       4,     0,    97,     0,     0,     0,    44,    45,     0,     0,
       0,     0,     0,     0,     0,    34,     0,     0,     0,     0,
      17,     0,    36,    37,    38,     0,   242,    19,    39,     0,
       0,    40,     0,     0,     9,   244,    10,    21,     0,     0,
      22,     0,    11,     0,   245,     0,    43,    23,     0,     0,
       0,     0,     0,     0,    44,    45,     0,     0,     0,     0,
      26,    27,    28,    29,     0,     0,     0,     0,    17,     0,
      31,     0,     0,     0,     0,    19,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    21,     0,     0,    22,     0,
       0,     0,     0,     0,     0,    23,     0,     0,     0,   583,
       0,     0,     0,     0,     0,     0,     0,     0,    26,    27,
      28,    29,     0,     0,    36,    37,    38,     0,    31,     0,
      39,     0,     0,     0,     0,     0,     0,   244,     0,     0,
       0,     9,     0,    10,     0,     0,   245,     0,    43,    11,
       0,     0,     0,    13,     0,     0,    44,    45,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    37,    38,    17,     0,     0,    39,     0,
     583,   242,    19,     0,     0,     0,     0,    20,     0,     0,
       0,     0,    21,     0,     0,    22,    43,     0,     0,     0,
       0,     0,    23,     0,     0,    45,     0,     0,     0,     0,
       0,     0,     9,    25,    10,    26,    27,    28,    29,     0,
      11,     0,     0,     0,     0,    31,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    17,     0,     0,     0,
       0,     0,   242,    19,     0,     0,     0,     0,     0,     0,
       0,     0,    34,    21,     0,     0,    22,     0,     0,    36,
      37,    38,     0,    23,     0,    39,     0,     0,    40,     0,
       0,     0,   244,     0,     0,     0,    26,    27,    28,    29,
       0,   245,     0,    43,     0,     0,    31,     0,     0,     0,
       0,    44,    45,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      36,    37,    38,     0,     0,     0,    39,     0,     0,     0,
       0,     0,     0,   244,     0,     0,     0,     0,   122,   123,
       0,     0,   245,   124,    43,   125,   126,   127,   128,   129,
       0,   130,    44,    45,   131,     0,   132,     0,     0,     0,
     133,   134,     0,   135,   136,   137,   138,   139,   140,     0,
     141,     0,   142,   143,   144,     0,   145,   146,   147,   148,
     149,     0,   150,     0,     0,   151,   152,   153,   154,   155,
       0,     0,   156,   157,   158,   159,     0,     0,     0,   160,
     161,     0,   162,   163,     0,   164,   165,   166,   167,   168,
     169,     0,   170,   171,   172,   173,   174,   175,     0,     0,
     176,     0,     0,   177,     0,     0,     0,     0,     0,   178,
     179,     0,   180,   181,     0,   182,   183,   184,     0,     0,
       0,     0,   185,   186,   187,     0,   188,   189,   190,     0,
     191,   192,   193,   194,   195,   196,   197,     0,   198,     0,
     199,     0,   200,   201,   202,   203,   204,   205,   206,   207,
     208,     0,   209,   210,     0,   211,   212,     0,     0,     0,
       0,     0,   213,     0,     0,   214,     0,   215,     0,   216,
     217,     0,     0,   218,   219,   220,   221,     0,     0,   222,
       0,   223,     0,   224,   225,   226,   227,   228,   229,   230,
       0,     0,   231
};

static const yytype_int16 yycheck[] =
{
       2,     2,     8,    84,   240,    55,    12,   258,   258,     2,
      16,   258,    18,     2,    82,    83,     2,   258,     2,     2,
      88,    84,     2,     2,    30,   320,    81,    82,    83,    35,
       2,     2,     2,    88,   322,    41,    42,   325,     2,   327,
       2,     2,   330,     2,   395,     2,   632,     2,   336,     2,
     282,   329,   314,    41,    42,    28,   349,   698,    64,    27,
     370,   446,   277,   278,   300,    58,     6,    85,   179,    58,
       6,   706,    58,    49,    58,    58,    43,    62,    84,    58,
     666,   115,    17,     3,   631,     5,    58,    58,     3,   115,
     179,    68,   115,    60,   630,    75,   114,    70,   634,   179,
     153,   420,   421,   398,   157,   316,    29,    83,   205,   205,
     714,   115,   125,     9,   231,   719,    12,     3,   229,     5,
     205,     3,     0,     5,    44,   225,   205,   205,   205,    49,
     227,   717,   228,   109,   345,   188,    59,   229,   115,   228,
     229,   126,    31,    17,   148,    60,   205,   232,    37,   229,
     211,    74,   226,   232,   232,   232,   230,   408,    44,    82,
     205,   408,    44,    49,   132,    85,   228,   229,   227,   716,
     231,   252,   758,    15,    16,    17,    18,    19,    20,    21,
     395,   205,   158,   419,   420,   421,   205,   232,   212,   252,
     211,   576,   226,   212,   215,   168,   277,   278,   174,    85,
     185,   586,   806,    85,   230,   173,   753,   230,   111,   844,
     520,   530,   505,   226,   277,   278,   752,   858,   286,   755,
     238,   226,     6,     7,   144,   228,   231,   813,    17,   232,
     203,   286,     9,   239,   236,   237,   242,   243,   244,   245,
      38,   228,   229,   236,   237,    43,   252,   236,   237,   312,
     236,   237,   236,   237,     3,   175,   244,   245,   144,   211,
     807,   127,   144,   230,   211,   231,     3,   555,     5,   229,
     521,   277,   278,   809,   521,   526,   526,   231,   228,   526,
     521,   517,   518,   519,   820,   526,     3,   873,     5,   175,
     225,   226,   232,   175,   530,   215,   232,   205,   205,   226,
       3,   516,     5,   230,   212,   212,   312,    44,   371,   228,
     228,   231,   226,   849,   395,    44,   309,   231,   554,   337,
     615,   314,   610,   341,   228,   343,   344,   329,   321,   215,
     348,   228,   395,   215,   200,   201,   202,   203,   204,   115,
     226,   215,   216,   217,   226,   231,   339,   410,    85,   231,
     226,   225,   226,   585,    68,   231,    85,   226,   646,   669,
       3,   230,     5,   673,   228,   371,   676,   209,   210,   211,
     212,   213,   214,   215,   216,   217,     3,     3,     5,     5,
     373,    44,   388,   225,   226,     3,    49,     5,   650,   395,
     228,   446,   226,    15,    16,    17,   230,   228,   400,   226,
       3,   752,     5,   230,   410,   228,   638,   144,   226,   415,
       9,   394,   230,   228,   692,   144,     3,   228,     5,   421,
     228,     3,    85,     5,   213,   214,   215,   216,   217,   680,
     226,   228,   228,   680,   229,   516,   225,   226,   175,   680,
     211,   229,   233,   226,   231,   231,   175,   698,   698,   231,
     231,   698,   231,   516,   229,   806,   766,   698,   231,   231,
       5,   231,   231,   231,   470,   231,   231,   231,   231,   820,
     231,   231,   231,   231,   231,   231,   469,   231,   215,   231,
     231,   144,   714,   231,   231,   231,   215,   719,   231,   231,
     722,   231,   231,   708,   231,   231,   231,   226,   849,   231,
     231,   231,   231,   231,   585,   231,   231,   231,   231,   229,
     516,   229,   175,   764,   229,   517,   517,   764,   228,   587,
     830,   576,   229,   774,   517,   225,   528,   528,   517,   228,
     228,   517,   587,   517,   211,   528,   229,   231,   207,   528,
     232,   207,   528,   232,   528,   528,   231,   842,   528,   528,
       9,   632,   215,     6,   864,   770,   528,   528,   528,     9,
       9,     9,     9,   226,   528,     9,   528,   528,   231,   528,
     563,   528,   565,   528,   806,   528,   565,   563,     9,   889,
       9,     9,   226,   229,   229,   233,   837,   875,   228,   231,
     837,   213,   214,   215,   216,   217,   837,   228,   228,   228,
     228,   207,   838,   225,   226,   229,   215,   858,   858,   230,
     229,   858,   232,   230,   664,   205,     6,   858,   232,   205,
      15,    16,    17,   231,   630,    20,    21,   708,   634,   225,
     632,   232,   232,   714,   232,   232,   717,   232,   719,   205,
     232,   232,   205,   232,   232,   708,   882,   710,   232,   885,
     205,   232,   232,   232,   232,   723,   232,   650,   232,   232,
     232,   232,   232,    45,   666,   232,   225,   232,   723,     9,
     317,   232,   232,   320,   232,   232,   232,   161,   232,   672,
     232,   328,   232,   672,   331,   687,   672,   207,   672,   770,
     692,   338,   232,   340,   687,   701,   228,   232,   205,   185,
     706,   211,   708,   205,   710,   232,     3,   770,     3,     6,
       7,     8,     9,    10,    11,   717,    98,   228,     3,   228,
       6,     9,     6,   205,   232,   806,   229,   185,   207,   111,
     112,   113,   114,   228,   230,   226,   230,   212,   228,   121,
     232,   205,     5,   232,   232,   232,   752,   232,   228,   755,
     207,   398,   399,   229,   232,   228,   758,   228,   232,   211,
     232,   228,   768,   232,   770,   767,   232,   773,   774,   232,
     231,   207,   228,   228,   767,   207,   417,   228,   767,   572,
     393,   767,   781,   767,   166,   338,   232,    84,   640,   171,
     885,   701,   785,   440,   441,   442,   443,   444,   445,   446,
     687,   554,   576,   809,   526,   382,   844,   252,   334,   697,
     768,   813,    94,    -1,   820,   695,   211,   212,   213,   214,
     215,   216,   217,   693,    -1,    -1,    -1,    -1,   834,   404,
     225,   226,    -1,    -1,    -1,    -1,   838,   838,   844,   136,
      -1,    -1,    -1,   849,    -1,   838,    -1,    -1,    -1,   838,
      -1,    -1,   838,    -1,   838,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   873,    -1,   170,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   184,    -1,   536,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,     3,    -1,     5,
       6,     7,     8,     9,    10,    11,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   210,    -1,    -1,   213,   214,   215,    -1,
       3,   218,   219,     6,     7,     8,     9,    10,    11,    -1,
     227,    37,    -1,    39,   231,    -1,    -1,    -1,    -1,    45,
      -1,   588,   589,    49,   591,   592,   593,   594,   595,   596,
     597,   598,   599,   600,   601,   602,   603,   604,   605,   606,
     607,    -1,   609,    -1,    -1,    71,    -1,    -1,   615,    -1,
      -1,    77,    78,    -1,    -1,    -1,    -1,    83,    84,    -1,
      -1,    -1,    88,    -1,    -1,    91,    -1,    -1,    -1,    -1,
      -1,    -1,    98,   640,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    84,    -1,   109,    -1,   111,   112,   113,   114,    -1,
      -1,    -1,    -1,     3,    -1,   121,     6,     7,     8,     9,
      10,    11,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     136,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   158,   136,    -1,    -1,    -1,    -1,    -1,   165,
     166,   167,    -1,    -1,   170,   171,    -1,    -1,   174,    -1,
      -1,    -1,   178,    -1,    -1,    -1,    -1,    -1,   184,    -1,
      -1,   187,    -1,   189,    -1,    -1,    -1,   170,    -1,    -1,
      -1,   197,   198,    -1,    84,    -1,    -1,    -1,    -1,    -1,
      -1,   184,    -1,    -1,   210,    -1,    -1,   213,   214,   215,
      -1,    -1,   218,   219,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   231,    -1,   210,    -1,    -1,
     213,   214,   215,    -1,    -1,   218,   219,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   227,    -1,   136,    -1,   231,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,     3,     4,     5,   812,    -1,    -1,    -1,   816,
      -1,    15,    16,    17,    18,    19,    20,    21,    22,    23,
     170,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      31,    -1,    -1,    -1,   184,   842,    37,    -1,    39,    -1,
      -1,    -1,    -1,    -1,    45,    46,    -1,    -1,    49,    -1,
      -1,    -1,    -1,    -1,    -1,    56,    -1,    58,    -1,    -1,
     210,    -1,    -1,   213,   214,   215,    -1,    68,   218,   219,
      71,    -1,    -1,     3,     4,     5,    77,    78,    -1,    -1,
      -1,   231,    83,    -1,    -1,    -1,    -1,    88,    -1,    -1,
      91,    -1,    -1,    -1,    -1,    -1,    -1,    98,    -1,    -1,
      -1,    31,    -1,    -1,   105,   106,    -1,    37,   109,    39,
     111,   112,   113,   114,   115,    45,    46,    -1,    -1,    49,
     121,    -1,    -1,    -1,    -1,    -1,    56,   128,    58,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    68,    -1,
      -1,    71,    -1,    -1,    -1,   146,    -1,    77,    78,    -1,
      -1,    -1,    -1,    83,    -1,    -1,    -1,   158,    88,    -1,
      -1,    91,    -1,   164,   165,   166,   167,    -1,    98,    -1,
     171,    -1,    -1,   174,    -1,   105,   106,   178,    -1,   109,
      -1,   111,   112,   113,   114,   115,   187,    -1,   189,    -1,
      -1,   121,    -1,    -1,    -1,    -1,   197,   198,   128,    -1,
      -1,    -1,   206,    -1,   208,   209,   210,   211,   212,   213,
     214,   215,   216,   217,    -1,    -1,   146,    -1,     3,     4,
       5,   225,   226,   227,    -1,   226,    -1,    -1,   158,   230,
      -1,    -1,    -1,    -1,   164,   165,   166,   167,    -1,    -1,
      -1,   171,    -1,    -1,   174,    -1,    31,    -1,   178,    -1,
      -1,    -1,    37,    -1,    39,    -1,    -1,   187,    -1,   189,
      45,    46,    -1,    -1,    49,    -1,    -1,   197,   198,    -1,
      -1,    56,    -1,    58,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    68,    -1,    -1,    71,    -1,    -1,     3,
       4,     5,    77,    78,    -1,    -1,   226,    -1,    83,    -1,
     230,    -1,    -1,    88,    -1,    -1,    91,    -1,    -1,    -1,
      -1,    -1,    -1,    98,    -1,    -1,    -1,    -1,    -1,    -1,
     105,    -1,    -1,    37,   109,    39,   111,   112,   113,   114,
     115,    45,    -1,    -1,    -1,    49,   121,    -1,    -1,    -1,
      -1,    -1,    56,   128,    -1,    -1,    -1,    -1,    -1,    15,
      16,    17,    18,    19,    20,    21,    -1,    71,    -1,    -1,
      -1,   146,    -1,    77,    78,    -1,    -1,    -1,    -1,    83,
      -1,    -1,    -1,   158,    88,    -1,    -1,    91,    -1,   164,
     165,   166,   167,    -1,    98,    -1,   171,    -1,    -1,   174,
      -1,   105,    -1,   178,    -1,   109,    -1,   111,   112,   113,
     114,    -1,   187,    -1,   189,    -1,    -1,   121,    -1,    -1,
      -1,    -1,   197,   198,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,     3,     4,     5,    -1,    -1,
      -1,    -1,   146,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   226,    -1,    -1,   158,   230,    -1,    -1,    -1,    -1,
      -1,   165,   166,   167,    -1,    -1,    -1,   171,    -1,    37,
     174,    39,    -1,    -1,   178,    -1,    -1,    45,    -1,    -1,
      -1,    49,    -1,   187,    -1,   189,    -1,    -1,    56,    -1,
      -1,    -1,    -1,   197,   198,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    71,    -1,    -1,     3,    -1,     5,    77,
      78,    -1,    -1,    -1,    -1,    83,    -1,    -1,    -1,    -1,
      88,    -1,   226,    91,    -1,    -1,   230,    -1,    -1,    -1,
      98,    -1,    -1,    -1,    -1,    -1,    -1,   105,    -1,    -1,
      37,   109,    39,   111,   112,   113,   114,    -1,    45,    -1,
      -1,    -1,    49,   121,   210,   211,   212,   213,   214,   215,
     216,   217,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   225,
     226,    -1,    -1,    -1,    71,    -1,    -1,    -1,   146,    -1,
      77,    78,    -1,    -1,    -1,    -1,    83,    -1,    -1,    -1,
     158,    88,    -1,    -1,    91,    -1,    -1,   165,   166,   167,
      -1,    98,    -1,   171,    -1,    -1,   174,    -1,    -1,    -1,
     178,    -1,   109,    -1,   111,   112,   113,   114,    -1,   187,
      -1,   189,    -1,    -1,   121,    -1,    -1,    -1,    -1,   197,
     198,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     0,
      -1,    -1,     3,     4,     5,    -1,    -1,    -1,   226,    -1,
      -1,   158,   230,    14,    -1,    -1,    -1,    -1,   165,   166,
     167,    -1,    -1,    -1,   171,    -1,    -1,   174,    -1,    -1,
      31,   178,    -1,    -1,    -1,    -1,    37,    -1,    39,    -1,
     187,    -1,   189,    -1,    45,    46,    -1,    -1,    49,    -1,
     197,   198,    -1,    -1,    -1,    56,    -1,    58,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    68,    -1,    -1,
      71,    -1,    -1,    -1,    -1,    -1,    77,    78,    -1,   226,
      -1,    -1,    83,   230,    -1,    -1,    -1,    88,    -1,    -1,
      91,    -1,    -1,    -1,    -1,    -1,    -1,    98,    -1,    -1,
      -1,    -1,    -1,    -1,   105,    -1,    -1,    -1,   109,    -1,
     111,   112,   113,   114,   115,    -1,    -1,    -1,    -1,    -1,
     121,    -1,    -1,    -1,    -1,    -1,    -1,   128,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   146,    -1,    -1,     3,     4,
       5,    -1,    -1,    -1,    -1,    -1,    -1,   158,    13,    -1,
      -1,    -1,    -1,   164,   165,   166,   167,    -1,    -1,    -1,
     171,    -1,    -1,   174,    -1,    -1,    31,   178,    -1,    -1,
      -1,    -1,    37,    -1,    39,    -1,   187,    -1,   189,    -1,
      45,    46,    -1,    -1,    49,    -1,   197,   198,    -1,    -1,
      -1,    56,    -1,    58,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    68,    -1,    -1,    71,    -1,    -1,    -1,
      -1,    -1,    77,    78,    -1,   226,    -1,    -1,    83,    -1,
      -1,    -1,    -1,    88,    -1,    -1,    91,    -1,    -1,    -1,
       3,    -1,     5,    98,    -1,    -1,    -1,    -1,    -1,    -1,
     105,   106,    -1,    -1,   109,    -1,   111,   112,   113,   114,
     115,    -1,    -1,    -1,    -1,    -1,   121,    -1,    -1,    -1,
      -1,    -1,    -1,   128,    37,    -1,    39,    -1,    -1,    -1,
      -1,    44,    45,    -1,    -1,    -1,    49,    -1,    -1,    -1,
      -1,   146,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   158,    -1,    -1,    -1,    -1,    71,   164,
     165,   166,   167,    -1,    77,    78,   171,    -1,    -1,   174,
      83,    -1,    85,   178,    -1,    88,    -1,    -1,    91,    -1,
      -1,    -1,   187,    -1,   189,    98,    -1,    -1,    -1,    -1,
      -1,    -1,   197,   198,    -1,    -1,   109,    -1,   111,   112,
     113,   114,    -1,    -1,    -1,    -1,    -1,    -1,   121,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   226,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   144,    -1,    -1,    -1,    -1,     3,    -1,     5,    -1,
      -1,    -1,    -1,    -1,    -1,   158,    -1,    -1,    -1,    -1,
      -1,    -1,   165,   166,   167,    -1,    -1,    -1,   171,    -1,
      -1,   174,   175,    -1,    -1,   178,    -1,    -1,    -1,    -1,
      37,    -1,    39,    -1,   187,    -1,   189,    44,    45,    -1,
      -1,    -1,    49,    -1,   197,   198,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   215,    -1,    71,    -1,    -1,     3,    -1,     5,
      77,    78,    -1,   226,    -1,    -1,    83,    -1,    85,    -1,
      -1,    88,    -1,    -1,    91,    -1,    -1,    -1,    24,    -1,
      -1,    98,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    37,   109,    39,   111,   112,   113,   114,    -1,    45,
      -1,    -1,    -1,    49,   121,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    -1,    -1,    71,    -1,   144,    -1,    -1,
      -1,    77,    78,    -1,    -1,    -1,    -1,    83,    -1,    -1,
      -1,   158,    88,    -1,    -1,    91,    -1,    -1,   165,   166,
     167,    -1,    98,    -1,   171,    -1,    -1,   174,   175,    -1,
      -1,   178,    -1,   109,    -1,   111,   112,   113,   114,    -1,
     187,    -1,   189,    -1,    -1,   121,    -1,    -1,    -1,    -1,
     197,   198,    -1,    -1,    -1,    -1,    -1,    -1,     3,    -1,
       5,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   215,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    -1,   226,
      -1,    -1,   158,    -1,    -1,    -1,    -1,    -1,    -1,   165,
     166,   167,    37,    -1,    39,   171,    -1,    -1,   174,    -1,
      45,    -1,   178,    -1,    49,    -1,    -1,    -1,    -1,    -1,
      -1,   187,    -1,   189,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   197,   198,    -1,    -1,    -1,    71,    -1,    -1,    -1,
      -1,    -1,    77,    78,    -1,    -1,    -1,    -1,    83,    -1,
      -1,    -1,    -1,    88,    -1,    -1,    91,    -1,    -1,    -1,
     226,    -1,    -1,    98,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    -1,   109,    -1,   111,   112,   113,   114,
      -1,    -1,    -1,    -1,    -1,   206,   121,   208,   209,   210,
     211,   212,   213,   214,   215,   216,   217,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   225,   226,    -1,    -1,    -1,    -1,
      -1,   232,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    -1,    -1,   158,    -1,    -1,    -1,    -1,    -1,    -1,
     165,   166,   167,    -1,    -1,    -1,   171,    -1,    -1,   174,
      -1,    -1,    -1,   178,    -1,    15,    16,    17,    18,    19,
      20,    21,   187,    23,   189,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   197,   198,    -1,    -1,    -1,    -1,    -1,    -1,
     206,    -1,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   225,
     226,   226,    -1,    -1,    -1,    -1,   232,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    15,    16,    17,
      18,    19,    20,    21,    15,    16,    17,    18,    19,    20,
      21,    -1,    -1,    -1,    -1,   206,    -1,   208,   209,   210,
     211,   212,   213,   214,   215,   216,   217,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   225,   226,    -1,    -1,    -1,    -1,
      -1,   232,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   206,    -1,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   225,   226,   227,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   208,   209,
     210,   211,   212,   213,   214,   215,   216,   217,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   225,   226,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   206,   207,
     208,   209,   210,   211,   212,   213,   214,   215,   216,   217,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   225,   226,   206,
      -1,   208,   209,   210,   211,   212,   213,   214,   215,   216,
     217,    -1,     3,    -1,     5,    -1,    -1,    -1,   225,   226,
     208,   209,   210,   211,   212,   213,   214,   215,   216,   217,
     211,   212,   213,   214,   215,   216,   217,   225,   226,    -1,
      31,    -1,    -1,    -1,   225,   226,    37,    -1,    39,    -1,
      -1,    -1,    -1,    -1,    45,    46,    -1,    -1,    49,    -1,
       3,    -1,     5,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    68,    -1,    -1,
      71,    -1,    -1,    -1,    -1,    -1,    77,    78,    -1,    -1,
      -1,    -1,    83,    -1,    37,    -1,    39,    88,    -1,    -1,
      91,    -1,    45,    -1,    -1,    -1,    49,    98,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,    -1,
     111,   112,   113,   114,   115,    -1,    -1,   118,    71,    -1,
     121,    -1,    -1,    -1,    77,    78,    -1,    -1,    -1,    -1,
      83,    -1,    -1,    -1,    -1,    88,    -1,    -1,    91,    -1,
      -1,    -1,     3,    -1,     5,    98,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   109,   158,   111,   112,
     113,   114,    -1,   164,   165,   166,   167,    -1,   121,    -1,
     171,    -1,    -1,   174,    -1,    -1,    37,   178,    39,    -1,
      -1,    -1,    -1,    -1,    45,    -1,   187,    -1,   189,    -1,
       3,    -1,     5,    -1,    -1,    -1,   197,   198,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   158,    -1,    -1,    -1,    -1,
      71,    -1,   165,   166,   167,    -1,    77,    78,   171,    -1,
      -1,   174,    -1,    -1,    37,   178,    39,    88,    -1,    -1,
      91,    -1,    45,    -1,   187,    -1,   189,    98,    -1,    -1,
      -1,    -1,    -1,    -1,   197,   198,    -1,    -1,    -1,    -1,
     111,   112,   113,   114,    -1,    -1,    -1,    -1,    71,    -1,
     121,    -1,    -1,    -1,    -1,    78,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    88,    -1,    -1,    91,    -1,
      -1,    -1,    -1,    -1,    -1,    98,    -1,    -1,    -1,     5,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,   112,
     113,   114,    -1,    -1,   165,   166,   167,    -1,   121,    -1,
     171,    -1,    -1,    -1,    -1,    -1,    -1,   178,    -1,    -1,
      -1,    37,    -1,    39,    -1,    -1,   187,    -1,   189,    45,
      -1,    -1,    -1,    49,    -1,    -1,   197,   198,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   166,   167,    71,    -1,    -1,   171,    -1,
       5,    77,    78,    -1,    -1,    -1,    -1,    83,    -1,    -1,
      -1,    -1,    88,    -1,    -1,    91,   189,    -1,    -1,    -1,
      -1,    -1,    98,    -1,    -1,   198,    -1,    -1,    -1,    -1,
      -1,    -1,    37,   109,    39,   111,   112,   113,   114,    -1,
      45,    -1,    -1,    -1,    -1,   121,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    71,    -1,    -1,    -1,
      -1,    -1,    77,    78,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   158,    88,    -1,    -1,    91,    -1,    -1,   165,
     166,   167,    -1,    98,    -1,   171,    -1,    -1,   174,    -1,
      -1,    -1,   178,    -1,    -1,    -1,   111,   112,   113,   114,
      -1,   187,    -1,   189,    -1,    -1,   121,    -1,    -1,    -1,
      -1,   197,   198,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     165,   166,   167,    -1,    -1,    -1,   171,    -1,    -1,    -1,
      -1,    -1,    -1,   178,    -1,    -1,    -1,    -1,    25,    26,
      -1,    -1,   187,    30,   189,    32,    33,    34,    35,    36,
      -1,    38,   197,   198,    41,    -1,    43,    -1,    -1,    -1,
      47,    48,    -1,    50,    51,    52,    53,    54,    55,    -1,
      57,    -1,    59,    60,    61,    -1,    63,    64,    65,    66,
      67,    -1,    69,    -1,    -1,    72,    73,    74,    75,    76,
      -1,    -1,    79,    80,    81,    82,    -1,    -1,    -1,    86,
      87,    -1,    89,    90,    -1,    92,    93,    94,    95,    96,
      97,    -1,    99,   100,   101,   102,   103,   104,    -1,    -1,
     107,    -1,    -1,   110,    -1,    -1,    -1,    -1,    -1,   116,
     117,    -1,   119,   120,    -1,   122,   123,   124,    -1,    -1,
      -1,    -1,   129,   130,   131,    -1,   133,   134,   135,    -1,
     137,   138,   139,   140,   141,   142,   143,    -1,   145,    -1,
     147,    -1,   149,   150,   151,   152,   153,   154,   155,   156,
     157,    -1,   159,   160,    -1,   162,   163,    -1,    -1,    -1,
      -1,    -1,   169,    -1,    -1,   172,    -1,   174,    -1,   176,
     177,    -1,    -1,   180,   181,   182,   183,    -1,    -1,   186,
      -1,   188,    -1,   190,   191,   192,   193,   194,   195,   196,
      -1,    -1,   199
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,   235,   241,     0,     3,     4,     5,    14,    31,    37,
      39,    45,    46,    49,    56,    58,    68,    71,    77,    78,
      83,    88,    91,    98,   105,   109,   111,   112,   113,   114,
     115,   121,   128,   146,   158,   164,   165,   166,   167,   171,
     174,   178,   187,   189,   197,   198,   226,   236,   238,   247,
     248,   250,   251,   252,   253,   256,   257,   263,   264,   280,
     294,   297,   299,   301,   302,   303,   304,   307,   308,   309,
     310,   311,   312,   313,   316,   317,   320,   324,   327,   332,
     337,   338,   339,   340,   342,   345,   363,   364,   365,   366,
     367,   225,   226,   369,   372,   373,     3,     5,   297,   297,
     231,   229,   297,     3,   296,   297,   111,   300,     9,   297,
     300,     3,   231,   297,   231,   300,   301,     3,   296,     3,
     296,   301,    25,    26,    30,    32,    33,    34,    35,    36,
      38,    41,    43,    47,    48,    50,    51,    52,    53,    54,
      55,    57,    59,    60,    61,    63,    64,    65,    66,    67,
      69,    72,    73,    74,    75,    76,    79,    80,    81,    82,
      86,    87,    89,    90,    92,    93,    94,    95,    96,    97,
      99,   100,   101,   102,   103,   104,   107,   110,   116,   117,
     119,   120,   122,   123,   124,   129,   130,   131,   133,   134,
     135,   137,   138,   139,   140,   141,   142,   143,   145,   147,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   159,
     160,   162,   163,   169,   172,   174,   176,   177,   180,   181,
     182,   183,   186,   188,   190,   191,   192,   193,   194,   195,
     196,   199,   265,   271,   362,   228,   243,   243,    62,   126,
     185,   336,    77,   118,   178,   187,   255,   280,   307,   309,
     311,   324,   342,   363,   367,   228,     3,   297,   211,   228,
     228,   228,   229,   228,   316,   228,   246,   228,   344,   345,
     344,   344,    44,    85,   144,   175,   215,   231,   273,   297,
     298,   346,   347,   360,   280,   363,   365,   367,   344,   228,
      29,    59,    74,    82,   374,   375,   369,   115,     9,   237,
     229,   228,   211,     3,    60,   365,   229,   179,   229,   231,
     231,   231,   231,   231,   231,   231,   231,   231,   231,   231,
     231,   231,   231,   231,   231,   231,   231,   231,   231,   231,
     231,   231,   231,   231,   231,   231,   231,   231,   231,   231,
     231,   231,   231,   231,   231,   231,   231,   231,   231,   205,
     227,    13,    58,   106,   240,   247,   254,   257,   307,   308,
     309,   310,   311,   312,   313,   316,   324,   327,   332,   337,
     230,   365,   297,   263,   264,   229,     3,   297,     3,     3,
     229,   229,   229,   229,   333,   360,   225,   299,   302,   303,
     304,   305,   306,   242,   229,   341,   346,   346,   233,   226,
     231,   262,   344,   231,   205,   227,     5,   232,   115,   230,
     263,   276,   277,   278,   279,   325,   207,   207,   232,   287,
     231,   290,   269,   342,     9,     9,    12,   272,   298,     3,
       6,     7,     8,     9,    10,    11,    84,   136,   170,   184,
     210,   213,   214,   215,   218,   219,   231,   283,   284,   285,
     269,     6,   268,   272,   283,   286,     9,     9,   266,   286,
     342,   285,     9,     9,   285,     9,   285,   283,   261,   264,
     342,   285,   281,   282,   283,    27,   132,   173,   267,     9,
     362,     9,   285,   365,   281,   270,   342,   283,   365,   127,
     200,   201,   202,   203,   204,   361,   365,   365,   272,     6,
       7,   368,     9,   365,   271,   226,   229,   231,   228,   228,
     228,   229,   228,   228,   246,   298,   342,   245,   314,   314,
     230,   207,   321,   297,   215,   215,   205,   212,   241,   148,
     318,   324,   340,   346,   232,   286,   215,   227,   283,   258,
     259,   260,   261,    28,    70,   168,   203,   376,   377,   375,
     229,   303,   298,   230,   205,   233,   297,   322,   323,     6,
     249,   249,   230,   263,   288,   263,   292,   230,   264,   289,
     292,   232,   205,   232,   232,   232,   231,   283,   283,   283,
     283,   283,   283,     5,   283,   343,   345,   364,    15,    16,
      17,    18,    19,    20,    21,    22,    23,   206,   208,   209,
     210,   211,   212,   213,   214,   215,   216,   217,   225,   226,
     205,   232,   232,   225,   232,   205,   232,   232,   205,   232,
     232,   232,   232,   232,   232,   232,   232,   232,   232,   232,
     342,   215,   231,   262,   273,   298,   352,   354,   355,   232,
     205,   232,   232,   232,   232,   232,   205,   232,   232,   232,
     205,   232,   232,   232,   232,   232,   232,   225,   232,   232,
     232,   271,   239,     9,   244,   211,   231,   346,   356,   230,
     247,   263,   264,   230,   263,   315,   230,   246,   303,   304,
     161,   331,   305,   230,   207,   125,   292,   319,   228,   227,
     227,   232,   205,   205,   232,   185,   370,   371,   211,   279,
     285,   205,   326,     6,   232,   232,   342,   367,   342,   363,
     232,   228,   228,   268,   343,   232,   215,   231,   262,   273,
     348,   350,   351,   364,   344,   283,   283,     3,   283,   283,
     283,   283,   283,   283,   283,   283,   283,   283,   283,   283,
     283,   283,   283,   283,   283,     3,   283,   285,     6,   286,
       9,   354,   341,   215,   258,   273,   353,   354,   231,   262,
     282,   285,   269,     6,   115,   230,   232,   243,   328,   258,
     205,   246,   246,    68,   115,   334,   335,   246,   303,   304,
     330,   229,   207,   228,   230,   264,   293,   294,   230,    24,
     261,   377,   373,   230,   370,   306,   322,   212,   352,   358,
     359,   228,   346,   295,   298,   350,   341,   215,   258,   273,
     349,   350,   232,   231,   262,   344,   207,   227,   232,   354,
     341,   232,   354,   232,   258,   232,   303,   246,   230,   323,
     232,   346,   297,   297,   302,   228,   228,   205,   245,   228,
       5,   212,   207,   357,   205,   228,   229,   232,   350,   341,
     232,   354,   232,   283,   258,   283,   354,   232,   211,   212,
     246,   297,   303,   304,   230,   228,   228,   286,   358,   274,
     354,   232,   306,   231,   246,    43,    60,   230,   275,   212,
     258,   285,   207,   228,   232,   207,   228,   291,   292,   329,
     291,   228,   246
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   234,   235,   236,   236,   237,   237,   238,   239,   239,
     240,   241,   242,   241,   241,   241,   241,   241,   241,   241,
     241,   241,   241,   241,   241,   241,   241,   241,   243,   243,
     243,   244,   243,   243,   243,   243,   243,   243,   243,   243,
     243,   243,   243,   243,   243,   243,   245,   245,   246,   246,
     247,   247,   247,   247,   247,   247,   247,   248,   248,   249,
     249,   250,   250,   250,   250,   250,   250,   250,   250,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   258,   259,
     259,   260,   260,   261,   261,   262,   262,   262,   263,   263,
     264,   265,   265,   265,   266,   266,   267,   267,   267,   268,
     268,   269,   270,   271,   271,   271,   271,   271,   271,   271,
     271,   271,   271,   271,   271,   271,   271,   271,   271,   271,
     271,   271,   271,   271,   271,   271,   271,   271,   271,   271,
     271,   271,   271,   271,   271,   271,   271,   271,   271,   271,
     271,   271,   271,   271,   271,   271,   271,   271,   271,   271,
     271,   271,   271,   271,   271,   271,   271,   271,   271,   271,
     271,   271,   271,   271,   271,   271,   271,   271,   271,   271,
     271,   271,   271,   271,   271,   271,   271,   271,   271,   271,
     271,   271,   271,   271,   271,   271,   271,   271,   271,   271,
     271,   271,   271,   271,   271,   271,   271,   271,   271,   271,
     271,   271,   271,   271,   271,   271,   271,   271,   271,   271,
     271,   271,   271,   272,   272,   273,   273,   273,   273,   274,
     274,   275,   275,   276,   276,   276,   277,   277,   278,   279,
     279,   280,   281,   281,   282,   282,   283,   283,   283,   283,
     283,   283,   283,   283,   283,   283,   283,   283,   283,   283,
     283,   283,   283,   283,   283,   283,   283,   283,   283,   283,
     283,   283,   283,   283,   283,   283,   283,   283,   283,   283,
     283,   283,   283,   283,   283,   283,   283,   284,   284,   285,
     286,   287,   287,   288,   288,   289,   289,   290,   290,   291,
     291,   292,   292,   293,   294,   294,   295,   295,   296,   296,
     297,   297,   298,   299,   299,   299,   299,   299,   299,   299,
     299,   299,   299,   299,   300,   300,   301,   301,   301,   301,
     301,   301,   301,   301,   301,   302,   302,   303,   303,   304,
     305,   305,   305,   305,   305,   306,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   314,   315,   315,   316,   317,
     318,   318,   319,   319,   320,   320,   321,   321,   321,   322,
     323,   323,   324,   325,   326,   324,   327,   328,   329,   327,
     330,   330,   330,   330,   331,   331,   333,   332,   332,   334,
     334,   335,   336,   337,   338,   338,   338,   339,   340,   341,
     341,   342,   342,   343,   343,   344,   344,   345,   345,   345,
     346,   346,   346,   347,   347,   347,   347,   348,   348,   348,
     349,   349,   350,   350,   351,   351,   351,   351,   351,   352,
     352,   352,   353,   353,   354,   354,   355,   355,   355,   355,
     355,   355,   356,   356,   357,   357,   358,   359,   359,   360,
     360,   361,   361,   361,   361,   361,   361,   362,   362,   362,
     363,   364,   364,   364,   364,   364,   364,   364,   364,   364,
     364,   365,   365,   365,   366,   367,   367,   368,   368,   368,
     369,   369,   370,   370,   371,   372,   373,   373,   374,   374,
     375,   375,   375,   375,   376,   376,   377,   377,   377,   377
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     2,     0,     2,     0,     7,     4,     0,     7,
       4,     0,     0,     6,     3,     3,     2,     2,     3,     2,
       3,     2,     3,     2,     2,     2,     2,     2,     0,     3,
       3,     0,     6,     2,     2,     3,     2,     3,     2,     3,
       2,     2,     2,     2,     2,     2,     0,     2,     0,     1,
       1,     2,     2,     1,     2,     1,     1,     6,     6,     1,
       2,     1,     2,     1,     2,     1,     2,     2,     2,     2,
       4,     3,     3,     5,     2,     3,     4,     0,     1,     1,
       3,     1,     3,     3,     2,     3,     3,     2,     0,     1,
       3,     1,     3,     4,     1,     3,     1,     1,     1,     1,
       3,     3,     3,     0,     4,     1,     4,     1,     1,     1,
       1,     1,     4,     4,     1,     1,     1,     1,     1,     4,
       4,     1,     6,     1,     1,     1,     1,     4,     1,     1,
       1,     4,     1,     1,     1,     4,     4,     1,     1,     4,
       1,     1,     1,     1,     1,     4,     4,     4,     4,     4,
       1,     4,     1,     1,     4,     1,     4,     1,     1,     4,
       4,     1,     1,     1,     4,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     4,     1,     1,     1,
       4,     4,     1,     1,     1,     1,     1,     6,     1,     4,
       1,     1,     1,     4,     1,     4,     1,     1,     4,     4,
       4,     4,     1,     1,     4,     4,     4,     1,     1,     4,
       4,     4,     1,     1,     1,     1,     1,     1,     1,     0,
       2,     4,     3,     0,     2,     1,     1,     3,     2,     3,
       1,     5,     1,     3,     0,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     5,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     2,     2,     2,     2,     2,
       2,     3,     3,     5,     5,     4,     3,     1,     3,     1,
       1,     0,     2,     4,     3,     2,     2,     0,     2,     2,
       1,     3,     2,     1,     3,     2,     0,     1,     0,     1,
       1,     1,     1,     1,     1,     1,     2,     2,     1,     1,
       1,     1,     1,     1,     0,     1,     1,     2,     1,     2,
       2,     1,     1,     1,     1,     2,     3,     1,     2,     4,
       1,     1,     2,     1,     2,     1,     3,     2,     6,     2,
       6,     2,     5,     2,     0,     2,     3,     3,     2,     1,
       2,     3,     2,     3,     6,     6,     0,     2,     2,     1,
       1,     3,     2,     0,     0,     7,     8,     0,     0,    13,
       1,     1,     3,     3,     0,     2,     0,     9,     2,     2,
       3,     2,     2,     6,     1,     1,     1,     1,     1,     0,
       2,     2,     3,     2,     3,     0,     1,     2,     2,     2,
       3,     2,     1,     1,     3,     2,     4,     3,     2,     1,
       3,     2,     0,     1,     3,     2,     1,     3,     4,     3,
       2,     1,     3,     2,     0,     1,     1,     3,     2,     1,
       3,     4,     1,     3,     0,     2,     2,     1,     3,     1,
       3,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       5,     1,     1,     1,     2,     1,     2,     1,     2,     4,
       1,     1,     2,     1,     5,     5,    10,     1,     3,     1,
       0,     2,     0,     2,     4,     6,     0,     3,     1,     3,
       4,     1,     1,     1,     1,     3,     1,     1,     1,     1
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                                              );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yystacksize);

        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 349 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyvsp[-1].stmt_list) = append_parameterized_type_stmts((yyvsp[-1].stmt_list));
						  check_statements((yyvsp[-1].stmt_list), FALSE);
						  check_all_user_types((yyvsp[-1].stmt_list));
						  write_header((yyvsp[-1].stmt_list));
						  write_id_data((yyvsp[-1].stmt_list));
						  write_proxies((yyvsp[-1].stmt_list));
						  write_client((yyvsp[-1].stmt_list));
						  write_server((yyvsp[-1].stmt_list));
						  write_regscript((yyvsp[-1].stmt_list));
						  write_typelib_regscript((yyvsp[-1].stmt_list));
						  write_dlldata((yyvsp[-1].stmt_list));
						  write_local_stubs((yyvsp[-1].stmt_list));
						}
#line 2836 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 5:
#line 366 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.stmt_list) = NULL; }
#line 2842 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 6:
#line 368 "tools/widl/parser.y" /* yacc.c:1646  */
    { parameterized_type_stmts = append_statement(parameterized_type_stmts, make_statement_parameterized_type((yyvsp[-4].type), (yyvsp[-2].typeref_list)));
						  (yyval.stmt_list) = append_statement((yyvsp[-6].stmt_list), make_statement_reference(type_parameterized_type_specialize_declare((yyvsp[-4].type), (yyvsp[-2].typeref_list))));
						}
#line 2850 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 7:
#line 373 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.stmt_list) = (yyvsp[-1].stmt_list); }
#line 2856 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 8:
#line 375 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.stmt_list) = NULL; }
#line 2862 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 9:
#line 377 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.stmt_list) = append_statement((yyvsp[-6].stmt_list), make_statement_reference(type_parameterized_type_specialize_declare((yyvsp[-4].type), (yyvsp[-2].typeref_list)))); }
#line 2868 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 10:
#line 380 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.stmt_list) = (yyvsp[-1].stmt_list); }
#line 2874 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 11:
#line 382 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.stmt_list) = NULL; }
#line 2880 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 12:
#line 383 "tools/widl/parser.y" /* yacc.c:1646  */
    { push_namespace((yyvsp[-1].str)); }
#line 2886 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 13:
#line 384 "tools/widl/parser.y" /* yacc.c:1646  */
    { pop_namespace((yyvsp[-4].str)); (yyval.stmt_list) = append_statements((yyvsp[-5].stmt_list), (yyvsp[-1].stmt_list)); }
#line 2892 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 14:
#line 385 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.stmt_list) = append_statement((yyvsp[-2].stmt_list), make_statement_reference((yyvsp[-1].type))); }
#line 2898 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 15:
#line 386 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.stmt_list) = append_statement((yyvsp[-2].stmt_list), make_statement_reference((yyvsp[-1].type))); }
#line 2904 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 16:
#line 387 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.stmt_list) = append_statement((yyvsp[-1].stmt_list), make_statement_type_decl((yyvsp[0].type))); }
#line 2910 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 17:
#line 388 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.stmt_list) = append_statement((yyvsp[-1].stmt_list), make_statement_type_decl((yyvsp[0].type))); }
#line 2916 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 18:
#line 389 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.stmt_list) = (yyvsp[-2].stmt_list);
						  reg_type((yyvsp[-1].type), (yyvsp[-1].type)->name, current_namespace, 0);
						}
#line 2924 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 19:
#line 392 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.stmt_list) = append_statement((yyvsp[-1].stmt_list), make_statement_type_decl((yyvsp[0].type)));
						  reg_type((yyvsp[0].type), (yyvsp[0].type)->name, current_namespace, 0);
						}
#line 2932 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 20:
#line 395 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.stmt_list) = (yyvsp[-2].stmt_list); reg_type((yyvsp[-1].type), (yyvsp[-1].type)->name, current_namespace, 0); }
#line 2938 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 21:
#line 396 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.stmt_list) = append_statement((yyvsp[-1].stmt_list), make_statement_type_decl((yyvsp[0].type)));
						  reg_type((yyvsp[0].type), (yyvsp[0].type)->name, current_namespace, 0); }
#line 2945 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 22:
#line 398 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.stmt_list) = (yyvsp[-2].stmt_list); reg_type((yyvsp[-1].type), (yyvsp[-1].type)->name, current_namespace, 0); }
#line 2951 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 23:
#line 399 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.stmt_list) = append_statement((yyvsp[-1].stmt_list), make_statement_type_decl((yyvsp[0].type)));
	                                          reg_type((yyvsp[0].type), (yyvsp[0].type)->name, current_namespace, 0); }
#line 2958 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 24:
#line 401 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.stmt_list) = append_statement((yyvsp[-1].stmt_list), make_statement_module((yyvsp[0].type))); }
#line 2964 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 25:
#line 402 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.stmt_list) = append_statement((yyvsp[-1].stmt_list), make_statement_library((yyvsp[0].typelib))); }
#line 2970 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 26:
#line 403 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.stmt_list) = append_statement((yyvsp[-1].stmt_list), (yyvsp[0].statement)); }
#line 2976 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 27:
#line 404 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.stmt_list) = append_statements((yyvsp[-1].stmt_list), (yyvsp[0].stmt_list)); }
#line 2982 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 28:
#line 407 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.stmt_list) = NULL; }
#line 2988 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 29:
#line 408 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.stmt_list) = append_statement((yyvsp[-2].stmt_list), make_statement_reference((yyvsp[-1].type))); }
#line 2994 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 30:
#line 409 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.stmt_list) = append_statement((yyvsp[-2].stmt_list), make_statement_reference((yyvsp[-1].type))); }
#line 3000 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 31:
#line 410 "tools/widl/parser.y" /* yacc.c:1646  */
    { push_namespace((yyvsp[-1].str)); }
#line 3006 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 32:
#line 411 "tools/widl/parser.y" /* yacc.c:1646  */
    { pop_namespace((yyvsp[-4].str)); (yyval.stmt_list) = append_statements((yyvsp[-5].stmt_list), (yyvsp[-1].stmt_list)); }
#line 3012 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 33:
#line 412 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.stmt_list) = append_statement((yyvsp[-1].stmt_list), make_statement_type_decl((yyvsp[0].type))); }
#line 3018 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 34:
#line 413 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.stmt_list) = append_statement((yyvsp[-1].stmt_list), make_statement_type_decl((yyvsp[0].type))); }
#line 3024 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 35:
#line 414 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.stmt_list) = (yyvsp[-2].stmt_list); reg_type((yyvsp[-1].type), (yyvsp[-1].type)->name, current_namespace, 0); }
#line 3030 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 36:
#line 415 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.stmt_list) = append_statement((yyvsp[-1].stmt_list), make_statement_type_decl((yyvsp[0].type)));
						  reg_type((yyvsp[0].type), (yyvsp[0].type)->name, current_namespace, 0);
						}
#line 3038 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 37:
#line 418 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.stmt_list) = (yyvsp[-2].stmt_list); reg_type((yyvsp[-1].type), (yyvsp[-1].type)->name, current_namespace, 0); }
#line 3044 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 38:
#line 419 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.stmt_list) = append_statement((yyvsp[-1].stmt_list), make_statement_type_decl((yyvsp[0].type)));
						  reg_type((yyvsp[0].type), (yyvsp[0].type)->name, current_namespace, 0); }
#line 3051 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 39:
#line 421 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.stmt_list) = (yyvsp[-2].stmt_list); reg_type((yyvsp[-1].type), (yyvsp[-1].type)->name, current_namespace, 0); }
#line 3057 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 40:
#line 422 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.stmt_list) = append_statement((yyvsp[-1].stmt_list), make_statement_type_decl((yyvsp[0].type)));
	                                          reg_type((yyvsp[0].type), (yyvsp[0].type)->name, current_namespace, 0); }
#line 3064 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 41:
#line 424 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.stmt_list) = append_statement((yyvsp[-1].stmt_list), make_statement_module((yyvsp[0].type))); }
#line 3070 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 42:
#line 425 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.stmt_list) = append_statement((yyvsp[-1].stmt_list), (yyvsp[0].statement)); }
#line 3076 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 43:
#line 426 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.stmt_list) = append_statement((yyvsp[-1].stmt_list), make_statement_importlib((yyvsp[0].str))); }
#line 3082 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 44:
#line 427 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.stmt_list) = append_statement((yyvsp[-1].stmt_list), make_statement_library((yyvsp[0].typelib))); }
#line 3088 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 45:
#line 428 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.stmt_list) = append_statements((yyvsp[-1].stmt_list), (yyvsp[0].stmt_list)); }
#line 3094 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 46:
#line 431 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.stmt_list) = NULL; }
#line 3100 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 47:
#line 432 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.stmt_list) = append_statement((yyvsp[-1].stmt_list), (yyvsp[0].statement)); }
#line 3106 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 50:
#line 440 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.statement) = make_statement_cppquote((yyvsp[0].str)); }
#line 3112 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 51:
#line 441 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.statement) = make_statement_type_decl((yyvsp[-1].type)); }
#line 3118 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 52:
#line 442 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.statement) = make_statement_declaration((yyvsp[-1].var)); }
#line 3124 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 53:
#line 443 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.statement) = make_statement_import((yyvsp[0].str)); }
#line 3130 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 54:
#line 444 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.statement) = (yyvsp[-1].statement); }
#line 3136 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 55:
#line 445 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.statement) = make_statement_pragma((yyvsp[0].str)); }
#line 3142 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 56:
#line 446 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.statement) = NULL; }
#line 3148 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 57:
#line 450 "tools/widl/parser.y" /* yacc.c:1646  */
    {
                      int result;
                      (yyval.statement) = NULL;
                      result = do_warning((yyvsp[-3].str), (yyvsp[-1].warning_list));
                      if(!result)
                          error_loc("expected \"disable\", \"enable\" or \"default\"\n");
                  }
#line 3160 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 58:
#line 458 "tools/widl/parser.y" /* yacc.c:1646  */
    {
                      (yyval.statement) = NULL;
                      do_warning("default", (yyvsp[-1].warning_list));
                  }
#line 3169 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 59:
#line 465 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.warning_list) = append_warning(NULL, (yyvsp[0].num)); }
#line 3175 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 60:
#line 466 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.warning_list) = append_warning((yyvsp[-1].warning_list), (yyvsp[0].num)); }
#line 3181 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 62:
#line 471 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = type_new_enum((yyvsp[0].str), current_namespace, FALSE, NULL); }
#line 3187 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 64:
#line 473 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = type_new_struct((yyvsp[0].str), current_namespace, FALSE, NULL); }
#line 3193 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 66:
#line 475 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = type_new_nonencapsulated_union((yyvsp[0].str), FALSE, NULL); }
#line 3199 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 67:
#line 476 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = (yyvsp[0].type); (yyval.type)->attrs = check_enum_attrs((yyvsp[-1].attr_list)); }
#line 3205 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 68:
#line 477 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = (yyvsp[0].type); (yyval.type)->attrs = check_struct_attrs((yyvsp[-1].attr_list)); }
#line 3211 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 69:
#line 478 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = (yyvsp[0].type); (yyval.type)->attrs = check_union_attrs((yyvsp[-1].attr_list)); }
#line 3217 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 70:
#line 481 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[-1].str); }
#line 3223 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 71:
#line 483 "tools/widl/parser.y" /* yacc.c:1646  */
    { assert(yychar == YYEMPTY);
						  (yyval.import) = xmalloc(sizeof(struct _import_t));
						  (yyval.import)->name = (yyvsp[-1].str);
						  (yyval.import)->import_performed = do_import((yyvsp[-1].str));
						  if (!(yyval.import)->import_performed) yychar = aEOF;
						}
#line 3234 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 72:
#line 491 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[-2].import)->name;
						  if ((yyvsp[-2].import)->import_performed) pop_import();
						  free((yyvsp[-2].import));
						}
#line 3243 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 73:
#line 498 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[-2].str); if(!parse_only) add_importlib((yyvsp[-2].str), current_typelib); }
#line 3249 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 74:
#line 501 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 3255 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 75:
#line 503 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.typelib) = make_library((yyvsp[-1].str), check_library_attrs((yyvsp[-1].str), (yyvsp[-2].attr_list)));
						  if (!parse_only && do_typelib) current_typelib = (yyval.typelib);
						}
#line 3263 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 76:
#line 508 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.typelib) = (yyvsp[-3].typelib); (yyval.typelib)->stmts = (yyvsp[-2].stmt_list); }
#line 3269 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 77:
#line 511 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.var_list) = NULL; }
#line 3275 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 79:
#line 515 "tools/widl/parser.y" /* yacc.c:1646  */
    { check_arg_attrs((yyvsp[0].var)); (yyval.var_list) = append_var( NULL, (yyvsp[0].var) ); }
#line 3281 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 80:
#line 516 "tools/widl/parser.y" /* yacc.c:1646  */
    { check_arg_attrs((yyvsp[0].var)); (yyval.var_list) = append_var( (yyvsp[-2].var_list), (yyvsp[0].var) ); }
#line 3287 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 82:
#line 520 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.var_list) = append_var( (yyvsp[-2].var_list), make_var(strdup("...")) ); }
#line 3293 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 83:
#line 524 "tools/widl/parser.y" /* yacc.c:1646  */
    { if ((yyvsp[-1].declspec)->stgclass != STG_NONE && (yyvsp[-1].declspec)->stgclass != STG_REGISTER)
						    error_loc("invalid storage class for function parameter\n");
						  (yyval.var) = declare_var((yyvsp[-2].attr_list), (yyvsp[-1].declspec), (yyvsp[0].declarator), TRUE);
						  free((yyvsp[-1].declspec)); free((yyvsp[0].declarator));
						}
#line 3303 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 84:
#line 529 "tools/widl/parser.y" /* yacc.c:1646  */
    { if ((yyvsp[-1].declspec)->stgclass != STG_NONE && (yyvsp[-1].declspec)->stgclass != STG_REGISTER)
						    error_loc("invalid storage class for function parameter\n");
						  (yyval.var) = declare_var(NULL, (yyvsp[-1].declspec), (yyvsp[0].declarator), TRUE);
						  free((yyvsp[-1].declspec)); free((yyvsp[0].declarator));
						}
#line 3313 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 85:
#line 536 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.expr) = (yyvsp[-1].expr);
						  if (!(yyval.expr)->is_const || (yyval.expr)->cval <= 0)
						      error_loc("array dimension is not a positive integer constant\n");
						}
#line 3322 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 86:
#line 540 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.expr) = make_expr(EXPR_VOID); }
#line 3328 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 87:
#line 541 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.expr) = make_expr(EXPR_VOID); }
#line 3334 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 88:
#line 544 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr_list) = NULL; }
#line 3340 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 90:
#line 549 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr_list) = (yyvsp[-1].attr_list); }
#line 3346 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 91:
#line 552 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr_list) = append_attr( NULL, (yyvsp[0].attr) ); }
#line 3352 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 92:
#line 553 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr_list) = append_attr( (yyvsp[-2].attr_list), (yyvsp[0].attr) ); }
#line 3358 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 93:
#line 554 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr_list) = append_attr( (yyvsp[-3].attr_list), (yyvsp[0].attr) ); }
#line 3364 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 94:
#line 557 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.str_list) = append_str( NULL, (yyvsp[0].str) ); }
#line 3370 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 95:
#line 558 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.str_list) = append_str( (yyvsp[-2].str_list), (yyvsp[0].str) ); }
#line 3376 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 96:
#line 562 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.num) = MARSHALING_AGILE; }
#line 3382 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 97:
#line 563 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.num) = MARSHALING_NONE; }
#line 3388 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 98:
#line 564 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.num) = MARSHALING_STANDARD; }
#line 3394 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 99:
#line 568 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.num) = MAKEVERSION(0, (yyvsp[0].num)); }
#line 3400 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 100:
#line 569 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.num) = MAKEVERSION((yyvsp[0].num), (yyvsp[-2].num)); }
#line 3406 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 101:
#line 572 "tools/widl/parser.y" /* yacc.c:1646  */
    { if ((yyvsp[-2].declspec)->type->type_type != TYPE_APICONTRACT)
						      error_loc("type %s is not an apicontract\n", (yyvsp[-2].declspec)->type->name);
						  (yyval.expr) = make_exprl(EXPR_NUM, (yyvsp[0].num));
						  (yyval.expr) = make_exprt(EXPR_GTREQL, declare_var(NULL, (yyvsp[-2].declspec), make_declarator(NULL), 0), (yyval.expr));
						}
#line 3416 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 102:
#line 578 "tools/widl/parser.y" /* yacc.c:1646  */
    { if ((yyvsp[-2].declspec)->type->type_type != TYPE_INTERFACE)
						      error_loc("type %s is not an interface\n", (yyvsp[-2].declspec)->type->name);
						  (yyval.expr) = make_exprt(EXPR_MEMBER, declare_var(NULL, (yyvsp[-2].declspec), make_declarator(NULL), 0), (yyvsp[0].expr));
						}
#line 3425 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 103:
#line 583 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = NULL; }
#line 3431 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 104:
#line 584 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = make_attrp(ATTR_ACTIVATABLE, (yyvsp[-1].expr)); }
#line 3437 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 105:
#line 585 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = make_attr(ATTR_AGGREGATABLE); }
#line 3443 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 106:
#line 586 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = make_attrp(ATTR_ANNOTATION, (yyvsp[-1].str)); }
#line 3449 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 107:
#line 587 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = make_attr(ATTR_APPOBJECT); }
#line 3455 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 108:
#line 588 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = make_attr(ATTR_ASYNC); }
#line 3461 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 109:
#line 589 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = make_attr(ATTR_AUTO_HANDLE); }
#line 3467 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 110:
#line 590 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = make_attr(ATTR_BINDABLE); }
#line 3473 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 111:
#line 591 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = make_attr(ATTR_BROADCAST); }
#line 3479 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 112:
#line 592 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = make_attrp(ATTR_CALLAS, (yyvsp[-1].var)); }
#line 3485 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 113:
#line 593 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = make_attrp(ATTR_CASE, (yyvsp[-1].expr_list)); }
#line 3491 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 114:
#line 594 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = make_attr(ATTR_CODE); }
#line 3497 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 115:
#line 595 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = make_attr(ATTR_COMMSTATUS); }
#line 3503 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 116:
#line 596 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = make_attrv(ATTR_CONTEXTHANDLE, 0); }
#line 3509 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 117:
#line 597 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = make_attrv(ATTR_CONTEXTHANDLE, 0); /* RPC_CONTEXT_HANDLE_DONT_SERIALIZE */ }
#line 3515 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 118:
#line 598 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = make_attrv(ATTR_CONTEXTHANDLE, 0); /* RPC_CONTEXT_HANDLE_SERIALIZE */ }
#line 3521 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 119:
#line 599 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = make_attrp(ATTR_CONTRACT, (yyvsp[-1].expr)); }
#line 3527 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 120:
#line 600 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = make_attrv(ATTR_CONTRACTVERSION, (yyvsp[-1].num)); }
#line 3533 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 121:
#line 601 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = make_attr(ATTR_CONTROL); }
#line 3539 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 122:
#line 602 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = make_custom_attr((yyvsp[-3].uuid), (yyvsp[-1].expr)); }
#line 3545 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 123:
#line 603 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = make_attr(ATTR_DECODE); }
#line 3551 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 124:
#line 604 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = make_attr(ATTR_DEFAULT); }
#line 3557 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 125:
#line 605 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = make_attr(ATTR_DEFAULTBIND); }
#line 3563 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 126:
#line 606 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = make_attr(ATTR_DEFAULTCOLLELEM); }
#line 3569 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 127:
#line 607 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = make_attrp(ATTR_DEFAULTVALUE, (yyvsp[-1].expr)); }
#line 3575 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 128:
#line 608 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = make_attr(ATTR_DEFAULTVTABLE); }
#line 3581 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 129:
#line 609 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = make_attr(ATTR_DISABLECONSISTENCYCHECK); }
#line 3587 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 130:
#line 610 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = make_attr(ATTR_DISPLAYBIND); }
#line 3593 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 131:
#line 611 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = make_attrp(ATTR_DLLNAME, (yyvsp[-1].str)); }
#line 3599 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 132:
#line 612 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = make_attr(ATTR_DUAL); }
#line 3605 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 133:
#line 613 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = make_attr(ATTR_ENABLEALLOCATE); }
#line 3611 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 134:
#line 614 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = make_attr(ATTR_ENCODE); }
#line 3617 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 135:
#line 615 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = make_attrp(ATTR_ENDPOINT, (yyvsp[-1].str_list)); }
#line 3623 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 136:
#line 616 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = make_attrp(ATTR_ENTRY, (yyvsp[-1].expr)); }
#line 3629 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 137:
#line 617 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = make_attr(ATTR_EVENTADD); }
#line 3635 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 138:
#line 618 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = make_attr(ATTR_EVENTREMOVE); }
#line 3641 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 139:
#line 619 "tools/widl/parser.y" /* yacc.c:1646  */
    { if ((yyvsp[-1].declspec)->type->type_type != TYPE_RUNTIMECLASS)
						      error_loc("type %s is not a runtimeclass\n", (yyvsp[-1].declspec)->type->name);
						  (yyval.attr) = make_attrp(ATTR_EXCLUSIVETO, (yyvsp[-1].declspec)->type); }
#line 3649 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 140:
#line 622 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = make_attr(ATTR_EXPLICIT_HANDLE); }
#line 3655 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 141:
#line 623 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = make_attr(ATTR_FAULTSTATUS); }
#line 3661 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 142:
#line 624 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = make_attr(ATTR_FLAGS); }
#line 3667 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 143:
#line 625 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = make_attr(ATTR_FORCEALLOCATE); }
#line 3673 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 144:
#line 626 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = make_attr(ATTR_HANDLE); }
#line 3679 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 145:
#line 627 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = make_attrp(ATTR_HELPCONTEXT, (yyvsp[-1].expr)); }
#line 3685 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 146:
#line 628 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = make_attrp(ATTR_HELPFILE, (yyvsp[-1].str)); }
#line 3691 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 147:
#line 629 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = make_attrp(ATTR_HELPSTRING, (yyvsp[-1].str)); }
#line 3697 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 148:
#line 630 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = make_attrp(ATTR_HELPSTRINGCONTEXT, (yyvsp[-1].expr)); }
#line 3703 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 149:
#line 631 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = make_attrp(ATTR_HELPSTRINGDLL, (yyvsp[-1].str)); }
#line 3709 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 150:
#line 632 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = make_attr(ATTR_HIDDEN); }
#line 3715 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 151:
#line 633 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = make_attrp(ATTR_ID, (yyvsp[-1].expr)); }
#line 3721 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 152:
#line 634 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = make_attr(ATTR_IDEMPOTENT); }
#line 3727 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 153:
#line 635 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = make_attr(ATTR_IGNORE); }
#line 3733 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 154:
#line 636 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = make_attrp(ATTR_IIDIS, (yyvsp[-1].expr)); }
#line 3739 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 155:
#line 637 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = make_attr(ATTR_IMMEDIATEBIND); }
#line 3745 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 156:
#line 638 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = make_attrp(ATTR_IMPLICIT_HANDLE, (yyvsp[-1].var)); }
#line 3751 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 157:
#line 639 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = make_attr(ATTR_IN); }
#line 3757 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 158:
#line 640 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = make_attr(ATTR_INPUTSYNC); }
#line 3763 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 159:
#line 641 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = make_attrp(ATTR_LENGTHIS, (yyvsp[-1].expr_list)); }
#line 3769 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 160:
#line 642 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = make_attrp(ATTR_LIBLCID, (yyvsp[-1].expr)); }
#line 3775 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 161:
#line 643 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = make_attr(ATTR_PARAMLCID); }
#line 3781 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 162:
#line 644 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = make_attr(ATTR_LICENSED); }
#line 3787 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 163:
#line 645 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = make_attr(ATTR_LOCAL); }
#line 3793 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 164:
#line 647 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = make_attrv(ATTR_MARSHALING_BEHAVIOR, (yyvsp[-1].num)); }
#line 3799 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 165:
#line 648 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = make_attr(ATTR_MAYBE); }
#line 3805 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 166:
#line 649 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = make_attr(ATTR_MESSAGE); }
#line 3811 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 167:
#line 650 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = make_attr(ATTR_NOCODE); }
#line 3817 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 168:
#line 651 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = make_attr(ATTR_NONBROWSABLE); }
#line 3823 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 169:
#line 652 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = make_attr(ATTR_NONCREATABLE); }
#line 3829 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 170:
#line 653 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = make_attr(ATTR_NONEXTENSIBLE); }
#line 3835 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 171:
#line 654 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = make_attr(ATTR_NOTIFY); }
#line 3841 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 172:
#line 655 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = make_attr(ATTR_NOTIFYFLAG); }
#line 3847 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 173:
#line 656 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = make_attr(ATTR_OBJECT); }
#line 3853 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 174:
#line 657 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = make_attr(ATTR_ODL); }
#line 3859 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 175:
#line 658 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = make_attr(ATTR_OLEAUTOMATION); }
#line 3865 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 176:
#line 659 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = make_attrp(ATTR_OPTIMIZE, (yyvsp[-1].str)); }
#line 3871 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 177:
#line 660 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = make_attr(ATTR_OPTIONAL); }
#line 3877 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 178:
#line 661 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = make_attr(ATTR_OUT); }
#line 3883 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 179:
#line 662 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = make_attr(ATTR_PARTIALIGNORE); }
#line 3889 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 180:
#line 663 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = make_attrv(ATTR_POINTERDEFAULT, (yyvsp[-1].num)); }
#line 3895 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 181:
#line 664 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = make_attrp(ATTR_PROGID, (yyvsp[-1].str)); }
#line 3901 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 182:
#line 665 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = make_attr(ATTR_PROPGET); }
#line 3907 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 183:
#line 666 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = make_attr(ATTR_PROPPUT); }
#line 3913 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 184:
#line 667 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = make_attr(ATTR_PROPPUTREF); }
#line 3919 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 185:
#line 668 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = make_attr(ATTR_PROXY); }
#line 3925 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 186:
#line 669 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = make_attr(ATTR_PUBLIC); }
#line 3931 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 187:
#line 671 "tools/widl/parser.y" /* yacc.c:1646  */
    { expr_list_t *list = append_expr( NULL, (yyvsp[-3].expr) );
						  list = append_expr( list, (yyvsp[-1].expr) );
						  (yyval.attr) = make_attrp(ATTR_RANGE, list); }
#line 3939 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 188:
#line 674 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = make_attr(ATTR_READONLY); }
#line 3945 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 189:
#line 675 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = make_attrp(ATTR_REPRESENTAS, (yyvsp[-1].type)); }
#line 3951 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 190:
#line 676 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = make_attr(ATTR_REQUESTEDIT); }
#line 3957 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 191:
#line 677 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = make_attr(ATTR_RESTRICTED); }
#line 3963 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 192:
#line 678 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = make_attr(ATTR_RETVAL); }
#line 3969 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 193:
#line 679 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = make_attrp(ATTR_SIZEIS, (yyvsp[-1].expr_list)); }
#line 3975 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 194:
#line 680 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = make_attr(ATTR_SOURCE); }
#line 3981 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 195:
#line 681 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = make_attrp(ATTR_STATIC, (yyvsp[-1].expr)); }
#line 3987 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 196:
#line 682 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = make_attr(ATTR_STRICTCONTEXTHANDLE); }
#line 3993 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 197:
#line 683 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = make_attr(ATTR_STRING); }
#line 3999 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 198:
#line 684 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = make_attrp(ATTR_SWITCHIS, (yyvsp[-1].expr)); }
#line 4005 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 199:
#line 685 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = make_attrp(ATTR_SWITCHTYPE, (yyvsp[-1].type)); }
#line 4011 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 200:
#line 686 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = make_attrp(ATTR_TRANSMITAS, (yyvsp[-1].type)); }
#line 4017 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 201:
#line 687 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = make_attrv(ATTR_THREADING, (yyvsp[-1].num)); }
#line 4023 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 202:
#line 688 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = make_attr(ATTR_UIDEFAULT); }
#line 4029 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 203:
#line 689 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = make_attr(ATTR_USESGETLASTERROR); }
#line 4035 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 204:
#line 690 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = make_attrp(ATTR_USERMARSHAL, (yyvsp[-1].type)); }
#line 4041 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 205:
#line 691 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = make_attrp(ATTR_UUID, (yyvsp[-1].uuid)); }
#line 4047 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 206:
#line 692 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = make_attrp(ATTR_ASYNCUUID, (yyvsp[-1].uuid)); }
#line 4053 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 207:
#line 693 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = make_attr(ATTR_V1ENUM); }
#line 4059 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 208:
#line 694 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = make_attr(ATTR_VARARG); }
#line 4065 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 209:
#line 695 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = make_attrv(ATTR_VERSION, (yyvsp[-1].num)); }
#line 4071 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 210:
#line 696 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = make_attrp(ATTR_VIPROGID, (yyvsp[-1].str)); }
#line 4077 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 211:
#line 697 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = make_attrp(ATTR_WIREMARSHAL, (yyvsp[-1].type)); }
#line 4083 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 212:
#line 698 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = make_attrv(ATTR_POINTERTYPE, (yyvsp[0].num)); }
#line 4089 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 214:
#line 703 "tools/widl/parser.y" /* yacc.c:1646  */
    { if (!is_valid_uuid((yyvsp[0].str)))
						    error_loc("invalid UUID: %s\n", (yyvsp[0].str));
						  (yyval.uuid) = parse_uuid((yyvsp[0].str)); }
#line 4097 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 215:
#line 708 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.str) = xstrdup("__cdecl"); }
#line 4103 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 216:
#line 709 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.str) = xstrdup("__fastcall"); }
#line 4109 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 217:
#line 710 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.str) = xstrdup("__pascal"); }
#line 4115 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 218:
#line 711 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.str) = xstrdup("__stdcall"); }
#line 4121 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 219:
#line 714 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.var_list) = NULL; }
#line 4127 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 220:
#line 715 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.var_list) = append_var( (yyvsp[-1].var_list), (yyvsp[0].var) ); }
#line 4133 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 221:
#line 718 "tools/widl/parser.y" /* yacc.c:1646  */
    { attr_t *a = make_attrp(ATTR_CASE, append_expr( NULL, (yyvsp[-2].expr) ));
						  (yyval.var) = (yyvsp[0].var); if (!(yyval.var)) (yyval.var) = make_var(NULL);
						  (yyval.var)->attrs = append_attr( (yyval.var)->attrs, a );
						}
#line 4142 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 222:
#line 722 "tools/widl/parser.y" /* yacc.c:1646  */
    { attr_t *a = make_attr(ATTR_DEFAULT);
						  (yyval.var) = (yyvsp[0].var); if (!(yyval.var)) (yyval.var) = make_var(NULL);
						  (yyval.var)->attrs = append_attr( (yyval.var)->attrs, a );
						}
#line 4151 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 223:
#line 728 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.var_list) = NULL; }
#line 4157 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 224:
#line 729 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.var_list) = (yyvsp[-1].var_list); }
#line 4163 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 226:
#line 733 "tools/widl/parser.y" /* yacc.c:1646  */
    { if (!(yyvsp[0].var)->eval)
						    (yyvsp[0].var)->eval = make_exprl(EXPR_NUM, 0 /* default for first enum entry */);
                                                  (yyval.var_list) = append_var( NULL, (yyvsp[0].var) );
						}
#line 4172 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 227:
#line 737 "tools/widl/parser.y" /* yacc.c:1646  */
    { if (!(yyvsp[0].var)->eval)
                                                  {
                                                    var_t *last = LIST_ENTRY( list_tail((yyval.var_list)), var_t, entry );
                                                    enum expr_type type = EXPR_NUM;
                                                    if (last->eval->type == EXPR_HEXNUM) type = EXPR_HEXNUM;
                                                    if (last->eval->cval + 1 < 0) type = EXPR_HEXNUM;
                                                    (yyvsp[0].var)->eval = make_exprl(type, last->eval->cval + 1);
                                                  }
                                                  (yyval.var_list) = append_var( (yyvsp[-2].var_list), (yyvsp[0].var) );
						}
#line 4187 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 228:
#line 749 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.var) = (yyvsp[0].var);
						  (yyval.var)->attrs = check_enum_member_attrs((yyvsp[-1].attr_list));
						}
#line 4195 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 229:
#line 754 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.var) = reg_const((yyvsp[-2].var));
						  (yyval.var)->eval = (yyvsp[0].expr);
                                                  (yyval.var)->declspec.type = type_new_int(TYPE_BASIC_INT, 0);
						}
#line 4204 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 230:
#line 758 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.var) = reg_const((yyvsp[0].var));
                                                  (yyval.var)->declspec.type = type_new_int(TYPE_BASIC_INT, 0);
						}
#line 4212 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 231:
#line 763 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = type_new_enum((yyvsp[-3].str), current_namespace, TRUE, (yyvsp[-1].var_list)); }
#line 4218 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 232:
#line 766 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.expr_list) = append_expr( NULL, (yyvsp[0].expr) ); }
#line 4224 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 233:
#line 767 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.expr_list) = append_expr( (yyvsp[-2].expr_list), (yyvsp[0].expr) ); }
#line 4230 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 234:
#line 770 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.expr) = make_expr(EXPR_VOID); }
#line 4236 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 236:
#line 774 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.expr) = make_exprl(EXPR_NUM, (yyvsp[0].num)); }
#line 4242 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 237:
#line 775 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.expr) = make_exprl(EXPR_HEXNUM, (yyvsp[0].num)); }
#line 4248 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 238:
#line 776 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.expr) = make_exprd(EXPR_DOUBLE, (yyvsp[0].dbl)); }
#line 4254 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 239:
#line 777 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.expr) = make_exprl(EXPR_TRUEFALSE, 0); }
#line 4260 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 240:
#line 778 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.expr) = make_exprl(EXPR_NUM, 0); }
#line 4266 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 241:
#line 779 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.expr) = make_exprl(EXPR_TRUEFALSE, 1); }
#line 4272 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 242:
#line 780 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.expr) = make_exprs(EXPR_STRLIT, (yyvsp[0].str)); }
#line 4278 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 243:
#line 781 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.expr) = make_exprs(EXPR_WSTRLIT, (yyvsp[0].str)); }
#line 4284 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 244:
#line 782 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.expr) = make_exprs(EXPR_CHARCONST, (yyvsp[0].str)); }
#line 4290 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 245:
#line 783 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.expr) = make_exprs(EXPR_IDENTIFIER, (yyvsp[0].str)); }
#line 4296 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 246:
#line 784 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.expr) = make_expr3(EXPR_COND, (yyvsp[-4].expr), (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 4302 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 247:
#line 785 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.expr) = make_expr2(EXPR_LOGOR, (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 4308 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 248:
#line 786 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.expr) = make_expr2(EXPR_LOGAND, (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 4314 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 249:
#line 787 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.expr) = make_expr2(EXPR_OR , (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 4320 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 250:
#line 788 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.expr) = make_expr2(EXPR_XOR, (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 4326 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 251:
#line 789 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.expr) = make_expr2(EXPR_AND, (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 4332 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 252:
#line 790 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.expr) = make_expr2(EXPR_EQUALITY, (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 4338 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 253:
#line 791 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.expr) = make_expr2(EXPR_INEQUALITY, (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 4344 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 254:
#line 792 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.expr) = make_expr2(EXPR_GTR, (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 4350 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 255:
#line 793 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.expr) = make_expr2(EXPR_LESS, (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 4356 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 256:
#line 794 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.expr) = make_expr2(EXPR_GTREQL, (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 4362 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 257:
#line 795 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.expr) = make_expr2(EXPR_LESSEQL, (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 4368 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 258:
#line 796 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.expr) = make_expr2(EXPR_SHL, (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 4374 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 259:
#line 797 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.expr) = make_expr2(EXPR_SHR, (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 4380 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 260:
#line 798 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.expr) = make_expr2(EXPR_ADD, (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 4386 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 261:
#line 799 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.expr) = make_expr2(EXPR_SUB, (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 4392 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 262:
#line 800 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.expr) = make_expr2(EXPR_MOD, (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 4398 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 263:
#line 801 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.expr) = make_expr2(EXPR_MUL, (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 4404 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 264:
#line 802 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.expr) = make_expr2(EXPR_DIV, (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 4410 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 265:
#line 803 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.expr) = make_expr1(EXPR_LOGNOT, (yyvsp[0].expr)); }
#line 4416 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 266:
#line 804 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.expr) = make_expr1(EXPR_NOT, (yyvsp[0].expr)); }
#line 4422 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 267:
#line 805 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.expr) = make_expr1(EXPR_POS, (yyvsp[0].expr)); }
#line 4428 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 268:
#line 806 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.expr) = make_expr1(EXPR_NEG, (yyvsp[0].expr)); }
#line 4434 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 269:
#line 807 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.expr) = make_expr1(EXPR_ADDRESSOF, (yyvsp[0].expr)); }
#line 4440 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 270:
#line 808 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.expr) = make_expr1(EXPR_PPTR, (yyvsp[0].expr)); }
#line 4446 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 271:
#line 809 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.expr) = make_expr2(EXPR_MEMBER, make_expr1(EXPR_PPTR, (yyvsp[-2].expr)), make_exprs(EXPR_IDENTIFIER, (yyvsp[0].str))); }
#line 4452 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 272:
#line 810 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.expr) = make_expr2(EXPR_MEMBER, (yyvsp[-2].expr), make_exprs(EXPR_IDENTIFIER, (yyvsp[0].str))); }
#line 4458 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 273:
#line 812 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.expr) = make_exprt(EXPR_CAST, declare_var(NULL, (yyvsp[-3].declspec), (yyvsp[-2].declarator), 0), (yyvsp[0].expr)); free((yyvsp[-3].declspec)); free((yyvsp[-2].declarator)); }
#line 4464 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 274:
#line 814 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.expr) = make_exprt(EXPR_SIZEOF, declare_var(NULL, (yyvsp[-2].declspec), (yyvsp[-1].declarator), 0), NULL); free((yyvsp[-2].declspec)); free((yyvsp[-1].declarator)); }
#line 4470 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 275:
#line 815 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.expr) = make_expr2(EXPR_ARRAY, (yyvsp[-3].expr), (yyvsp[-1].expr)); }
#line 4476 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 276:
#line 816 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.expr) = (yyvsp[-1].expr); }
#line 4482 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 277:
#line 819 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.expr_list) = append_expr( NULL, (yyvsp[0].expr) ); }
#line 4488 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 278:
#line 820 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.expr_list) = append_expr( (yyvsp[-2].expr_list), (yyvsp[0].expr) ); }
#line 4494 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 279:
#line 823 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.expr) = (yyvsp[0].expr);
						  if (!(yyval.expr)->is_const)
						      error_loc("expression is not an integer constant\n");
						}
#line 4503 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 280:
#line 829 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.expr) = (yyvsp[0].expr);
						  if (!(yyval.expr)->is_const && (yyval.expr)->type != EXPR_STRLIT && (yyval.expr)->type != EXPR_WSTRLIT)
						      error_loc("expression is not constant\n");
						}
#line 4512 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 281:
#line 835 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.var_list) = NULL; }
#line 4518 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 282:
#line 836 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.var_list) = append_var_list((yyvsp[-1].var_list), (yyvsp[0].var_list)); }
#line 4524 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 283:
#line 840 "tools/widl/parser.y" /* yacc.c:1646  */
    { const char *first = LIST_ENTRY(list_head((yyvsp[-1].declarator_list)), declarator_t, entry)->var->name;
						  check_field_attrs(first, (yyvsp[-3].attr_list));
						  (yyval.var_list) = set_var_types((yyvsp[-3].attr_list), (yyvsp[-2].declspec), (yyvsp[-1].declarator_list));
						}
#line 4533 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 284:
#line 844 "tools/widl/parser.y" /* yacc.c:1646  */
    { var_t *v = make_var(NULL);
						  v->declspec.type = (yyvsp[-1].type); v->attrs = (yyvsp[-2].attr_list);
						  (yyval.var_list) = append_var(NULL, v);
						}
#line 4542 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 285:
#line 851 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.var) = (yyvsp[-1].var); }
#line 4548 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 286:
#line 852 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.var) = make_var(NULL); (yyval.var)->attrs = (yyvsp[-1].attr_list); }
#line 4554 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 287:
#line 855 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.var_list) = NULL; }
#line 4560 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 288:
#line 856 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.var_list) = append_var( (yyvsp[-1].var_list), (yyvsp[0].var) ); }
#line 4566 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 289:
#line 860 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.var) = (yyvsp[-1].var); }
#line 4572 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 290:
#line 861 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.var) = NULL; }
#line 4578 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 291:
#line 864 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.var) = declare_var(check_field_attrs((yyvsp[0].declarator)->var->name, (yyvsp[-2].attr_list)),
						                (yyvsp[-1].declspec), (yyvsp[0].declarator), FALSE);
						  free((yyvsp[0].declarator));
						}
#line 4587 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 292:
#line 868 "tools/widl/parser.y" /* yacc.c:1646  */
    { var_t *v = make_var(NULL);
						  v->declspec.type = (yyvsp[0].type); v->attrs = (yyvsp[-1].attr_list);
						  (yyval.var) = v;
						}
#line 4596 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 293:
#line 874 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.var) = (yyvsp[0].var);
						  if (type_get_type((yyval.var)->declspec.type) != TYPE_FUNCTION)
						    error_loc("only methods may be declared inside the methods section of a dispinterface\n");
						  check_function_attrs((yyval.var)->name, (yyval.var)->attrs);
						}
#line 4606 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 294:
#line 883 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.var) = declare_var((yyvsp[-2].attr_list), (yyvsp[-1].declspec), (yyvsp[0].declarator), FALSE);
						  free((yyvsp[0].declarator));
						}
#line 4614 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 295:
#line 886 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.var) = declare_var(NULL, (yyvsp[-1].declspec), (yyvsp[0].declarator), FALSE);
						  free((yyvsp[0].declarator));
						}
#line 4622 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 296:
#line 891 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.var) = NULL; }
#line 4628 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 298:
#line 895 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 4634 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 302:
#line 903 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.var) = make_var((yyvsp[0].str)); }
#line 4640 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 303:
#line 906 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = find_type_or_error(NULL, (yyvsp[0].str)); }
#line 4646 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 304:
#line 907 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = find_type_or_error(NULL, (yyvsp[0].str)); }
#line 4652 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 306:
#line 909 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = type_new_int(type_basic_get_type((yyvsp[0].type)), -1); }
#line 4658 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 307:
#line 910 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = type_new_int(type_basic_get_type((yyvsp[0].type)), 1); }
#line 4664 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 308:
#line 911 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = type_new_int(TYPE_BASIC_INT, 1); }
#line 4670 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 309:
#line 912 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = find_type_or_error(NULL, (yyvsp[0].str)); }
#line 4676 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 310:
#line 913 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = find_type_or_error(NULL, (yyvsp[0].str)); }
#line 4682 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 311:
#line 914 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = find_type_or_error(NULL, (yyvsp[0].str)); }
#line 4688 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 312:
#line 915 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = find_type_or_error(NULL, (yyvsp[0].str)); }
#line 4694 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 313:
#line 916 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = find_type_or_error(NULL, (yyvsp[0].str)); }
#line 4700 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 316:
#line 923 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = type_new_int(TYPE_BASIC_INT, 0); }
#line 4706 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 317:
#line 924 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = type_new_int(TYPE_BASIC_INT16, 0); }
#line 4712 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 318:
#line 925 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = type_new_int(TYPE_BASIC_INT8, 0); }
#line 4718 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 319:
#line 926 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = type_new_int(TYPE_BASIC_LONG, 0); }
#line 4724 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 320:
#line 927 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = type_new_int(TYPE_BASIC_HYPER, 0); }
#line 4730 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 321:
#line 928 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = type_new_int(TYPE_BASIC_INT64, 0); }
#line 4736 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 322:
#line 929 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = type_new_int(TYPE_BASIC_CHAR, 0); }
#line 4742 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 323:
#line 930 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = type_new_int(TYPE_BASIC_INT32, 0); }
#line 4748 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 324:
#line 931 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = type_new_int(TYPE_BASIC_INT3264, 0); }
#line 4754 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 325:
#line 935 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.namespace) = find_namespace_or_error(&global_namespace, (yyvsp[-1].str)); }
#line 4760 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 326:
#line 936 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.namespace) = find_namespace_or_error((yyvsp[-2].namespace), (yyvsp[-1].str)); }
#line 4766 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 327:
#line 940 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = find_type_or_error(current_namespace, (yyvsp[0].str)); }
#line 4772 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 328:
#line 941 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = find_type_or_error((yyvsp[-1].namespace), (yyvsp[0].str)); }
#line 4778 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 329:
#line 945 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = find_parameterized_type((yyvsp[-3].type), (yyvsp[-1].typeref_list)); }
#line 4784 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 330:
#line 949 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = (yyvsp[0].type); }
#line 4790 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 331:
#line 950 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = (yyvsp[0].type); }
#line 4796 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 332:
#line 951 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = type_new_pointer((yyvsp[-1].type)); }
#line 4802 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 333:
#line 952 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = (yyvsp[0].type); }
#line 4808 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 334:
#line 953 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = type_new_pointer((yyvsp[-1].type)); }
#line 4814 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 335:
#line 957 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.typeref_list) = append_typeref(NULL, make_typeref((yyvsp[0].type))); }
#line 4820 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 336:
#line 959 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.typeref_list) = append_typeref((yyvsp[-2].typeref_list), make_typeref((yyvsp[0].type))); }
#line 4826 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 337:
#line 962 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = type_coclass_declare((yyvsp[0].str)); }
#line 4832 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 338:
#line 966 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = type_coclass_define((yyvsp[-4].type), (yyvsp[-5].attr_list), (yyvsp[-2].typeref_list)); }
#line 4838 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 339:
#line 969 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = type_runtimeclass_declare((yyvsp[0].str), current_namespace); }
#line 4844 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 340:
#line 973 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = type_runtimeclass_define((yyvsp[-4].type), (yyvsp[-5].attr_list), (yyvsp[-2].typeref_list)); }
#line 4850 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 341:
#line 976 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = type_apicontract_declare((yyvsp[0].str), current_namespace); }
#line 4856 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 342:
#line 980 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = type_apicontract_define((yyvsp[-3].type), (yyvsp[-4].attr_list)); }
#line 4862 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 343:
#line 983 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 4868 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 344:
#line 986 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.typeref_list) = NULL; }
#line 4874 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 345:
#line 987 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.typeref_list) = append_typeref( (yyvsp[-1].typeref_list), (yyvsp[0].typeref) ); }
#line 4880 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 346:
#line 991 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.typeref) = make_typeref((yyvsp[-1].type)); (yyval.typeref)->attrs = (yyvsp[-2].attr_list); }
#line 4886 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 347:
#line 992 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.typeref) = make_typeref((yyvsp[-1].type)); (yyval.typeref)->attrs = (yyvsp[-2].attr_list); }
#line 4892 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 348:
#line 995 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = type_dispinterface_declare((yyvsp[0].str)); }
#line 4898 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 349:
#line 998 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr_list) = append_attr((yyvsp[0].attr_list), make_attr(ATTR_DISPINTERFACE)); }
#line 4904 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 350:
#line 1001 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.var_list) = NULL; }
#line 4910 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 351:
#line 1002 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.var_list) = append_var( (yyvsp[-2].var_list), (yyvsp[-1].var) ); }
#line 4916 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 352:
#line 1005 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.var_list) = NULL; }
#line 4922 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 353:
#line 1006 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.var_list) = append_var( (yyvsp[-2].var_list), (yyvsp[-1].var) ); }
#line 4928 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 354:
#line 1011 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = type_dispinterface_define((yyvsp[-4].type), (yyvsp[-5].attr_list), (yyvsp[-2].var_list), (yyvsp[-1].var_list)); }
#line 4934 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 355:
#line 1013 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = type_dispinterface_define_from_iface((yyvsp[-4].type), (yyvsp[-5].attr_list), (yyvsp[-2].type)); }
#line 4940 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 356:
#line 1016 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = NULL; }
#line 4946 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 357:
#line 1017 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = (yyvsp[0].type); }
#line 4952 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 358:
#line 1018 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = (yyvsp[0].type); }
#line 4958 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 359:
#line 1021 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = get_type(TYPE_PARAMETER, (yyvsp[0].str), parameters_namespace, 0); }
#line 4964 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 360:
#line 1025 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.typeref_list) = append_typeref(NULL, make_typeref((yyvsp[0].type))); }
#line 4970 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 361:
#line 1026 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.typeref_list) = append_typeref((yyvsp[-2].typeref_list), make_typeref((yyvsp[0].type))); }
#line 4976 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 362:
#line 1030 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = type_interface_declare((yyvsp[0].str), current_namespace); }
#line 4982 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 363:
#line 1031 "tools/widl/parser.y" /* yacc.c:1646  */
    { push_parameters_namespace((yyvsp[-1].str)); }
#line 4988 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 364:
#line 1031 "tools/widl/parser.y" /* yacc.c:1646  */
    { pop_parameters_namespace((yyvsp[-3].str)); }
#line 4994 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 365:
#line 1032 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = type_parameterized_interface_declare((yyvsp[-5].str), current_namespace, (yyvsp[-2].typeref_list)); }
#line 5000 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 366:
#line 1036 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = type_delegate_declare((yyvsp[-4].var)->name, current_namespace);
						  (yyval.type) = type_delegate_define((yyval.type), (yyvsp[-7].attr_list), append_statement(NULL, make_statement_delegate((yyvsp[-5].type), (yyvsp[-2].var_list))));
						}
#line 5008 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 367:
#line 1040 "tools/widl/parser.y" /* yacc.c:1646  */
    { push_parameters_namespace((yyvsp[-1].var)->name); }
#line 5014 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 368:
#line 1041 "tools/widl/parser.y" /* yacc.c:1646  */
    { pop_parameters_namespace((yyvsp[-7].var)->name); }
#line 5020 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 369:
#line 1042 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = type_parameterized_delegate_declare((yyvsp[-9].var)->name, current_namespace, (yyvsp[-6].typeref_list));
						  (yyval.type) = type_parameterized_delegate_define((yyval.type), (yyvsp[-12].attr_list), append_statement(NULL, make_statement_delegate((yyvsp[-10].type), (yyvsp[-3].var_list))));
						}
#line 5028 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 370:
#line 1048 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.typeref_list) = append_typeref(NULL, make_typeref((yyvsp[0].type))); }
#line 5034 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 371:
#line 1049 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.typeref_list) = append_typeref(NULL, make_typeref((yyvsp[0].type))); }
#line 5040 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 372:
#line 1050 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.typeref_list) = append_typeref((yyvsp[-2].typeref_list), make_typeref((yyvsp[0].type))); }
#line 5046 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 373:
#line 1051 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.typeref_list) = append_typeref((yyvsp[-2].typeref_list), make_typeref((yyvsp[0].type))); }
#line 5052 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 374:
#line 1053 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.typeref_list) = NULL; }
#line 5058 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 375:
#line 1054 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.typeref_list) = (yyvsp[0].typeref_list); }
#line 5064 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 376:
#line 1057 "tools/widl/parser.y" /* yacc.c:1646  */
    { if ((yyvsp[0].type)->type_type == TYPE_PARAMETERIZED_TYPE) push_parameters_namespace((yyvsp[0].type)->name); }
#line 5070 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 377:
#line 1059 "tools/widl/parser.y" /* yacc.c:1646  */
    { if ((yyvsp[-7].type)->type_type == TYPE_PARAMETERIZED_TYPE)
						  {
						      (yyval.type) = type_parameterized_interface_define((yyvsp[-7].type), (yyvsp[-8].attr_list), (yyvsp[-5].type), (yyvsp[-2].stmt_list), (yyvsp[-4].typeref_list));
						      pop_parameters_namespace((yyvsp[-7].type)->name);
						  }
						  else
						  {
						      (yyval.type) = type_interface_define((yyvsp[-7].type), (yyvsp[-8].attr_list), (yyvsp[-5].type), (yyvsp[-2].stmt_list), (yyvsp[-4].typeref_list));
						      check_async_uuid((yyval.type));
						  }
						}
#line 5086 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 378:
#line 1070 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = (yyvsp[-1].type); }
#line 5092 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 379:
#line 1074 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = get_type(TYPE_INTERFACE, (yyvsp[0].str), current_namespace, 0); }
#line 5098 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 380:
#line 1075 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = get_type(TYPE_INTERFACE, (yyvsp[0].str), (yyvsp[-1].namespace), 0); }
#line 5104 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 381:
#line 1079 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = get_type(TYPE_INTERFACE, (yyvsp[0].str), current_namespace, 0); }
#line 5110 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 382:
#line 1082 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = type_module_declare((yyvsp[0].str)); }
#line 5116 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 383:
#line 1086 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = type_module_define((yyvsp[-4].type), (yyvsp[-5].attr_list), (yyvsp[-2].stmt_list)); }
#line 5122 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 384:
#line 1090 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.stgclass) = STG_EXTERN; }
#line 5128 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 385:
#line 1091 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.stgclass) = STG_STATIC; }
#line 5134 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 386:
#line 1092 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.stgclass) = STG_REGISTER; }
#line 5140 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 387:
#line 1096 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.function_specifier) = FUNCTION_SPECIFIER_INLINE; }
#line 5146 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 388:
#line 1100 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type_qualifier) = TYPE_QUALIFIER_CONST; }
#line 5152 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 389:
#line 1103 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type_qualifier) = 0; }
#line 5158 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 390:
#line 1104 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type_qualifier) = (yyvsp[-1].type_qualifier) | (yyvsp[0].type_qualifier); }
#line 5164 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 391:
#line 1107 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.declspec) = make_decl_spec((yyvsp[-1].type), (yyvsp[0].declspec), NULL, STG_NONE, 0, 0); }
#line 5170 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 392:
#line 1109 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.declspec) = make_decl_spec((yyvsp[-1].type), (yyvsp[-2].declspec), (yyvsp[0].declspec), STG_NONE, 0, 0); }
#line 5176 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 393:
#line 1113 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.declspec) = make_decl_spec((yyvsp[-1].type), (yyvsp[0].declspec), NULL, STG_NONE, 0, 0); }
#line 5182 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 394:
#line 1115 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.declspec) = make_decl_spec((yyvsp[-1].type), (yyvsp[-2].declspec), (yyvsp[0].declspec), STG_NONE, 0, 0); }
#line 5188 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 395:
#line 1118 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.declspec) = NULL; }
#line 5194 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 397:
#line 1123 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.declspec) = make_decl_spec(NULL, (yyvsp[0].declspec), NULL, STG_NONE, (yyvsp[-1].type_qualifier), 0); }
#line 5200 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 398:
#line 1124 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.declspec) = make_decl_spec(NULL, (yyvsp[0].declspec), NULL, STG_NONE, 0, (yyvsp[-1].function_specifier)); }
#line 5206 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 399:
#line 1125 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.declspec) = make_decl_spec(NULL, (yyvsp[0].declspec), NULL, (yyvsp[-1].stgclass), 0, 0); }
#line 5212 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 400:
#line 1130 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.declarator) = (yyvsp[0].declarator); append_chain_type((yyval.declarator), type_new_pointer(NULL), (yyvsp[-1].type_qualifier)); }
#line 5218 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 401:
#line 1131 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.declarator) = (yyvsp[0].declarator); append_chain_callconv((yyval.declarator)->type, (yyvsp[-1].str)); }
#line 5224 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 403:
#line 1136 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.declarator) = make_declarator((yyvsp[0].var)); }
#line 5230 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 404:
#line 1137 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.declarator) = (yyvsp[-1].declarator); }
#line 5236 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 405:
#line 1138 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.declarator) = (yyvsp[-1].declarator); append_array((yyval.declarator), (yyvsp[0].expr)); }
#line 5242 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 406:
#line 1139 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.declarator) = (yyvsp[-3].declarator); append_chain_type((yyval.declarator), type_new_function((yyvsp[-1].var_list)), 0); }
#line 5248 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 407:
#line 1145 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.declarator) = (yyvsp[0].declarator); append_chain_type((yyval.declarator), type_new_pointer(NULL), (yyvsp[-1].type_qualifier)); }
#line 5254 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 408:
#line 1146 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.declarator) = (yyvsp[0].declarator); append_chain_callconv((yyval.declarator)->type, (yyvsp[-1].str)); }
#line 5260 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 410:
#line 1153 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.declarator) = (yyvsp[0].declarator); append_chain_type((yyval.declarator), type_new_pointer(NULL), (yyvsp[-1].type_qualifier)); }
#line 5266 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 411:
#line 1154 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.declarator) = (yyvsp[0].declarator); append_chain_callconv((yyval.declarator)->type, (yyvsp[-1].str)); }
#line 5272 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 412:
#line 1158 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.declarator) = make_declarator(NULL); }
#line 5278 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 414:
#line 1164 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.declarator) = (yyvsp[-1].declarator); }
#line 5284 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 415:
#line 1165 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.declarator) = (yyvsp[-1].declarator); append_array((yyval.declarator), (yyvsp[0].expr)); }
#line 5290 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 416:
#line 1166 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.declarator) = make_declarator(NULL); append_array((yyval.declarator), (yyvsp[0].expr)); }
#line 5296 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 417:
#line 1168 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.declarator) = make_declarator(NULL);
						  append_chain_type((yyval.declarator), type_new_function((yyvsp[-1].var_list)), 0);
						}
#line 5304 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 418:
#line 1172 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.declarator) = (yyvsp[-3].declarator);
						  append_chain_type((yyval.declarator), type_new_function((yyvsp[-1].var_list)), 0);
						}
#line 5312 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 419:
#line 1180 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.declarator) = (yyvsp[0].declarator); append_chain_type((yyval.declarator), type_new_pointer(NULL), (yyvsp[-1].type_qualifier)); }
#line 5318 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 420:
#line 1181 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.declarator) = (yyvsp[0].declarator); append_chain_callconv((yyval.declarator)->type, (yyvsp[-1].str)); }
#line 5324 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 422:
#line 1188 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.declarator) = (yyvsp[0].declarator); append_chain_type((yyval.declarator), type_new_pointer(NULL), (yyvsp[-1].type_qualifier)); }
#line 5330 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 423:
#line 1189 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.declarator) = (yyvsp[0].declarator); append_chain_callconv((yyval.declarator)->type, (yyvsp[-1].str)); }
#line 5336 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 424:
#line 1193 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.declarator) = make_declarator(NULL); }
#line 5342 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 426:
#line 1201 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.declarator) = make_declarator((yyvsp[0].var)); }
#line 5348 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 427:
#line 1202 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.declarator) = (yyvsp[-1].declarator); }
#line 5354 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 428:
#line 1203 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.declarator) = (yyvsp[-1].declarator); append_array((yyval.declarator), (yyvsp[0].expr)); }
#line 5360 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 429:
#line 1204 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.declarator) = make_declarator(NULL); append_array((yyval.declarator), (yyvsp[0].expr)); }
#line 5366 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 430:
#line 1206 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.declarator) = make_declarator(NULL);
						  append_chain_type((yyval.declarator), type_new_function((yyvsp[-1].var_list)), 0);
						}
#line 5374 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 431:
#line 1210 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.declarator) = (yyvsp[-3].declarator);
						  append_chain_type((yyval.declarator), type_new_function((yyvsp[-1].var_list)), 0);
						}
#line 5382 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 432:
#line 1216 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.declarator_list) = append_declarator( NULL, (yyvsp[0].declarator) ); }
#line 5388 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 433:
#line 1217 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.declarator_list) = append_declarator( (yyvsp[-2].declarator_list), (yyvsp[0].declarator) ); }
#line 5394 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 434:
#line 1220 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.expr) = NULL; }
#line 5400 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 435:
#line 1221 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.expr) = (yyvsp[0].expr); }
#line 5406 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 436:
#line 1224 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.declarator) = (yyvsp[-1].declarator); (yyval.declarator)->bits = (yyvsp[0].expr);
						  if (!(yyval.declarator)->bits && !(yyval.declarator)->var->name)
						    error_loc("unnamed fields are not allowed\n");
						}
#line 5415 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 437:
#line 1231 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.declarator_list) = append_declarator( NULL, (yyvsp[0].declarator) ); }
#line 5421 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 438:
#line 1233 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.declarator_list) = append_declarator( (yyvsp[-2].declarator_list), (yyvsp[0].declarator) ); }
#line 5427 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 439:
#line 1237 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.declarator) = (yyvsp[0].declarator); }
#line 5433 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 440:
#line 1238 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.declarator) = (yyvsp[-2].declarator); (yyvsp[-2].declarator)->var->eval = (yyvsp[0].expr); }
#line 5439 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 441:
#line 1242 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.num) = THREADING_APARTMENT; }
#line 5445 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 442:
#line 1243 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.num) = THREADING_NEUTRAL; }
#line 5451 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 443:
#line 1244 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.num) = THREADING_SINGLE; }
#line 5457 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 444:
#line 1245 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.num) = THREADING_FREE; }
#line 5463 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 445:
#line 1246 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.num) = THREADING_BOTH; }
#line 5469 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 446:
#line 1247 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.num) = THREADING_FREE; }
#line 5475 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 447:
#line 1251 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.num) = FC_RP; }
#line 5481 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 448:
#line 1252 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.num) = FC_UP; }
#line 5487 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 449:
#line 1253 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.num) = FC_FP; }
#line 5493 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 450:
#line 1256 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = type_new_struct((yyvsp[-3].str), current_namespace, TRUE, (yyvsp[-1].var_list)); }
#line 5499 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 451:
#line 1260 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = type_new_void(); }
#line 5505 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 452:
#line 1261 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = (yyvsp[0].type); }
#line 5511 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 453:
#line 1262 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = (yyvsp[0].type); }
#line 5517 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 454:
#line 1263 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = type_new_enum((yyvsp[0].str), current_namespace, FALSE, NULL); }
#line 5523 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 455:
#line 1264 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = (yyvsp[0].type); }
#line 5529 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 456:
#line 1265 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = type_new_struct((yyvsp[0].str), current_namespace, FALSE, NULL); }
#line 5535 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 457:
#line 1266 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = (yyvsp[0].type); }
#line 5541 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 458:
#line 1267 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = type_new_nonencapsulated_union((yyvsp[0].str), FALSE, NULL); }
#line 5547 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 459:
#line 1268 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = make_safearray((yyvsp[-1].type)); }
#line 5553 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 460:
#line 1269 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = find_type_or_error(current_namespace, (yyvsp[0].str)); }
#line 5559 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 462:
#line 1274 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = find_type_or_error((yyvsp[-1].namespace), (yyvsp[0].str)); }
#line 5565 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 463:
#line 1275 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = (yyvsp[0].type); }
#line 5571 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 464:
#line 1279 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyvsp[-4].attr_list) = append_attribs((yyvsp[-4].attr_list), (yyvsp[-2].attr_list));
						  reg_typedefs((yyvsp[-1].declspec), (yyvsp[0].declarator_list), check_typedef_attrs((yyvsp[-4].attr_list)));
						  (yyval.statement) = make_statement_typedef((yyvsp[0].declarator_list), !(yyvsp[-1].declspec)->type->defined);
						}
#line 5580 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 465:
#line 1286 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = type_new_nonencapsulated_union((yyvsp[-3].str), TRUE, (yyvsp[-1].var_list)); }
#line 5586 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 466:
#line 1289 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.type) = type_new_encapsulated_union((yyvsp[-8].str), (yyvsp[-5].var), (yyvsp[-3].var), (yyvsp[-1].var_list)); }
#line 5592 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 467:
#line 1293 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.num) = MAKEVERSION((yyvsp[0].num), 0); }
#line 5598 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 468:
#line 1294 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.num) = MAKEVERSION((yyvsp[-2].num), (yyvsp[0].num)); }
#line 5604 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 469:
#line 1295 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.num) = (yyvsp[0].num); }
#line 5610 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 474:
#line 1310 "tools/widl/parser.y" /* yacc.c:1646  */
    { type_t *type = find_type_or_error(current_namespace, (yyvsp[-1].str));
                                                  type->attrs = append_attr_list(type->attrs, (yyvsp[-2].attr_list));
                                                }
#line 5618 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 475:
#line 1317 "tools/widl/parser.y" /* yacc.c:1646  */
    {  type_t *iface = find_type_or_error(current_namespace, (yyvsp[-3].str));
                                                   if (type_get_type(iface) != TYPE_INTERFACE)
                                                       error_loc("%s is not an interface\n", iface->name);
                                                   iface->attrs = append_attr_list(iface->attrs, (yyvsp[-5].attr_list));
                                                }
#line 5628 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 476:
#line 1325 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr_list) = NULL; }
#line 5634 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 477:
#line 1326 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr_list) = (yyvsp[-1].attr_list); }
#line 5640 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 478:
#line 1330 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr_list) = append_attr(NULL, (yyvsp[0].attr)); }
#line 5646 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 479:
#line 1331 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr_list) = append_attr((yyvsp[-2].attr_list), (yyvsp[0].attr)); }
#line 5652 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 480:
#line 1336 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = make_attrv(ATTR_ALLOCATE, (yyvsp[-1].num)); }
#line 5658 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 481:
#line 1337 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = make_attr(ATTR_ENCODE); }
#line 5664 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 482:
#line 1338 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = make_attr(ATTR_DECODE); }
#line 5670 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 483:
#line 1339 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.attr) = make_attr(ATTR_EXPLICIT_HANDLE); }
#line 5676 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 484:
#line 1343 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.num) = (yyvsp[0].num); }
#line 5682 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 485:
#line 1345 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.num) = (yyvsp[-2].num) | (yyvsp[0].num); }
#line 5688 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 486:
#line 1349 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.num) = FC_DONT_FREE; }
#line 5694 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 487:
#line 1350 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.num) = 0; }
#line 5700 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 488:
#line 1351 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.num) = FC_ALLOCATE_ALL_NODES; }
#line 5706 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;

  case 489:
#line 1352 "tools/widl/parser.y" /* yacc.c:1646  */
    { (yyval.num) = 0; }
#line 5712 "tools/widl/parser.tab.c" /* yacc.c:1646  */
    break;


#line 5716 "tools/widl/parser.tab.c" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 1355 "tools/widl/parser.y" /* yacc.c:1906  */


static void decl_builtin_basic(const char *name, enum type_basic_type type)
{
  type_t *t = type_new_basic(type);
  reg_type(t, name, NULL, 0);
}

static void decl_builtin_alias(const char *name, type_t *t)
{
    const decl_spec_t ds = {.type = t};
    reg_type(type_new_alias(&ds, name), name, NULL, 0);
}

void init_types(void)
{
  decl_builtin_basic("byte", TYPE_BASIC_BYTE);
  decl_builtin_basic("wchar_t", TYPE_BASIC_WCHAR);
  decl_builtin_basic("float", TYPE_BASIC_FLOAT);
  decl_builtin_basic("double", TYPE_BASIC_DOUBLE);
  decl_builtin_basic("error_status_t", TYPE_BASIC_ERROR_STATUS_T);
  decl_builtin_basic("handle_t", TYPE_BASIC_HANDLE);
  decl_builtin_alias("boolean", type_new_basic(TYPE_BASIC_CHAR));
}

static str_list_t *append_str(str_list_t *list, char *str)
{
    struct str_list_entry_t *entry;

    if (!str) return list;
    if (!list)
    {
        list = xmalloc( sizeof(*list) );
        list_init( list );
    }
    entry = xmalloc( sizeof(*entry) );
    entry->str = str;
    list_add_tail( list, &entry->entry );
    return list;
}

static attr_list_t *move_attr(attr_list_t *dst, attr_list_t *src, enum attr_type type)
{
  attr_t *attr;
  if (!src) return dst;
  LIST_FOR_EACH_ENTRY(attr, src, attr_t, entry)
    if (attr->type == type)
    {
      list_remove(&attr->entry);
      return append_attr(dst, attr);
    }
  return dst;
}

static attr_list_t *append_attr_list(attr_list_t *new_list, attr_list_t *old_list)
{
  struct list *entry;

  if (!old_list) return new_list;

  while ((entry = list_head(old_list)))
  {
    attr_t *attr = LIST_ENTRY(entry, attr_t, entry);
    list_remove(entry);
    new_list = append_attr(new_list, attr);
  }
  return new_list;
}

typedef int (*map_attrs_filter_t)(attr_list_t*,const attr_t*);

static attr_list_t *map_attrs(const attr_list_t *list, map_attrs_filter_t filter)
{
  attr_list_t *new_list;
  const attr_t *attr;
  attr_t *new_attr;

  if (!list) return NULL;

  new_list = xmalloc( sizeof(*list) );
  list_init( new_list );
  LIST_FOR_EACH_ENTRY(attr, list, const attr_t, entry)
  {
    if (filter && !filter(new_list, attr)) continue;
    new_attr = xmalloc(sizeof(*new_attr));
    *new_attr = *attr;
    list_add_tail(new_list, &new_attr->entry);
  }
  return new_list;
}

static decl_spec_t *make_decl_spec(type_t *type, decl_spec_t *left, decl_spec_t *right,
        enum storage_class stgclass, enum type_qualifier qual, enum function_specifier func_specifier)
{
  decl_spec_t *declspec = left ? left : right;
  if (!declspec)
  {
    declspec = xmalloc(sizeof(*declspec));
    declspec->type = NULL;
    declspec->stgclass = STG_NONE;
    declspec->qualifier = 0;
    declspec->func_specifier = 0;
  }
  declspec->type = type;
  if (left && declspec != left)
  {
    if (declspec->stgclass == STG_NONE)
      declspec->stgclass = left->stgclass;
    else if (left->stgclass != STG_NONE)
      error_loc("only one storage class can be specified\n");
    declspec->qualifier |= left->qualifier;
    declspec->func_specifier |= left->func_specifier;
    assert(!left->type);
    free(left);
  }
  if (right && declspec != right)
  {
    if (declspec->stgclass == STG_NONE)
      declspec->stgclass = right->stgclass;
    else if (right->stgclass != STG_NONE)
      error_loc("only one storage class can be specified\n");
    declspec->qualifier |= right->qualifier;
    declspec->func_specifier |= right->func_specifier;
    assert(!right->type);
    free(right);
  }

  if (declspec->stgclass == STG_NONE)
    declspec->stgclass = stgclass;
  else if (stgclass != STG_NONE)
    error_loc("only one storage class can be specified\n");
  declspec->qualifier |= qual;
  declspec->func_specifier |= func_specifier;

  return declspec;
}

static attr_t *make_attr(enum attr_type type)
{
  attr_t *a = xmalloc(sizeof(attr_t));
  a->type = type;
  a->u.ival = 0;
  return a;
}

static attr_t *make_attrv(enum attr_type type, unsigned int val)
{
  attr_t *a = xmalloc(sizeof(attr_t));
  a->type = type;
  a->u.ival = val;
  return a;
}

attr_t *make_attrp(enum attr_type type, void *val)
{
  attr_t *a = xmalloc(sizeof(attr_t));
  a->type = type;
  a->u.pval = val;
  return a;
}

static attr_t *make_custom_attr(UUID *id, expr_t *pval)
{
  attr_t *a = xmalloc(sizeof(attr_t));
  attr_custdata_t *cstdata = xmalloc(sizeof(attr_custdata_t));
  a->type = ATTR_CUSTOM;
  cstdata->id = *id;
  cstdata->pval = pval;
  a->u.pval = cstdata;
  return a;
}

static expr_list_t *append_expr(expr_list_t *list, expr_t *expr)
{
    if (!expr) return list;
    if (!list)
    {
        list = xmalloc( sizeof(*list) );
        list_init( list );
    }
    list_add_tail( list, &expr->entry );
    return list;
}

static void append_array(declarator_t *decl, expr_t *expr)
{
    type_t *array;

    if (!expr)
        return;

    /* An array is always a reference pointer unless explicitly marked otherwise
     * (regardless of what the default pointer attribute is). */
    array = type_new_array(NULL, NULL, FALSE, expr->is_const ? expr->cval : 0,
            expr->is_const ? NULL : expr, NULL);

    append_chain_type(decl, array, 0);
}

static struct list type_pool = LIST_INIT(type_pool);
typedef struct
{
  type_t data;
  struct list link;
} type_pool_node_t;

type_t *alloc_type(void)
{
  type_pool_node_t *node = xmalloc(sizeof *node);
  list_add_tail(&type_pool, &node->link);
  return &node->data;
}

void set_all_tfswrite(int val)
{
  type_pool_node_t *node;
  LIST_FOR_EACH_ENTRY(node, &type_pool, type_pool_node_t, link)
    node->data.tfswrite = val;
}

void clear_all_offsets(void)
{
  type_pool_node_t *node;
  LIST_FOR_EACH_ENTRY(node, &type_pool, type_pool_node_t, link)
    node->data.typestring_offset = node->data.ptrdesc = 0;
}

static void type_function_add_head_arg(type_t *type, var_t *arg)
{
    if (!type->details.function->args)
    {
        type->details.function->args = xmalloc( sizeof(*type->details.function->args) );
        list_init( type->details.function->args );
    }
    list_add_head( type->details.function->args, &arg->entry );
}

static int is_allowed_range_type(const type_t *type)
{
    switch (type_get_type(type))
    {
    case TYPE_ENUM:
        return TRUE;
    case TYPE_BASIC:
        switch (type_basic_get_type(type))
        {
        case TYPE_BASIC_INT8:
        case TYPE_BASIC_INT16:
        case TYPE_BASIC_INT32:
        case TYPE_BASIC_INT64:
        case TYPE_BASIC_INT:
        case TYPE_BASIC_INT3264:
        case TYPE_BASIC_LONG:
        case TYPE_BASIC_BYTE:
        case TYPE_BASIC_CHAR:
        case TYPE_BASIC_WCHAR:
        case TYPE_BASIC_HYPER:
            return TRUE;
        case TYPE_BASIC_FLOAT:
        case TYPE_BASIC_DOUBLE:
        case TYPE_BASIC_ERROR_STATUS_T:
        case TYPE_BASIC_HANDLE:
            return FALSE;
        }
        return FALSE;
    default:
        return FALSE;
    }
}

static type_t *get_chain_ref(type_t *type)
{
    if (is_ptr(type))
        return type_pointer_get_ref_type(type);
    else if (is_array(type))
        return type_array_get_element_type(type);
    else if (is_func(type))
        return type_function_get_rettype(type);
    return NULL;
}

static type_t *get_chain_end(type_t *type)
{
    type_t *inner;
    while ((inner = get_chain_ref(type)))
        type = inner;
    return type;
}

static void append_chain_type(declarator_t *decl, type_t *type, enum type_qualifier qual)
{
    type_t *chain_type;

    if (!decl->type)
    {
        decl->type = type;
        decl->qualifier = qual;
        return;
    }
    chain_type = get_chain_end(decl->type);

    if (is_ptr(chain_type))
    {
        chain_type->details.pointer.ref.type = type;
        chain_type->details.pointer.ref.qualifier = qual;
    }
    else if (is_array(chain_type))
    {
        chain_type->details.array.elem.type = type;
        chain_type->details.array.elem.qualifier = qual;
    }
    else if (is_func(chain_type))
    {
        chain_type->details.function->retval->declspec.type = type;
        chain_type->details.function->retval->declspec.qualifier = qual;
    }
    else
        assert(0);

    if (!is_func(chain_type))
        type->attrs = move_attr(type->attrs, chain_type->attrs, ATTR_CALLCONV);
}

static void append_chain_callconv(type_t *chain, char *callconv)
{
    type_t *chain_end;

    if (chain && (chain_end = get_chain_end(chain)))
        chain_end->attrs = append_attr(chain_end->attrs, make_attrp(ATTR_CALLCONV, callconv));
    else
        error_loc("calling convention applied to non-function type\n");
}

static warning_list_t *append_warning(warning_list_t *list, int num)
{
    warning_t *entry;

    if(!list)
    {
        list = xmalloc( sizeof(*list) );
        list_init( list );
    }
    entry = xmalloc( sizeof(*entry) );
    entry->num = num;
    list_add_tail( list, &entry->entry );
    return list;
}

static var_t *declare_var(attr_list_t *attrs, decl_spec_t *decl_spec, declarator_t *decl,
                       int top)
{
  var_t *v = decl->var;
  expr_list_t *sizes = get_attrp(attrs, ATTR_SIZEIS);
  expr_list_t *lengs = get_attrp(attrs, ATTR_LENGTHIS);
  expr_t *dim;
  type_t **ptype;
  type_t *type = decl_spec->type;

  if (decl_spec->func_specifier & FUNCTION_SPECIFIER_INLINE)
  {
    if (!decl || !is_func(decl->type))
      error_loc("inline attribute applied to non-function type\n");
  }

  /* add type onto the end of the pointers in pident->type */
  append_chain_type(decl, type, decl_spec->qualifier);
  v->declspec = *decl_spec;
  v->declspec.type = decl->type;
  v->declspec.qualifier = decl->qualifier;
  v->attrs = attrs;
  v->declonly = !type->defined;

  if (is_attr(type->attrs, ATTR_CALLCONV) && !is_func(type))
    error_loc("calling convention applied to non-function type\n");

  /* check for pointer attribute being applied to non-pointer, non-array
   * type */
  if (!is_array(v->declspec.type))
  {
    int ptr_attr = get_attrv(v->attrs, ATTR_POINTERTYPE);
    const type_t *ptr = NULL;
    for (ptr = v->declspec.type; ptr && !ptr_attr; )
    {
      ptr_attr = get_attrv(ptr->attrs, ATTR_POINTERTYPE);
      if (!ptr_attr && type_is_alias(ptr))
        ptr = type_alias_get_aliasee_type(ptr);
      else
        break;
    }
    if (is_ptr(ptr))
    {
      if (ptr_attr && ptr_attr != FC_UP &&
          type_get_type(type_pointer_get_ref_type(ptr)) == TYPE_INTERFACE)
          warning_loc_info(&v->loc_info,
                           "%s: pointer attribute applied to interface "
                           "pointer type has no effect\n", v->name);
      if (!ptr_attr && top)
      {
        /* FIXME: this is a horrible hack to cope with the issue that we
         * store an offset to the typeformat string in the type object, but
         * two typeformat strings may be written depending on whether the
         * pointer is a toplevel parameter or not */
        v->declspec.type = duptype(v->declspec.type, 1);
      }
    }
    else if (ptr_attr)
       error_loc("%s: pointer attribute applied to non-pointer type\n", v->name);
  }

  if (is_attr(v->attrs, ATTR_STRING))
  {
    type_t *t = type;

    if (!is_ptr(v->declspec.type) && !is_array(v->declspec.type))
      error_loc("'%s': [string] attribute applied to non-pointer, non-array type\n",
                v->name);

    for (;;)
    {
        if (is_ptr(t))
            t = type_pointer_get_ref_type(t);
        else if (is_array(t))
            t = type_array_get_element_type(t);
        else
            break;
    }

    if (type_get_type(t) != TYPE_BASIC &&
        (get_basic_fc(t) != FC_CHAR &&
         get_basic_fc(t) != FC_BYTE &&
         get_basic_fc(t) != FC_WCHAR))
    {
      error_loc("'%s': [string] attribute is only valid on 'char', 'byte', or 'wchar_t' pointers and arrays\n",
                v->name);
    }
  }

  if (is_attr(v->attrs, ATTR_V1ENUM))
  {
    if (type_get_type_detect_alias(v->declspec.type) != TYPE_ENUM)
      error_loc("'%s': [v1_enum] attribute applied to non-enum type\n", v->name);
  }

  if (is_attr(v->attrs, ATTR_RANGE) && !is_allowed_range_type(v->declspec.type))
    error_loc("'%s': [range] attribute applied to non-integer type\n",
              v->name);

  ptype = &v->declspec.type;
  if (sizes) LIST_FOR_EACH_ENTRY(dim, sizes, expr_t, entry)
  {
    if (dim->type != EXPR_VOID)
    {
      if (is_array(*ptype))
      {
        if (!type_array_get_conformance(*ptype) ||
            type_array_get_conformance(*ptype)->type != EXPR_VOID)
          error_loc("%s: cannot specify size_is for an already sized array\n", v->name);
        else
          *ptype = type_new_array((*ptype)->name,
                                  type_array_get_element(*ptype), FALSE,
                                  0, dim, NULL);
      }
      else if (is_ptr(*ptype))
        *ptype = type_new_array((*ptype)->name, type_pointer_get_ref(*ptype), TRUE,
                                0, dim, NULL);
      else
        error_loc("%s: size_is attribute applied to illegal type\n", v->name);
    }

    if (is_ptr(*ptype))
      ptype = &(*ptype)->details.pointer.ref.type;
    else if (is_array(*ptype))
      ptype = &(*ptype)->details.array.elem.type;
    else
      error_loc("%s: too many expressions in size_is attribute\n", v->name);
  }

  ptype = &v->declspec.type;
  if (lengs) LIST_FOR_EACH_ENTRY(dim, lengs, expr_t, entry)
  {
    if (dim->type != EXPR_VOID)
    {
      if (is_array(*ptype))
      {
        *ptype = type_new_array((*ptype)->name,
                                type_array_get_element(*ptype),
                                type_array_is_decl_as_ptr(*ptype),
                                type_array_get_dim(*ptype),
                                type_array_get_conformance(*ptype), dim);
      }
      else
        error_loc("%s: length_is attribute applied to illegal type\n", v->name);
    }

    if (is_ptr(*ptype))
      ptype = &(*ptype)->details.pointer.ref.type;
    else if (is_array(*ptype))
      ptype = &(*ptype)->details.array.elem.type;
    else
      error_loc("%s: too many expressions in length_is attribute\n", v->name);
  }

  if (decl->bits)
    v->declspec.type = type_new_bitfield(v->declspec.type, decl->bits);

  return v;
}

static var_list_t *set_var_types(attr_list_t *attrs, decl_spec_t *decl_spec, declarator_list_t *decls)
{
  declarator_t *decl, *next;
  var_list_t *var_list = NULL;

  LIST_FOR_EACH_ENTRY_SAFE( decl, next, decls, declarator_t, entry )
  {
    var_t *var = declare_var(attrs, decl_spec, decl, 0);
    var_list = append_var(var_list, var);
    free(decl);
  }
  free(decl_spec);
  return var_list;
}

typeref_list_t *append_typeref(typeref_list_t *list, typeref_t *ref)
{
    if (!ref) return list;
    if (!list)
    {
        list = xmalloc( sizeof(*list) );
        list_init( list );
    }
    list_add_tail( list, &ref->entry );
    return list;
}

typeref_t *make_typeref(type_t *type)
{
    typeref_t *ref = xmalloc(sizeof(typeref_t));
    ref->type = type;
    ref->attrs = NULL;
    return ref;
}

var_list_t *append_var(var_list_t *list, var_t *var)
{
    if (!var) return list;
    if (!list)
    {
        list = xmalloc( sizeof(*list) );
        list_init( list );
    }
    list_add_tail( list, &var->entry );
    return list;
}

static var_list_t *append_var_list(var_list_t *list, var_list_t *vars)
{
    if (!vars) return list;
    if (!list)
    {
        list = xmalloc( sizeof(*list) );
        list_init( list );
    }
    list_move_tail( list, vars );
    return list;
}

var_t *make_var(char *name)
{
  var_t *v = xmalloc(sizeof(var_t));
  v->name = name;
  init_declspec(&v->declspec, NULL);
  v->attrs = NULL;
  v->eval = NULL;
  init_loc_info(&v->loc_info);
  v->declonly = FALSE;
  return v;
}

static var_t *copy_var(var_t *src, char *name, map_attrs_filter_t attr_filter)
{
  var_t *v = xmalloc(sizeof(var_t));
  v->name = name;
  v->declspec = src->declspec;
  v->attrs = map_attrs(src->attrs, attr_filter);
  v->eval = src->eval;
  v->loc_info = src->loc_info;
  return v;
}

static declarator_list_t *append_declarator(declarator_list_t *list, declarator_t *d)
{
  if (!d) return list;
  if (!list) {
    list = xmalloc(sizeof(*list));
    list_init(list);
  }
  list_add_tail(list, &d->entry);
  return list;
}

static declarator_t *make_declarator(var_t *var)
{
  declarator_t *d = xmalloc(sizeof(*d));
  d->var = var ? var : make_var(NULL);
  d->type = NULL;
  d->qualifier = 0;
  d->bits = NULL;
  return d;
}

static type_t *make_safearray(type_t *type)
{
    decl_spec_t ds = {.type = type};
    ds.type = type_new_alias(&ds, "SAFEARRAY");
    return type_new_array(NULL, &ds, TRUE, 0, NULL, NULL);
}

static typelib_t *make_library(const char *name, const attr_list_t *attrs)
{
    typelib_t *typelib = xmalloc(sizeof(*typelib));
    memset(typelib, 0, sizeof(*typelib));
    typelib->name = xstrdup(name);
    typelib->attrs = attrs;
    list_init( &typelib->importlibs );
    return typelib;
}

static int hash_ident(const char *name)
{
  const char *p = name;
  int sum = 0;
  /* a simple sum hash is probably good enough */
  while (*p) {
    sum += *p;
    p++;
  }
  return sum & (HASHMAX-1);
}

/***** type repository *****/

static struct namespace *find_sub_namespace(struct namespace *namespace, const char *name)
{
  struct namespace *cur;

  LIST_FOR_EACH_ENTRY(cur, &namespace->children, struct namespace, entry) {
    if(!strcmp(cur->name, name))
      return cur;
  }

  return NULL;
}

static void push_namespace(const char *name)
{
  struct namespace *namespace;

  namespace = find_sub_namespace(current_namespace, name);
  if(!namespace) {
    namespace = xmalloc(sizeof(*namespace));
    namespace->name = xstrdup(name);
    namespace->parent = current_namespace;
    list_add_tail(&current_namespace->children, &namespace->entry);
    list_init(&namespace->children);
    memset(namespace->type_hash, 0, sizeof(namespace->type_hash));
  }

  current_namespace = namespace;
}

static void pop_namespace(const char *name)
{
  assert(!strcmp(current_namespace->name, name) && current_namespace->parent);
  current_namespace = current_namespace->parent;
}

static void push_parameters_namespace(const char *name)
{
    struct namespace *namespace;

    if (!(namespace = find_sub_namespace(current_namespace, name)))
    {
        namespace = xmalloc(sizeof(*namespace));
        namespace->name = xstrdup(name);
        namespace->parent = current_namespace;
        list_add_tail(&current_namespace->children, &namespace->entry);
        list_init(&namespace->children);
        memset(namespace->type_hash, 0, sizeof(namespace->type_hash));
    }

    parameters_namespace = namespace;
}

static void pop_parameters_namespace(const char *name)
{
    assert(!strcmp(parameters_namespace->name, name) && parameters_namespace->parent);
    parameters_namespace = NULL;
}

struct rtype {
  const char *name;
  type_t *type;
  int t;
  struct rtype *next;
};

type_t *reg_type(type_t *type, const char *name, struct namespace *namespace, int t)
{
  struct rtype *nt;
  int hash;
  if (!name) {
    error_loc("registering named type without name\n");
    return type;
  }
  if (!namespace)
    namespace = &global_namespace;
  hash = hash_ident(name);
  nt = xmalloc(sizeof(struct rtype));
  nt->name = name;
  if (is_global_namespace(namespace))
  {
    type->c_name = name;
    type->qualified_name = name;
  }
  else
  {
    type->c_name = format_namespace(namespace, "__x_", "_C", name, use_abi_namespace ? "ABI" : NULL);
    type->qualified_name = format_namespace(namespace, "", "::", name, use_abi_namespace ? "ABI" : NULL);
  }
  nt->type = type;
  nt->t = t;
  nt->next = namespace->type_hash[hash];
  namespace->type_hash[hash] = nt;
  return type;
}

static type_t *reg_typedefs(decl_spec_t *decl_spec, declarator_list_t *decls, attr_list_t *attrs)
{
  declarator_t *decl;
  type_t *type = decl_spec->type;

  if (is_attr(attrs, ATTR_UUID) && !is_attr(attrs, ATTR_PUBLIC))
    attrs = append_attr( attrs, make_attr(ATTR_PUBLIC) );

  /* We must generate names for tagless enum, struct or union.
     Typedef-ing a tagless enum, struct or union means we want the typedef
     to be included in a library hence the public attribute.  */
  if (type_get_type_detect_alias(type) == TYPE_ENUM ||
      type_get_type_detect_alias(type) == TYPE_STRUCT ||
      type_get_type_detect_alias(type) == TYPE_UNION ||
      type_get_type_detect_alias(type) == TYPE_ENCAPSULATED_UNION)
  {
    if (!type->name)
    {
      type->name = gen_name();
      if (!is_attr(attrs, ATTR_PUBLIC))
        attrs = append_attr(attrs, make_attr(ATTR_PUBLIC));
    }

    /* replace existing attributes when generating a typelib */
    if (do_typelib)
        type->attrs = attrs;
  }

  LIST_FOR_EACH_ENTRY( decl, decls, declarator_t, entry )
  {

    if (decl->var->name) {
      type_t *cur;
      var_t *name;

      cur = find_type(decl->var->name, current_namespace, 0);

      /*
       * MIDL allows shadowing types that are declared in imported files.
       * We don't throw an error in this case and instead add a new type
       * (which is earlier on the list in hash table, so it will be used
       * instead of shadowed type).
       *
       * FIXME: We may consider string separated type tables for each input
       *        for cleaner solution.
       */
      if (cur && input_name == cur->loc_info.input_name)
          error_loc("%s: redefinition error; original definition was at %s:%d\n",
                    cur->name, cur->loc_info.input_name,
                    cur->loc_info.line_number);

      name = declare_var(attrs, decl_spec, decl, 0);
      cur = type_new_alias(&name->declspec, name->name);
      cur->attrs = attrs;

      reg_type(cur, cur->name, current_namespace, 0);
    }
  }
  return type;
}

type_t *find_type(const char *name, struct namespace *namespace, int t)
{
  struct rtype *cur;

  if(namespace && namespace != &global_namespace) {
    for(cur = namespace->type_hash[hash_ident(name)]; cur; cur = cur->next) {
      if(cur->t == t && !strcmp(cur->name, name))
        return cur->type;
    }
  }
  for(cur = global_namespace.type_hash[hash_ident(name)]; cur; cur = cur->next) {
    if(cur->t == t && !strcmp(cur->name, name))
      return cur->type;
  }
  return NULL;
}

static type_t *find_type_or_error(struct namespace *namespace, const char *name)
{
    type_t *type;
    if (!(type = find_type(name, namespace, 0)) &&
        !(type = find_type(name, parameters_namespace, 0)))
    {
        error_loc("type '%s' not found in %s namespace\n", name, namespace && namespace->name ? namespace->name : "global");
        return NULL;
    }
    return type;
}

static struct namespace *find_namespace_or_error(struct namespace *parent, const char *name)
{
    struct namespace *namespace = NULL;

    if (!winrt_mode)
        error_loc("namespaces are only supported in winrt mode.\n");
    else if (!(namespace = find_sub_namespace(parent, name)))
        error_loc("namespace '%s' not found in '%s'\n", name, parent->name);

    return namespace;
}

int is_type(const char *name)
{
    return find_type(name, current_namespace, 0) != NULL ||
           find_type(name, parameters_namespace, 0);
}

type_t *get_type(enum type_type type, char *name, struct namespace *namespace, int t)
{
  type_t *tp;
  if (!namespace)
    namespace = &global_namespace;
  if (name) {
    tp = find_type(name, namespace, t);
    if (tp) {
      free(name);
      return tp;
    }
  }
  tp = make_type(type);
  tp->name = name;
  tp->namespace = namespace;
  if (!name) return tp;
  return reg_type(tp, name, namespace, t);
}

/***** constant repository *****/

struct rconst {
  char *name;
  var_t *var;
  struct rconst *next;
};

struct rconst *const_hash[HASHMAX];

static var_t *reg_const(var_t *var)
{
  struct rconst *nc;
  int hash;
  if (!var->name) {
    error_loc("registering constant without name\n");
    return var;
  }
  hash = hash_ident(var->name);
  nc = xmalloc(sizeof(struct rconst));
  nc->name = var->name;
  nc->var = var;
  nc->next = const_hash[hash];
  const_hash[hash] = nc;
  return var;
}

var_t *find_const(const char *name, int f)
{
  struct rconst *cur = const_hash[hash_ident(name)];
  while (cur && strcmp(cur->name, name))
    cur = cur->next;
  if (!cur) {
    if (f) error_loc("constant '%s' not found\n", name);
    return NULL;
  }
  return cur->var;
}

char *gen_name(void)
{
  static unsigned long n = 0;
  static const char *file_id;

  if (! file_id)
  {
    char *dst = replace_extension( get_basename(input_idl_name), ".idl", "" );
    file_id = dst;

    for (; *dst; ++dst)
      if (! isalnum((unsigned char) *dst))
        *dst = '_';
  }
  return strmake("__WIDL_%s_generated_name_%08lX", file_id, n++);
}

struct allowed_attr
{
    unsigned int dce_compatible : 1;
    unsigned int acf : 1;
    unsigned int multiple : 1;

    unsigned int on_interface : 1;
    unsigned int on_function : 1;
    unsigned int on_arg : 1;
    unsigned int on_type : 1;
    unsigned int on_enum : 1;
    unsigned int on_enum_member : 1;
    unsigned int on_struct : 2;
    unsigned int on_union : 1;
    unsigned int on_field : 1;
    unsigned int on_library : 1;
    unsigned int on_dispinterface : 1;
    unsigned int on_module : 1;
    unsigned int on_coclass : 1;
    unsigned int on_apicontract : 1;
    unsigned int on_runtimeclass : 1;
    const char *display_name;
};

struct allowed_attr allowed_attr[] =
{
    /* attr                        { D ACF M   I Fn ARG T En Enm St Un Fi L  DI M  C AC  R  <display name> } */
    /* ATTR_ACTIVATABLE */         { 0, 0, 0,  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, "activatable" },
    /* ATTR_AGGREGATABLE */        { 0, 0, 0,  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, "aggregatable" },
    /* ATTR_ALLOCATE */            { 0, 1, 0,  0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "allocate" },
    /* ATTR_ANNOTATION */          { 0, 0, 0,  0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "annotation" },
    /* ATTR_APPOBJECT */           { 0, 0, 0,  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, "appobject" },
    /* ATTR_ASYNC */               { 0, 1, 0,  0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "async" },
    /* ATTR_ASYNCUUID */           { 1, 0, 0,  1, 0, 0, 1, 1, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, "async_uuid" },
    /* ATTR_AUTO_HANDLE */         { 1, 1, 0,  1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "auto_handle" },
    /* ATTR_BINDABLE */            { 0, 0, 0,  0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "bindable" },
    /* ATTR_BROADCAST */           { 1, 0, 0,  0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "broadcast" },
    /* ATTR_CALLAS */              { 0, 0, 0,  0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "call_as" },
    /* ATTR_CALLCONV */            { 0, 0, 0,  0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL },
    /* ATTR_CASE */                { 1, 0, 0,  0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, "case" },
    /* ATTR_CODE */                { 0, 1, 0,  1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "code" },
    /* ATTR_COMMSTATUS */          { 0, 0, 0,  0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "comm_status" },
    /* ATTR_CONTEXTHANDLE */       { 1, 0, 0,  0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "context_handle" },
    /* ATTR_CONTRACT */            { 0, 0, 0,  1, 1, 0, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 1, "contract" },
    /* ATTR_CONTRACTVERSION */     { 0, 0, 0,  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, "contractversion" },
    /* ATTR_CONTROL */             { 0, 0, 0,  0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 1, 0, 0, "control" },
    /* ATTR_CUSTOM */              { 0, 0, 1,  1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, "custom" },
    /* ATTR_DECODE */              { 0, 0, 0,  1, 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "decode" },
    /* ATTR_DEFAULT */             { 0, 0, 0,  1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1, 0, 0, 0, 0, "default" },
    /* ATTR_DEFAULTBIND */         { 0, 0, 0,  0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "defaultbind" },
    /* ATTR_DEFAULTCOLLELEM */     { 0, 0, 0,  0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "defaultcollelem" },
    /* ATTR_DEFAULTVALUE */        { 0, 0, 0,  0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "defaultvalue" },
    /* ATTR_DEFAULTVTABLE */       { 0, 0, 0,  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, "defaultvtable" },
 /* ATTR_DISABLECONSISTENCYCHECK */{ 0, 0, 0,  0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "disable_consistency_check" },
    /* ATTR_DISPINTERFACE */       { 0, 0, 0,  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL },
    /* ATTR_DISPLAYBIND */         { 0, 0, 0,  0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "displaybind" },
    /* ATTR_DLLNAME */             { 0, 0, 0,  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, "dllname" },
    /* ATTR_DUAL */                { 0, 0, 0,  1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "dual" },
    /* ATTR_ENABLEALLOCATE */      { 0, 0, 0,  1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "enable_allocate" },
    /* ATTR_ENCODE */              { 0, 0, 0,  1, 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "encode" },
    /* ATTR_ENDPOINT */            { 1, 0, 0,  1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "endpoint" },
    /* ATTR_ENTRY */               { 0, 0, 0,  0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "entry" },
    /* ATTR_EVENTADD */            { 0, 0, 0,  0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "eventadd" },
    /* ATTR_EVENTREMOVE */         { 0, 0, 0,  0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "eventremove" },
    /* ATTR_EXCLUSIVETO */         { 0, 0, 0,  1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "exclusive_to" },
    /* ATTR_EXPLICIT_HANDLE */     { 1, 1, 0,  1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "explicit_handle" },
    /* ATTR_FAULTSTATUS */         { 0, 0, 0,  0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "fault_status" },
    /* ATTR_FLAGS */               { 0, 0, 0,  0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "flags" },
    /* ATTR_FORCEALLOCATE */       { 0, 0, 0,  0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "force_allocate" },
    /* ATTR_HANDLE */              { 1, 0, 0,  0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "handle" },
    /* ATTR_HELPCONTEXT */         { 0, 0, 0,  1, 1, 0, 1, 1, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, "helpcontext" },
    /* ATTR_HELPFILE */            { 0, 0, 0,  0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, "helpfile" },
    /* ATTR_HELPSTRING */          { 0, 0, 0,  1, 1, 0, 1, 1, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, "helpstring" },
    /* ATTR_HELPSTRINGCONTEXT */   { 0, 0, 0,  1, 1, 0, 1, 1, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, "helpstringcontext" },
    /* ATTR_HELPSTRINGDLL */       { 0, 0, 0,  0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, "helpstringdll" },
    /* ATTR_HIDDEN */              { 0, 0, 0,  1, 1, 0, 1, 1, 1, 0, 0, 0, 1, 1, 1, 1, 0, 0, "hidden" },
    /* ATTR_ID */                  { 0, 0, 0,  0, 1, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, "id" },
    /* ATTR_IDEMPOTENT */          { 1, 0, 0,  0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "idempotent" },
    /* ATTR_IGNORE */              { 0, 0, 0,  0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, "ignore" },
    /* ATTR_IIDIS */               { 0, 0, 0,  0, 0, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, "iid_is" },
    /* ATTR_IMMEDIATEBIND */       { 0, 0, 0,  0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "immediatebind" },
    /* ATTR_IMPLICIT_HANDLE */     { 1, 1, 0,  1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "implicit_handle" },
    /* ATTR_IN */                  { 0, 0, 0,  0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "in" },
    /* ATTR_INPUTSYNC */           { 0, 0, 0,  0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "inputsync" },
    /* ATTR_LENGTHIS */            { 0, 0, 0,  0, 0, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, "length_is" },
    /* ATTR_LIBLCID */             { 0, 0, 0,  0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, "lcid" },
    /* ATTR_LICENSED */            { 0, 0, 0,  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, "licensed" },
    /* ATTR_LOCAL */               { 1, 0, 0,  1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "local" },
    /* ATTR_MARSHALING_BEHAVIOR */ { 0, 0, 0,  0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, "marshaling_behavior" },
    /* ATTR_MAYBE */               { 0, 0, 0,  0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "maybe" },
    /* ATTR_MESSAGE */             { 0, 0, 0,  0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "message" },
    /* ATTR_NOCODE */              { 0, 1, 0,  1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "nocode" },
    /* ATTR_NONBROWSABLE */        { 0, 0, 0,  0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "nonbrowsable" },
    /* ATTR_NONCREATABLE */        { 0, 0, 0,  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, "noncreatable" },
    /* ATTR_NONEXTENSIBLE */       { 0, 0, 0,  1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "nonextensible" },
    /* ATTR_NOTIFY */              { 0, 0, 0,  0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "notify" },
    /* ATTR_NOTIFYFLAG */          { 0, 0, 0,  0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "notify_flag" },
    /* ATTR_OBJECT */              { 0, 0, 0,  1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "object" },
    /* ATTR_ODL */                 { 0, 0, 0,  1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, "odl" },
    /* ATTR_OLEAUTOMATION */       { 0, 0, 0,  1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "oleautomation" },
    /* ATTR_OPTIMIZE */            { 0, 0, 0,  1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "optimize" },
    /* ATTR_OPTIONAL */            { 0, 0, 0,  0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "optional" },
    /* ATTR_OUT */                 { 1, 0, 0,  0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "out" },
    /* ATTR_PARAMLCID */           { 0, 0, 0,  0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "lcid" },
    /* ATTR_PARTIALIGNORE */       { 0, 0, 0,  0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "partial_ignore" },
    /* ATTR_POINTERDEFAULT */      { 1, 0, 0,  1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "pointer_default" },
    /* ATTR_POINTERTYPE */         { 1, 0, 0,  0, 0, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, "ref, unique or ptr" },
    /* ATTR_PROGID */              { 0, 0, 0,  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, "progid" },
    /* ATTR_PROPGET */             { 0, 0, 0,  0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "propget" },
    /* ATTR_PROPPUT */             { 0, 0, 0,  0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "propput" },
    /* ATTR_PROPPUTREF */          { 0, 0, 0,  0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "propputref" },
    /* ATTR_PROXY */               { 0, 0, 0,  1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "proxy" },
    /* ATTR_PUBLIC */              { 0, 0, 0,  0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "public" },
    /* ATTR_RANGE */               { 0, 0, 0,  0, 0, 1, 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, "range" },
    /* ATTR_READONLY */            { 0, 0, 0,  0, 0, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, "readonly" },
    /* ATTR_REPRESENTAS */         { 1, 0, 0,  0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "represent_as" },
    /* ATTR_REQUESTEDIT */         { 0, 0, 0,  0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "requestedit" },
    /* ATTR_RESTRICTED */          { 0, 0, 0,  1, 1, 0, 1, 1, 0, 1, 0, 0, 1, 1, 1, 1, 0, 0, "restricted" },
    /* ATTR_RETVAL */              { 0, 0, 0,  0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "retval" },
    /* ATTR_SIZEIS */              { 0, 0, 0,  0, 0, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, "size_is" },
    /* ATTR_SOURCE */              { 0, 0, 0,  1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, "source" },
    /* ATTR_STATIC */              { 0, 0, 1,  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, "static" },
    /* ATTR_STRICTCONTEXTHANDLE */ { 0, 0, 0,  1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "strict_context_handle" },
    /* ATTR_STRING */              { 1, 0, 0,  0, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, "string" },
    /* ATTR_SWITCHIS */            { 1, 0, 0,  0, 0, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, "switch_is" },
    /* ATTR_SWITCHTYPE */          { 1, 0, 0,  0, 0, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, "switch_type" },
    /* ATTR_THREADING */           { 0, 0, 0,  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1, "threading" },
    /* ATTR_TRANSMITAS */          { 1, 0, 0,  0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "transmit_as" },
    /* ATTR_UIDEFAULT */           { 0, 0, 0,  0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "uidefault" },
    /* ATTR_USESGETLASTERROR */    { 0, 0, 0,  0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "usesgetlasterror" },
    /* ATTR_USERMARSHAL */         { 0, 0, 0,  0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "user_marshal" },
    /* ATTR_UUID */                { 1, 0, 0,  1, 0, 0, 1, 1, 0, 1, 0, 0, 1, 1, 1, 1, 0, 1, "uuid" },
    /* ATTR_V1ENUM */              { 0, 0, 0,  0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "v1_enum" },
    /* ATTR_VARARG */              { 0, 0, 0,  0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "vararg" },
    /* ATTR_VERSION */             { 1, 0, 0,  1, 0, 0, 1, 1, 0, 2, 0, 0, 1, 0, 1, 1, 0, 1, "version" },
    /* ATTR_VIPROGID */            { 0, 0, 0,  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, "vi_progid" },
    /* ATTR_WIREMARSHAL */         { 1, 0, 0,  0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "wire_marshal" },
};

attr_list_t *append_attr(attr_list_t *list, attr_t *attr)
{
    attr_t *attr_existing;
    if (!attr) return list;
    if (!list)
    {
        list = xmalloc( sizeof(*list) );
        list_init( list );
    }
    if (!allowed_attr[attr->type].multiple)
    {
        LIST_FOR_EACH_ENTRY(attr_existing, list, attr_t, entry)
            if (attr_existing->type == attr->type)
            {
                parser_warning("duplicate attribute %s\n", get_attr_display_name(attr->type));
                /* use the last attribute, like MIDL does */
                list_remove(&attr_existing->entry);
                break;
            }
    }
    list_add_tail( list, &attr->entry );
    return list;
}

const char *get_attr_display_name(enum attr_type type)
{
    return allowed_attr[type].display_name;
}

attr_list_t *check_interface_attrs(const char *name, attr_list_t *attrs)
{
  const attr_t *attr;
  if (!attrs) return attrs;
  LIST_FOR_EACH_ENTRY(attr, attrs, const attr_t, entry)
  {
    if (!allowed_attr[attr->type].on_interface)
      error_loc("inapplicable attribute %s for interface %s\n",
                allowed_attr[attr->type].display_name, name);
    if (attr->type == ATTR_IMPLICIT_HANDLE)
    {
        const var_t *var = attr->u.pval;
        if (type_get_type( var->declspec.type) == TYPE_BASIC &&
            type_basic_get_type( var->declspec.type ) == TYPE_BASIC_HANDLE)
            continue;
        if (is_aliaschain_attr( var->declspec.type, ATTR_HANDLE ))
            continue;
      error_loc("attribute %s requires a handle type in interface %s\n",
                allowed_attr[attr->type].display_name, name);
    }
  }
  return attrs;
}

static attr_list_t *check_function_attrs(const char *name, attr_list_t *attrs)
{
  const attr_t *attr;
  if (!attrs) return attrs;
  LIST_FOR_EACH_ENTRY(attr, attrs, const attr_t, entry)
  {
    if (!allowed_attr[attr->type].on_function)
      error_loc("inapplicable attribute %s for function %s\n",
                allowed_attr[attr->type].display_name, name);
  }
  return attrs;
}

static void check_arg_attrs(const var_t *arg)
{
  const attr_t *attr;

  if (arg->attrs)
  {
    LIST_FOR_EACH_ENTRY(attr, arg->attrs, const attr_t, entry)
    {
      if (!allowed_attr[attr->type].on_arg)
        error_loc("inapplicable attribute %s for argument %s\n",
                  allowed_attr[attr->type].display_name, arg->name);
    }
  }
}

static attr_list_t *check_typedef_attrs(attr_list_t *attrs)
{
  const attr_t *attr;
  if (!attrs) return attrs;
  LIST_FOR_EACH_ENTRY(attr, attrs, const attr_t, entry)
  {
    if (!allowed_attr[attr->type].on_type)
      error_loc("inapplicable attribute %s for typedef\n",
                allowed_attr[attr->type].display_name);
  }
  return attrs;
}

static attr_list_t *check_enum_attrs(attr_list_t *attrs)
{
  const attr_t *attr;
  if (!attrs) return attrs;
  LIST_FOR_EACH_ENTRY(attr, attrs, const attr_t, entry)
  {
    if (!allowed_attr[attr->type].on_enum)
      error_loc("inapplicable attribute %s for enum\n",
                allowed_attr[attr->type].display_name);
  }
  return attrs;
}

static attr_list_t *check_enum_member_attrs(attr_list_t *attrs)
{
  const attr_t *attr;
  if (!attrs) return attrs;
  LIST_FOR_EACH_ENTRY(attr, attrs, const attr_t, entry)
  {
    if (!allowed_attr[attr->type].on_enum_member)
      error_loc("inapplicable attribute %s for enum member\n",
                allowed_attr[attr->type].display_name);
  }
  return attrs;
}

static attr_list_t *check_struct_attrs(attr_list_t *attrs)
{
  int mask = winrt_mode ? 3 : 1;
  const attr_t *attr;
  if (!attrs) return attrs;
  LIST_FOR_EACH_ENTRY(attr, attrs, const attr_t, entry)
  {
    if (!(allowed_attr[attr->type].on_struct & mask))
      error_loc("inapplicable attribute %s for struct\n",
                allowed_attr[attr->type].display_name);
  }
  return attrs;
}

static attr_list_t *check_union_attrs(attr_list_t *attrs)
{
  const attr_t *attr;
  if (!attrs) return attrs;
  LIST_FOR_EACH_ENTRY(attr, attrs, const attr_t, entry)
  {
    if (!allowed_attr[attr->type].on_union)
      error_loc("inapplicable attribute %s for union\n",
                allowed_attr[attr->type].display_name);
  }
  return attrs;
}

static attr_list_t *check_field_attrs(const char *name, attr_list_t *attrs)
{
  const attr_t *attr;
  if (!attrs) return attrs;
  LIST_FOR_EACH_ENTRY(attr, attrs, const attr_t, entry)
  {
    if (!allowed_attr[attr->type].on_field)
      error_loc("inapplicable attribute %s for field %s\n",
                allowed_attr[attr->type].display_name, name);
  }
  return attrs;
}

static attr_list_t *check_library_attrs(const char *name, attr_list_t *attrs)
{
  const attr_t *attr;
  if (!attrs) return attrs;
  LIST_FOR_EACH_ENTRY(attr, attrs, const attr_t, entry)
  {
    if (!allowed_attr[attr->type].on_library)
      error_loc("inapplicable attribute %s for library %s\n",
                allowed_attr[attr->type].display_name, name);
  }
  return attrs;
}

attr_list_t *check_dispiface_attrs(const char *name, attr_list_t *attrs)
{
  const attr_t *attr;
  if (!attrs) return attrs;
  LIST_FOR_EACH_ENTRY(attr, attrs, const attr_t, entry)
  {
    if (!allowed_attr[attr->type].on_dispinterface)
      error_loc("inapplicable attribute %s for dispinterface %s\n",
                allowed_attr[attr->type].display_name, name);
  }
  return attrs;
}

attr_list_t *check_module_attrs(const char *name, attr_list_t *attrs)
{
  const attr_t *attr;
  if (!attrs) return attrs;
  LIST_FOR_EACH_ENTRY(attr, attrs, const attr_t, entry)
  {
    if (!allowed_attr[attr->type].on_module)
      error_loc("inapplicable attribute %s for module %s\n",
                allowed_attr[attr->type].display_name, name);
  }
  return attrs;
}

attr_list_t *check_coclass_attrs(const char *name, attr_list_t *attrs)
{
  const attr_t *attr;
  if (!attrs) return attrs;
  LIST_FOR_EACH_ENTRY(attr, attrs, const attr_t, entry)
  {
    if (!allowed_attr[attr->type].on_coclass)
      error_loc("inapplicable attribute %s for coclass %s\n",
                allowed_attr[attr->type].display_name, name);
  }
  return attrs;
}

attr_list_t *check_runtimeclass_attrs(const char *name, attr_list_t *attrs)
{
    const attr_t *attr;
    if (!attrs) return attrs;
    LIST_FOR_EACH_ENTRY(attr, attrs, const attr_t, entry)
        if (!allowed_attr[attr->type].on_runtimeclass)
            error_loc("inapplicable attribute %s for runtimeclass %s\n",
                      allowed_attr[attr->type].display_name, name);
    return attrs;
}

attr_list_t *check_apicontract_attrs(const char *name, attr_list_t *attrs)
{
    const attr_t *attr;
    if (!attrs) return attrs;
    LIST_FOR_EACH_ENTRY(attr, attrs, const attr_t, entry)
        if (!allowed_attr[attr->type].on_apicontract)
            error_loc("inapplicable attribute %s for apicontract %s\n",
                      allowed_attr[attr->type].display_name, name);
    return attrs;
}

static int is_allowed_conf_type(const type_t *type)
{
    switch (type_get_type(type))
    {
    case TYPE_ENUM:
        return TRUE;
    case TYPE_BASIC:
        switch (type_basic_get_type(type))
        {
        case TYPE_BASIC_INT8:
        case TYPE_BASIC_INT16:
        case TYPE_BASIC_INT32:
        case TYPE_BASIC_INT64:
        case TYPE_BASIC_INT:
        case TYPE_BASIC_LONG:
        case TYPE_BASIC_CHAR:
        case TYPE_BASIC_HYPER:
        case TYPE_BASIC_BYTE:
        case TYPE_BASIC_WCHAR:
            return TRUE;
        default:
            return FALSE;
        }
    case TYPE_ALIAS:
        /* shouldn't get here because of type_get_type call above */
        assert(0);
        /* fall through */
    case TYPE_STRUCT:
    case TYPE_UNION:
    case TYPE_ENCAPSULATED_UNION:
    case TYPE_ARRAY:
    case TYPE_POINTER:
    case TYPE_VOID:
    case TYPE_MODULE:
    case TYPE_COCLASS:
    case TYPE_FUNCTION:
    case TYPE_INTERFACE:
    case TYPE_BITFIELD:
    case TYPE_RUNTIMECLASS:
    case TYPE_DELEGATE:
        return FALSE;
    case TYPE_APICONTRACT:
    case TYPE_PARAMETERIZED_TYPE:
    case TYPE_PARAMETER:
        /* not supposed to be here */
        assert(0);
        break;
    }
    return FALSE;
}

static int is_ptr_guid_type(const type_t *type)
{
    /* first, make sure it is a pointer to something */
    if (!is_ptr(type)) return FALSE;

    /* second, make sure it is a pointer to something of size sizeof(GUID),
     * i.e. 16 bytes */
    return (type_memsize(type_pointer_get_ref_type(type)) == 16);
}

static void check_conformance_expr_list(const char *attr_name, const var_t *arg, const type_t *container_type, expr_list_t *expr_list)
{
    expr_t *dim;
    struct expr_loc expr_loc;
    expr_loc.v = arg;
    expr_loc.attr = attr_name;
    if (expr_list) LIST_FOR_EACH_ENTRY(dim, expr_list, expr_t, entry)
    {
        if (dim->type != EXPR_VOID)
        {
            const type_t *expr_type = expr_resolve_type(&expr_loc, container_type, dim);
            if (!is_allowed_conf_type(expr_type))
                error_loc_info(&arg->loc_info, "expression must resolve to integral type <= 32bits for attribute %s\n",
                               attr_name);
        }
    }
}

static void check_remoting_fields(const var_t *var, type_t *type);

/* checks that properties common to fields and arguments are consistent */
static void check_field_common(const type_t *container_type,
                               const char *container_name, const var_t *arg)
{
    type_t *type = arg->declspec.type;
    int more_to_do;
    const char *container_type_name;
    const char *var_type;

    switch (type_get_type(container_type))
    {
    case TYPE_STRUCT:
        container_type_name = "struct";
        var_type = "field";
        break;
    case TYPE_UNION:
        container_type_name = "union";
        var_type = "arm";
        break;
    case TYPE_ENCAPSULATED_UNION:
        container_type_name = "encapsulated union";
        var_type = "arm";
        break;
    case TYPE_FUNCTION:
        container_type_name = "function";
        var_type = "parameter";
        break;
    default:
        /* should be no other container types */
        assert(0);
        return;
    }

    if (is_attr(arg->attrs, ATTR_LENGTHIS) &&
        (is_attr(arg->attrs, ATTR_STRING) || is_aliaschain_attr(arg->declspec.type, ATTR_STRING)))
        error_loc_info(&arg->loc_info,
                       "string and length_is specified for argument %s are mutually exclusive attributes\n",
                       arg->name);

    if (is_attr(arg->attrs, ATTR_SIZEIS))
    {
        expr_list_t *size_is_exprs = get_attrp(arg->attrs, ATTR_SIZEIS);
        check_conformance_expr_list("size_is", arg, container_type, size_is_exprs);
    }
    if (is_attr(arg->attrs, ATTR_LENGTHIS))
    {
        expr_list_t *length_is_exprs = get_attrp(arg->attrs, ATTR_LENGTHIS);
        check_conformance_expr_list("length_is", arg, container_type, length_is_exprs);
    }
    if (is_attr(arg->attrs, ATTR_IIDIS))
    {
        struct expr_loc expr_loc;
        expr_t *expr = get_attrp(arg->attrs, ATTR_IIDIS);
        if (expr->type != EXPR_VOID)
        {
            const type_t *expr_type;
            expr_loc.v = arg;
            expr_loc.attr = "iid_is";
            expr_type = expr_resolve_type(&expr_loc, container_type, expr);
            if (!expr_type || !is_ptr_guid_type(expr_type))
                error_loc_info(&arg->loc_info, "expression must resolve to pointer to GUID type for attribute iid_is\n");
        }
    }
    if (is_attr(arg->attrs, ATTR_SWITCHIS))
    {
        struct expr_loc expr_loc;
        expr_t *expr = get_attrp(arg->attrs, ATTR_SWITCHIS);
        if (expr->type != EXPR_VOID)
        {
            const type_t *expr_type;
            expr_loc.v = arg;
            expr_loc.attr = "switch_is";
            expr_type = expr_resolve_type(&expr_loc, container_type, expr);
            if (!expr_type || !is_allowed_conf_type(expr_type))
                error_loc_info(&arg->loc_info, "expression must resolve to integral type <= 32bits for attribute %s\n",
                               expr_loc.attr);
        }
    }

    do
    {
        more_to_do = FALSE;

        switch (typegen_detect_type(type, arg->attrs, TDT_IGNORE_STRINGS))
        {
        case TGT_STRUCT:
        case TGT_UNION:
            check_remoting_fields(arg, type);
            break;
        case TGT_INVALID:
        {
            const char *reason = "is invalid";
            switch (type_get_type(type))
            {
            case TYPE_VOID:
                reason = "cannot derive from void *";
                break;
            case TYPE_FUNCTION:
                reason = "cannot be a function pointer";
                break;
            case TYPE_BITFIELD:
                reason = "cannot be a bit-field";
                break;
            case TYPE_COCLASS:
                reason = "cannot be a class";
                break;
            case TYPE_INTERFACE:
                reason = "cannot be a non-pointer to an interface";
                break;
            case TYPE_MODULE:
                reason = "cannot be a module";
                break;
            default:
                break;
            }
            error_loc_info(&arg->loc_info, "%s \'%s\' of %s \'%s\' %s\n",
                           var_type, arg->name, container_type_name, container_name, reason);
            break;
        }
        case TGT_CTXT_HANDLE:
        case TGT_CTXT_HANDLE_POINTER:
            if (type_get_type(container_type) != TYPE_FUNCTION)
                error_loc_info(&arg->loc_info,
                               "%s \'%s\' of %s \'%s\' cannot be a context handle\n",
                               var_type, arg->name, container_type_name,
                               container_name);
            break;
        case TGT_STRING:
        {
            const type_t *t = type;
            while (is_ptr(t))
                t = type_pointer_get_ref_type(t);
            if (is_aliaschain_attr(t, ATTR_RANGE))
                warning_loc_info(&arg->loc_info, "%s: range not verified for a string of ranged types\n", arg->name);
            break;
        }
        case TGT_POINTER:
            type = type_pointer_get_ref_type(type);
            more_to_do = TRUE;
            break;
        case TGT_ARRAY:
            type = type_array_get_element_type(type);
            more_to_do = TRUE;
            break;
        case TGT_ENUM:
            type = type_get_real_type(type);
            if (!type_is_complete(type))
            {
                error_loc_info(&arg->loc_info, "undefined type declaration \"enum %s\"\n", type->name);
            }
        case TGT_USER_TYPE:
        case TGT_IFACE_POINTER:
        case TGT_BASIC:
        case TGT_RANGE:
            /* nothing to do */
            break;
        }
    } while (more_to_do);
}

static void check_remoting_fields(const var_t *var, type_t *type)
{
    const var_t *field;
    const var_list_t *fields = NULL;

    type = type_get_real_type(type);

    if (type->checked)
        return;

    type->checked = TRUE;

    if (type_get_type(type) == TYPE_STRUCT)
    {
        if (type_is_complete(type))
            fields = type_struct_get_fields(type);
        else
            error_loc_info(&var->loc_info, "undefined type declaration \"struct %s\"\n", type->name);
    }
    else if (type_get_type(type) == TYPE_UNION || type_get_type(type) == TYPE_ENCAPSULATED_UNION)
    {
        if (type_is_complete(type))
            fields = type_union_get_cases(type);
        else
            error_loc_info(&var->loc_info, "undefined type declaration \"union %s\"\n", type->name);
    }

    if (fields) LIST_FOR_EACH_ENTRY( field, fields, const var_t, entry )
        if (field->declspec.type) check_field_common(type, type->name, field);
}

/* checks that arguments for a function make sense for marshalling and unmarshalling */
static void check_remoting_args(const var_t *func)
{
    const char *funcname = func->name;
    const var_t *arg;

    if (!type_function_get_args(func->declspec.type))
        return;

    LIST_FOR_EACH_ENTRY( arg, type_function_get_args(func->declspec.type), const var_t, entry )
    {
        const type_t *type = arg->declspec.type;

        /* check that [out] parameters have enough pointer levels */
        if (is_attr(arg->attrs, ATTR_OUT))
        {
            switch (typegen_detect_type(type, arg->attrs, TDT_ALL_TYPES))
            {
            case TGT_BASIC:
            case TGT_ENUM:
            case TGT_RANGE:
            case TGT_STRUCT:
            case TGT_UNION:
            case TGT_CTXT_HANDLE:
            case TGT_USER_TYPE:
                error_loc_info(&arg->loc_info, "out parameter \'%s\' of function \'%s\' is not a pointer\n", arg->name, funcname);
                break;
            case TGT_IFACE_POINTER:
                error_loc_info(&arg->loc_info, "out interface pointer \'%s\' of function \'%s\' is not a double pointer\n", arg->name, funcname);
                break;
            case TGT_STRING:
                if (is_array(type))
                {
                    /* needs conformance or fixed dimension */
                    if (type_array_has_conformance(type) &&
                        type_array_get_conformance(type)->type != EXPR_VOID) break;
                    if (!type_array_has_conformance(type) && type_array_get_dim(type)) break;
                }
                if (is_attr( arg->attrs, ATTR_IN )) break;
                error_loc_info(&arg->loc_info, "out parameter \'%s\' of function \'%s\' cannot be an unsized string\n", arg->name, funcname);
                break;
            case TGT_INVALID:
                /* already error'd before we get here */
            case TGT_CTXT_HANDLE_POINTER:
            case TGT_POINTER:
            case TGT_ARRAY:
                /* OK */
                break;
            }
        }

        check_field_common(func->declspec.type, funcname, arg);
    }

    if (type_get_type(type_function_get_rettype(func->declspec.type)) != TYPE_VOID)
    {
        var_t var;
        var = *func;
        var.declspec.type = type_function_get_rettype(func->declspec.type);
        var.name = xstrdup("return value");
        check_field_common(func->declspec.type, funcname, &var);
        free(var.name);
    }
}

static void add_explicit_handle_if_necessary(const type_t *iface, var_t *func)
{
    unsigned char explicit_fc, implicit_fc;

    /* check for a defined binding handle */
    if (!get_func_handle_var( iface, func, &explicit_fc, &implicit_fc ) || !explicit_fc)
    {
        /* no explicit handle specified so add
         * "[in] handle_t IDL_handle" as the first parameter to the
         * function */
        var_t *idl_handle = make_var(xstrdup("IDL_handle"));
        idl_handle->attrs = append_attr(NULL, make_attr(ATTR_IN));
        idl_handle->declspec.type = find_type_or_error(NULL, "handle_t");
        type_function_add_head_arg(func->declspec.type, idl_handle);
    }
}

static void check_functions(const type_t *iface, int is_inside_library)
{
    const statement_t *stmt;
    /* check for duplicates */
    if (is_attr(iface->attrs, ATTR_DISPINTERFACE))
    {
        var_list_t *methods = type_dispiface_get_methods(iface);
        var_t *func, *func_iter;

        if (methods) LIST_FOR_EACH_ENTRY( func, methods, var_t, entry )
        {
            LIST_FOR_EACH_ENTRY( func_iter, methods, var_t, entry )
            {
                if (func == func_iter) break;
                if (strcmp(func->name, func_iter->name)) continue;
                if (is_attr(func->attrs, ATTR_EVENTADD) != is_attr(func_iter->attrs, ATTR_EVENTADD)) continue;
                if (is_attr(func->attrs, ATTR_EVENTREMOVE) != is_attr(func_iter->attrs, ATTR_EVENTREMOVE)) continue;
                if (is_attr(func->attrs, ATTR_PROPGET) != is_attr(func_iter->attrs, ATTR_PROPGET)) continue;
                if (is_attr(func->attrs, ATTR_PROPPUT) != is_attr(func_iter->attrs, ATTR_PROPPUT)) continue;
                if (is_attr(func->attrs, ATTR_PROPPUTREF) != is_attr(func_iter->attrs, ATTR_PROPPUTREF)) continue;
                error_loc_info(&func->loc_info, "duplicated function \'%s\'\n", func->name);
            }
        }
    }
    if (is_attr(iface->attrs, ATTR_EXPLICIT_HANDLE))
    {
        STATEMENTS_FOR_EACH_FUNC( stmt, type_iface_get_stmts(iface) )
        {
            var_t *func = stmt->u.var;
            add_explicit_handle_if_necessary(iface, func);
        }
    }
    if (!is_inside_library && !is_attr(iface->attrs, ATTR_LOCAL))
    {
        STATEMENTS_FOR_EACH_FUNC( stmt, type_iface_get_stmts(iface) )
        {
            const var_t *func = stmt->u.var;
            if (!is_attr(func->attrs, ATTR_LOCAL))
                check_remoting_args(func);
        }
    }
}

static int async_iface_attrs(attr_list_t *attrs, const attr_t *attr)
{
    switch(attr->type)
    {
    case ATTR_UUID:
        return 0;
    case ATTR_ASYNCUUID:
        append_attr(attrs, make_attrp(ATTR_UUID, attr->u.pval));
        return 0;
    default:
        return 1;
    }
}

static int arg_in_attrs(attr_list_t *attrs, const attr_t *attr)
{
    return attr->type != ATTR_OUT && attr->type != ATTR_RETVAL;
}

static int arg_out_attrs(attr_list_t *attrs, const attr_t *attr)
{
    return attr->type != ATTR_IN;
}

static void check_async_uuid(type_t *iface)
{
    statement_list_t *stmts = NULL;
    statement_t *stmt;
    type_t *async_iface;
    type_t *inherit;

    if (!is_attr(iface->attrs, ATTR_ASYNCUUID)) return;

    inherit = type_iface_get_inherit(iface);
    if (inherit && strcmp(inherit->name, "IUnknown"))
        inherit = type_iface_get_async_iface(inherit);
    if (!inherit)
        error_loc("async_uuid applied to an interface with incompatible parent\n");

    async_iface = type_interface_declare(strmake("Async%s", iface->name), iface->namespace);

    STATEMENTS_FOR_EACH_FUNC( stmt, type_iface_get_stmts(iface) )
    {
        var_t *begin_func, *finish_func, *func = stmt->u.var, *arg;
        var_list_t *begin_args = NULL, *finish_args = NULL, *args;

        if (is_attr(func->attrs, ATTR_CALLAS)) continue;

        args = type_function_get_args(func->declspec.type);
        if (args) LIST_FOR_EACH_ENTRY(arg, args, var_t, entry)
        {
            if (is_attr(arg->attrs, ATTR_IN) || !is_attr(arg->attrs, ATTR_OUT))
                begin_args = append_var(begin_args, copy_var(arg, strdup(arg->name), arg_in_attrs));
            if (is_attr(arg->attrs, ATTR_OUT))
                finish_args = append_var(finish_args, copy_var(arg, strdup(arg->name), arg_out_attrs));
        }

        begin_func = copy_var(func, strmake("Begin_%s", func->name), NULL);
        begin_func->declspec.type = type_new_function(begin_args);
        begin_func->declspec.type->attrs = func->attrs;
        begin_func->declspec.type->details.function->retval = func->declspec.type->details.function->retval;
        stmts = append_statement(stmts, make_statement_declaration(begin_func));

        finish_func = copy_var(func, strmake("Finish_%s", func->name), NULL);
        finish_func->declspec.type = type_new_function(finish_args);
        finish_func->declspec.type->attrs = func->attrs;
        finish_func->declspec.type->details.function->retval = func->declspec.type->details.function->retval;
        stmts = append_statement(stmts, make_statement_declaration(finish_func));
    }

    type_interface_define(async_iface, map_attrs(iface->attrs, async_iface_attrs), inherit, stmts, NULL);
    iface->details.iface->async_iface = async_iface->details.iface->async_iface = async_iface;
}

static statement_list_t *append_parameterized_type_stmts(statement_list_t *stmts)
{
    statement_t *stmt, *next;

    if (stmts && parameterized_type_stmts) LIST_FOR_EACH_ENTRY_SAFE(stmt, next, parameterized_type_stmts, statement_t, entry)
    {
        switch(stmt->type)
        {
        case STMT_TYPE:
            stmt->u.type = type_parameterized_type_specialize_define(stmt->u.type);
            stmt->declonly = FALSE;
            list_remove(&stmt->entry);
            stmts = append_statement(stmts, stmt);
            break;
        default:
            assert(0); /* should not be there */
            break;
        }
    }

    return stmts;
}

static void check_statements(const statement_list_t *stmts, int is_inside_library)
{
    const statement_t *stmt;

    if (stmts) LIST_FOR_EACH_ENTRY(stmt, stmts, const statement_t, entry)
    {
        switch(stmt->type) {
        case STMT_LIBRARY:
            check_statements(stmt->u.lib->stmts, TRUE);
            break;
        case STMT_TYPE:
            switch(type_get_type(stmt->u.type)) {
            case TYPE_INTERFACE:
                check_functions(stmt->u.type, is_inside_library);
                break;
            case TYPE_COCLASS:
                if(winrt_mode)
                    error_loc("coclass is not allowed in Windows Runtime mode\n");
                break;
            default:
                break;
            }
            break;
        default:
            break;
        }
    }
}

static void check_all_user_types(const statement_list_t *stmts)
{
  const statement_t *stmt;
  const var_t *v;

  if (stmts) LIST_FOR_EACH_ENTRY(stmt, stmts, const statement_t, entry)
  {
    if (stmt->type == STMT_LIBRARY)
      check_all_user_types(stmt->u.lib->stmts);
    else if (stmt->type == STMT_TYPE && type_get_type(stmt->u.type) == TYPE_INTERFACE &&
             !is_local(stmt->u.type->attrs))
    {
      const statement_t *stmt_func;
      STATEMENTS_FOR_EACH_FUNC(stmt_func, type_iface_get_stmts(stmt->u.type)) {
        const var_t *func = stmt_func->u.var;
        if (type_function_get_args(func->declspec.type))
          LIST_FOR_EACH_ENTRY( v, type_function_get_args(func->declspec.type), const var_t, entry )
            check_for_additional_prototype_types(v->declspec.type);
        check_for_additional_prototype_types(type_function_get_rettype(func->declspec.type));
      }
    }
  }
}

int is_valid_uuid(const char *s)
{
  int i;

  for (i = 0; i < 36; ++i)
    if (i == 8 || i == 13 || i == 18 || i == 23)
    {
      if (s[i] != '-')
        return FALSE;
    }
    else
      if (!isxdigit(s[i]))
        return FALSE;

  return s[i] == '\0';
}

static statement_t *make_statement(enum statement_type type)
{
    statement_t *stmt = xmalloc(sizeof(*stmt));
    stmt->type = type;
    return stmt;
}

static statement_t *make_statement_type_decl(type_t *type)
{
    statement_t *stmt = make_statement(STMT_TYPE);
    stmt->u.type = type;
    stmt->declonly = !type->defined;
    return stmt;
}

static statement_t *make_statement_reference(type_t *type)
{
    statement_t *stmt = make_statement(STMT_TYPEREF);
    stmt->u.type = type;
    return stmt;
}

static statement_t *make_statement_declaration(var_t *var)
{
    statement_t *stmt = make_statement(STMT_DECLARATION);
    stmt->u.var = var;
    if (var->declspec.stgclass == STG_EXTERN && var->eval)
        warning("'%s' initialised and declared extern\n", var->name);
    if (is_const_decl(var))
    {
        if (var->eval)
            reg_const(var);
    }
    else if (type_get_type(var->declspec.type) == TYPE_FUNCTION)
        check_function_attrs(var->name, var->attrs);
    else if (var->declspec.stgclass == STG_NONE || var->declspec.stgclass == STG_REGISTER)
        error_loc("instantiation of data is illegal\n");
    return stmt;
}

static statement_t *make_statement_library(typelib_t *typelib)
{
    statement_t *stmt = make_statement(STMT_LIBRARY);
    stmt->u.lib = typelib;
    return stmt;
}

static statement_t *make_statement_pragma(const char *str)
{
    statement_t *stmt = make_statement(STMT_PRAGMA);
    stmt->u.str = str;
    return stmt;
}

static statement_t *make_statement_cppquote(const char *str)
{
    statement_t *stmt = make_statement(STMT_CPPQUOTE);
    stmt->u.str = str;
    return stmt;
}

static statement_t *make_statement_importlib(const char *str)
{
    statement_t *stmt = make_statement(STMT_IMPORTLIB);
    stmt->u.str = str;
    return stmt;
}

static statement_t *make_statement_import(const char *str)
{
    statement_t *stmt = make_statement(STMT_IMPORT);
    stmt->u.str = str;
    return stmt;
}

static statement_t *make_statement_module(type_t *type)
{
    statement_t *stmt = make_statement(STMT_MODULE);
    stmt->u.type = type;
    return stmt;
}

static statement_t *make_statement_typedef(declarator_list_t *decls, int declonly)
{
    declarator_t *decl, *next;
    statement_t *stmt;

    if (!decls) return NULL;

    stmt = make_statement(STMT_TYPEDEF);
    stmt->u.type_list = NULL;
    stmt->declonly = declonly;

    LIST_FOR_EACH_ENTRY_SAFE( decl, next, decls, declarator_t, entry )
    {
        var_t *var = decl->var;
        type_t *type = find_type_or_error(current_namespace, var->name);
        stmt->u.type_list = append_typeref(stmt->u.type_list, make_typeref(type));
        free(decl);
        free(var);
    }

    return stmt;
}

static statement_t *make_statement_parameterized_type(type_t *type, typeref_list_t *params)
{
    statement_t *stmt = make_statement(STMT_TYPE);
    stmt->u.type = type_parameterized_type_specialize_partial(type, params);
    return stmt;
}

static statement_t *make_statement_delegate(type_t *ret, var_list_t *args)
{
    declarator_t *decl = make_declarator(make_var(xstrdup("Invoke")));
    decl_spec_t *spec = make_decl_spec(ret, NULL, NULL, STG_NONE, 0, 0);
    append_chain_type(decl, type_new_function(args), 0);
    return make_statement_declaration(declare_var(NULL, spec, decl, FALSE));
}

static statement_list_t *append_statements(statement_list_t *l1, statement_list_t *l2)
{
    if (!l2) return l1;
    if (!l1 || l1 == l2) return l2;
    list_move_tail (l1, l2);
    return l1;
}

static attr_list_t *append_attribs(attr_list_t *l1, attr_list_t *l2)
{
    if (!l2) return l1;
    if (!l1 || l1 == l2) return l2;
    list_move_tail (l1, l2);
    return l1;
}

static statement_list_t *append_statement(statement_list_t *list, statement_t *stmt)
{
    if (!stmt) return list;
    if (!list)
    {
        list = xmalloc( sizeof(*list) );
        list_init( list );
    }
    list_add_tail( list, &stmt->entry );
    return list;
}

void init_loc_info(loc_info_t *i)
{
    i->input_name = input_name ? input_name : "stdin";
    i->line_number = line_number;
    i->near_text = parser_text;
}

type_t *find_parameterized_type(type_t *type, typeref_list_t *params)
{
    char *name = format_parameterized_type_name(type, params);

    if (parameters_namespace)
    {
        assert(type->type_type == TYPE_PARAMETERIZED_TYPE);
        type = type_parameterized_type_specialize_partial(type, params);
    }
    else if ((type = find_type(name, type->namespace, 0)))
        assert(type->type_type != TYPE_PARAMETERIZED_TYPE);
    else
        error_loc("parameterized type '%s' not declared\n", name);

    free(name);
    return type;
}
